<?php

class goods extends bhCommon {

    public function __construct()
    {
        parent::__construct();
    }


    /**
     *
     */
    public function category()
    {
        $category = p_getall('category', array('is_delete' => 1), array(), '', 'sort desc');

        $data = array(
            'category' => array_merge(array(0 => array('name' => '全部商品', 'id' => 0)), $category),
            'images' => array(
                'share' => $this->image_url . '018151426.png',
                'address' => $this->image_url . 'address.png',
                'card' => $this->image_url . 'card.png',
                'pay' => $this->image_url . 'pay.png'
            )
        );



        $this->json($data, 1, false);
    }


    /**
     *
     */
    public function goods()
    {
        $category_id = $this->get('category_id');
        $where = array(
            'status' => 1,
            'is_delete' => 1
        );

        if ($category_id) {
            $where['category_id'] = $category_id;
        }

        $goods = p_getall('goods', $where, array(), '', 'sort desc,id desc');
        if (!empty($goods)) {
            foreach ($goods as & $value) {
                $value['cover_image'] = getImage($value['cover_image']);
            }
        }

        $this->json(compact('goods'));
    }


    /**
     *
     */
    public function search()
    {
        $search = $this->get('search');
        if (empty($search)) {
            $this->json(array('goods' => array()));
        }

        $sql = "SELECT * FROM " . prefix('goods') . " WHERE status=1 AND is_delete=1 AND name LIKE '%{$search}%'".get_uniacid()." ORDER BY sort desc,id desc";

        $goods = p_fetchall($sql);
        if (!empty($goods)) {
            foreach ($goods as & $value) {
                $value['cover_image'] = getImage($value['cover_image']);
            }
        }

        $this->json(compact('goods'));
    }


    /**
     *
     */
    public function details()
    {
        $goods_id = intval($this->get('id'));

        $where = array(
            'id' => $goods_id,
            'status' => 1,
            'is_delete' => 1
        );

        if (!$goods = p_get('goods', $where)) {
            json('商品不存在或者已下架', 0);
        }
        if ($goods['images']) {
            $goods['images'] = json_decode($goods['images'], true);
            $goods['images'] = array_map('getImage', $goods['images']);
        }
        $goods['cover_image'] = getImage($goods['cover_image']);

        $data = array(
            'goods' => $goods
        );

        $this->json($data);
    }


}