<?php
/**
 * Created by PhpStorm.
 * User: 51382
 * Date: 2019/7/26
 * Time: 10:17
 */

class manger extends WeModuleSite
{

    public $gpc;
    public $w;
    public $style_path = '';
    public $member = '';

    public $pageSize = 10;


    protected $examine_status = array(
        1 => '审核中',
        2 => '审核通过',
        3 => '审核不通过',
    );

    protected $status = array(
        1 => '未发货',
        2 => '已发货',
        3 => '已完成',
        4 => '已取消',
        5 => '已退款',
    );
    /**
     * 1 业务员 2 商家
     * @var string
     */
    protected $userType = '';

    public function __construct()
    {
        global $_W;
        global $_GPC;
        $this->gpc = $_GPC;
        $this->w = $_W;
        $this->style_path = $this->w['siteroot'] . 'addons/bh_vote/template/assets/';
    }
    public function doMobileIndex()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $userType = $this->get('userType');
        include $this->template('index');
    }
    public function doMobileShop()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $userType = $this->get('userType');
        $where  = "salesman_id = {$this->member['id']} ".get_uniacid();
        $shop = $this->getTableList('shop',$page, $where);
        include $this->template('shop');
    }

    public function doMobileRemove()
    {
        $column = $this->get('column');
        $type = $this->get('type',1);
        $id = $this->get('id');
        $userType = $this->get('userType');
        if ($type ==1 ) {
            $bool =  p_update($column, array('is_delete' =>2), array('id' => $id));
        } else {
            $bool = p_delete($column, array('id' => $id));
        }
        message($bool ? '操作成功': '操作失败', $this->createMobileUrl($column , array('userType' => $userType ? $userType : $this->userType)), $bool ? 'success' : 'error');
    }
    public function doMobileHandleShop()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $userType = $this->get('userType');
        $behavior = $this->get('behavior');
        if ($behavior == 'add' || $behavior == 'edit') {
            $data  = array(
                    'shop_name'   => $this->get('shop_name'),
                    'phone'       => $this->get('phone'),
                    'address'     => $this->get('address'),
                    'pwd'         => $this->get('pwd'),
                    'is_examine'  => $this->get('is_examine'),
                    'share_text'  => $this->get('share_text'),
                    'share_img'  => $this->get('share_img'),
                    'shop_cover'  => $this->get('shop_cover'),
                    'ball_image'  => $this->get('ball_image'),
            );

            $id = $this->get('id');
            if (!$id) {
                $data['created'] = time();
                $data['salesman_id'] = $this->member['id'];
            }
           /* if (strlen($data['pwd']) != 32) {
                if (strlen($data['pwd']) < 6 || strlen($data['pwd']) > 18) {
                    message('登录密码在8-16位之间', $this->createMobileUrl('shop'), 'error');
                }
                $data['pwd'] = md5($data['pwd']);
            }*/
            $bool = $id ? p_update('shop', $data, array('id' => $id)) : p_insert('shop', $data);
            message($bool ? '操作成功': '操作失败', $this->createMobileUrl('shop', array('userType' => $this->userType)), $bool ? 'success' : 'error');
        } elseif($behavior == 'editShow') {
            $id = $this->get('id');
            $shop = p_get('shop', array('id' => $id));
            include $this->template('shop_add');
        } else {
            include $this->template('shop_add');
        }

    }

    public function doMobileShopBank()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $userType = $this->get('userType');
        $user  = $userType == 1 ? 2 :1;
        $where  = "relation_id = {$this->member['id']} AND type = {$user} " .get_uniacid();
        $shopBank = $this->getTableList('shop_bank',$page, $where);
        include $this->template('shopBank');

    }
    public function doMobileShopBankHandle()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $behavior = $this->get('behavior');
        $userType = $this->get('userType');
        if ($behavior == 'add' || $behavior == 'edit') {
            $data = array(
                'type'          => $this->userType == 1 ? 2 : 1,
                'relation_id'   => $this->member['id'],
                'no'            => $this->get('no'),
                'name'          => $this->get('name'),
                'opening_bank'  => $this->get('opening_bank'),
                'bank'          => $this->get('bank'),
                'mode'          => $this->get('mode'),
            );
            $id = $this->get('id');
            if (!$id) {
                $data['created'] = time();
            }
            $bool = $id ? p_update('shop_bank', $data, array('id' => $id)) : p_insert('shop_bank', $data);
            message($bool ? '操作成功': '操作失败', $this->createMobileUrl('shopBank', array('userType' => $this->userType)), $bool ? 'success' : 'error');
        } else if($behavior == 'editShow'){
            $shopBank = p_get('shop_bank', array('id' => $this->get('id')));

            include $this->template('shopBank_add');
        } else {
            include $this->template('shopBank_add');
        }

    }

    public function doMobileShopGoods()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $userType = $this->get('userType');
        $where  = "salesman_id = {$this->member['id']} AND is_delete =1 ".get_uniacid();
        $shopGoods = $this->getTableList('shop_goods',$page, $where);
        if ($shopGoods){
            foreach ($shopGoods['list'] as & $value) {
                $value['shop_name'] = p_getcolumn('shop', array('id' => $value['shop_id']), 'shop_name');
                $value['salesman']  = p_getcolumn('salesman', array('id' => $value['salesman_id']), 'salesman_name');
                $value['category']  = p_getcolumn('shop_category', array('id' => $value['category_id']), 'category_name');
                $value['audit']     = $this->examine_status[$value['examine_status']];
            }
        }
        include $this->template('shopGoods');
    }

    public function doMobileCheckGoods()
    {
        $id = $this->get('id');
        $examine_status = $this->get('examine_status');
        $bool = p_update('shop_goods', array('examine_status' => $examine_status), array('id' => $id));
        json('', $bool ? 1: 0);
    }
    public function doMobileGoods()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $userType = $this->get('userType');
        $where  = "shop_id = {$this->member['id']} AND is_delete =1 ".get_uniacid();
        $shopGoods = $this->getTableList('shop_goods',$page, $where);
        if ($shopGoods){
            foreach ($shopGoods['list'] as & $value) {
                $value['shop_name'] = p_getcolumn('shop', array('id' => $value['shop_id']), 'shop_name');
                $value['salesman']  = p_getcolumn('salesman', array('id' => $value['salesman_id']), 'salesman_name');
                $value['category']  = p_getcolumn('shop_category', array('id' => $value['category_id']), 'category_name');
                $value['audit']     = $this->examine_status[$value['examine_status']];
            }
        }
        include $this->template('goods');

    }



    public function doMobileHandleGoods()
    {//var_dump($this->w);exit;
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $behavior = $this->get('behavior');
        load()->func('tpl');
        if ($behavior == 'add' || $behavior == 'edit') {
            $data = array(
                'category_id'       => $this->get('category_id'),
                'original_price'    => $this->get('original_price'),
                'goods_name'        => $this->get('goods_name'),
                'share_title'       => $this->get('share_title'),
                'share_image'       => $this->get('share_image'),
                'exchange_type'     => $this->get('exchange_type'),
                'money'             => $this->get('money'),
                'currency'          => $this->get('currency'),
                'cover_image'       => $this->get('cover_image'),
                'image'             => json_encode($this->get('image')),
                'is_free'           => $this->get('is_free'),
                'inventory_type'    => $this->get('inventory_type'),
                'inventory'         => $this->get('inventory'),
                'introduce'         => $this->get('introduce'),
                'allow_number'      => $this->get('allow_number'),
                'sort'              => $this->get('sort'),
                'shop_id'           => $this->member['id'],
                'salesman_id'       => $this->member['salesman_id'],
            );
            if ($this->member['is_examine'] == 1) {
                $data['examine_status'] = 1;
            } else {
                $data['examine_status'] = 2;
            }
            if ($data['is_free'] == 2) {
                $data['free'] = $this->get('free');
            }

            $id  = $this->get('id');
            if (!$id) {
                $data['created'] = time();
            }
            $bool = $id ? p_update('shop_goods', $data, array('id' => $id)) : p_insert('shop_goods', $data);
            message($bool ? '操作成功' : '操作失败', $this->createMobileUrl('goods'), $bool ? 'success' : 'error');
        } else {
            $shop_category_use = p_getall('shop_category_use',  array('shop_id' => $this->member['id']));
            if ($shop_category_use) {
                $category_id = implode(',',array_column($shop_category_use, 'category_id'));
                $category = p_fetchall("SELECT id, category_name  FROM ".prefix('shop_category'). "WHERE id in ($category_id) AND states =1 AND is_delete =1");
            }
            $id = $this->get('id');
            $shopGoods = p_get('shop_goods', array('id' => $id));
            $shopGoods['image'] = json_decode($shopGoods['image'], true);
            include $this->template('goods_add');
        }
    }


    public function doMobileHandleShopGoods()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $behavior = $this->get('behavior');
        load()->func('tpl');
        $userType = $this->get('userType');
        if ($behavior == 'add' || $behavior == 'edit') {
            $data = array(
                'original_price'    => $this->get('original_price'),
                'goods_name'        => $this->get('goods_name'),
                'share_title'       => $this->get('share_title'),
                'share_image'       => $this->get('share_image'),
                'exchange_type'     => $this->get('exchange_type'),
                'money'             => $this->get('money'),
                'cover_image'       => $this->get('cover_image'),
                'image'             => json_encode($this->get('image')),
                'is_free'           => $this->get('is_free'),
                'inventory_type'    => $this->get('inventory_type'),
                'inventory'         => $this->get('inventory'),
                'introduce'         => $this->get('introduce'),
                'allow_number'      => $this->get('allow_number'),
                'sort'              => $this->get('sort'),
            );
            if ($this->member['is_examine'] == 1) {
                $data['examine_status'] = 1;
            } else {
                $data['examine_status'] = 2;
            }
            if ($data['is_free'] == 2) {
                $data['free'] = $this->get('free');
            }

            $id  = $this->get('id');
            if (!$id) {
                $data['created'] = time();
            }
            $bool = $id ? p_update('shop_goods', $data, array('id' => $id)) : p_insert('shop_goods', $data);
            message($bool ? '操作成功' : '操作失败', $this->createMobileUrl('shopGoods', array('userType' => $userType)), $bool ? 'success' : 'error');
        } else {
            $id = $this->get('id');
            $shopGoods = p_get('shop_goods', array('id' => $id));
            $shopGoods['image'] = json_decode($shopGoods['image'], true);
            include $this->template('shop_goods_add');
        }
    }

    public function doMobileHandleStatus()
    {
        $id = $this->get('id');
        $status = $this->get('status');
        $bool = p_update('shop_goods',array('status' => $status), array('id' => $id));
        json($bool ? 'success': 'error', $bool ? 1: 0);
    }

    public function doMobileDelete()
    {
        $id = $this->get('id');
        $bool =  p_update('shop_goods', array('is_delete' => 2), array('id' => $id));
        json($bool ? 'success': 'error', $bool ? 1 : 0);
    }
    public function doMobileDeleteShop()
    {
        $id = $this->get('id');
        $bool = p_delete('shop', array('id' => $id));
        json($bool ? 'success': 'error', $bool ? 1 : 0);
    }
    public function doMobileDeleteShopAdvertisement()
    {
        $id = $this->get('id');
        $bool = p_delete('shop_advertisement', array('id' => $id));
        json($bool ? 'success': 'error', $bool ? 1 : 0);
    }


    public function doMobileDeleteBank()
    {
        $id = $this->get('id');
        $bool =  p_delete('shop_bank', array('id' => $id));
        json($bool ? 'success': 'error', $bool ? 1 : 0);
    }


    public function doMobileShopCategoryUse()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $id = $this->member['id'];
        $shopName = p_getcolumn('shop', array('id' => $id), 'shop_name');

        $shop_category  = p_getall('shop_category', array('states' => 1, 'is_delete' => 1));
        $shop_category_use = p_getall('shop_category_use', array('shop_id' => $id));
        $category_id = array_column($shop_category_use, 'category_id');
        if ($shop_category) {
            foreach ($shop_category as & $value) {
                if (in_array($value['id'], $category_id)) {
                    $value['is_exist'] = 'success';
                } else {
                    $value['is_exist'] = 'error';
                }
            }
        }
        include  $this->template('permissions');
    }

    public function doMobileShopCategoryUseList()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $userType = $this->get('userType');
        $where  = "shop_id = {$this->member['id']}".get_uniacid();
        $shopCategoryUse = $this->getTableList('shop_category_use',$page, $where);

        if($shopCategoryUse['list']) {
            foreach ($shopCategoryUse['list'] as & $value) {
                $value['category_name'] = p_getcolumn('shop_category', array('id' => $value['category_id']), 'category_name');
            }
        }
        include  $this->template('shopCategoryUseList');
    }

    public function doMobileSort()
    {
        $id = $this->get('id');
        $sort= $this->get('sort');
        $bool = false;
        if ($id && $sort) {
            $bool = p_update('shop_category_use', array('sort' => $sort), array('id' => $id));
        }
        json('', $bool ? 1 : 0);
    }
    public function doMobilePermissionsAssign()
    {
        $shop_id    = $this->get('shop_id');
        $categoryId = $this->get('category_id');
        if (empty($shop_id) || empty($categoryId)) {
            message('商户不存在或没有选择权限，请重新添加权限', $this->createMobileUrl('goods'), 'error');
        }
        $bool = false;
        if ($categoryId) {
            p_delete('shop_category_use',array('shop_id' => $shop_id));
            $salesman_id = p_getcolumn('shop', array('id' => $shop_id), 'salesman_id');
            foreach ($categoryId as $item) {
                $data = array(
                    'category_id' => $item,
                    'shop_id'     => $shop_id,
                    'salesman_id' => $salesman_id,
                    'created'     => time(),
                );
                $bool = p_insert('shop_category_use', $data);
            }
        }
        message($bool ? '操作成功' : '操作失败', $this->createMobileUrl('goods'), $bool ? 'success' : 'error');

    }
    public function doMobileShopOrder()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $where  = "shop_id = {$this->member['id']} ".get_uniacid();
        $shopOrder = $this->getTableList('shop_order', $page, $where);
        if ($shopOrder['list']) {
            foreach ($shopOrder['list'] as & $value) {
                $value['nickname']   = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                $value['goods_name'] = p_getcolumn('shop_goods', array('id' => $value['goods_id']), 'goods_name');
                $value['salesman']   = p_getcolumn('salesman', array('id' => $value['salesman_id']), 'salesman_name');
                $value['status_str'] = $this->status[$value['status']];
            }
        }
        include $this->template('shopOrder');
    }

    public function doMobileSendOut()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $id = $this->get('id');
        if ($id) {
            $shopOrder = p_get('shop_order', array('id' => $id));
            $shopOrder['nickname']   = p_getcolumn('memberinfo', array('id' => $shopOrder['member_id']), 'nickname');
            $shopOrder['goods_name'] = p_getcolumn('shop_goods', array('id' => $shopOrder['goods_id']), 'goods_name');
            include $this->template('sendOut');
        }
    }

    public function doMobileSend()
    {
        $id = $this->get('id');

        $courier_name = $this->get('courier_name');
        $courier_number = $this->get('courier_number');

        if (empty($id) || empty($courier_name) || empty($courier_number)) {
            message('缺少发货信息,请检查后在发货', $this->createMobileUrl('sendOut', array('id' => $id)), 'error');
        }
        $data = array(
            'courier_name' => $courier_name,
            'courier_number' => $courier_number,
            'status'        => 2,
            'delivery_time' => time(),
        );
        $bool = p_update('shop_order', $data, array('id' => $id));
        message($bool ? '发货成功': '发货失败', $this->createMobileUrl('shopOrder'),$bool ? 'success' :  'error');
    }

    public function doMobileCancel()
    {
        $id = $this->get('id');
        $bool =  false;
        if ($id) {
            $bool = p_update('shop_order', array('status' => 4), array('id' => $id));
        }
        json($bool ? 'success': 'error', $bool ? 1 : 0);
    }
    public function doMobileSuccess()
    {
        $id = $this->get('id');
        $bool =  false;
        if ($id) {
            $bool = p_update('shop_order', array('status' => 3, 'complete_time' => time()), array('id' => $id));
        }
        json($bool ? 'success': 'error', $bool ? 1 : 0);
    }


    public function doMobileShopWithdrawal()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $userType   = $this->get('userType');
        $shop   = p_get('shop', array('id' => $this->member['id']));
        $shopBank = p_getall('shop_bank', array('relation_id' => $this->member['id'], 'type' => $this->userType ==2 ? 1 : 2 ));
        include $this->template('launchWithdrawal');

       /* $where  = "relation_id = {$this->member['id']} ".get_uniacid();
        $withdrawal = $this->getTableList('shop_withdrawal', $page, $where);
        if ($withdrawal['list']) {
            $status = array(
                1 => '提现中',
                2 => '提现通过',
                3 => '拒绝'
            );
            foreach ($withdrawal['list'] as & $value) {
                $value['receiver'] = p_getcolumn('shop', array('id' => $value['relation_id']) , 'shop_name');
                $value['status_str'] = $status[$value['status']];
            }
        }
        include $this->template('withdrawal');*/
    }


    public function doMobileShopAdvertising()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $userType   = $this->get('userType');
        $behavior = $this->get('behavior');
        if ($behavior == 'addShow' || $behavior == 'editShow') {
            $shopAdvertising = p_get('shop_advertisement',array('id' => $this->get('id')));
            $shop = p_getall('shop', array('salesman_id' => $this->member['id']));

            include  $this->template('shop_advertisement_add');
        } elseif ($behavior == 'add' || $behavior == 'edit') {
            $data = array(
                'title'     => $this->get('title'),
                'salesman_id'     => $this->member['id'],
                'shop_id'     => $this->get('shop_id'),
                'image'     => $this->get('image'),
                'describe'  => $this->get('describe'),
                'position'  => $this->get('position' ,1),
                'type'      => $this->get('type'),
                'url'       => $this->get('url'),
                'sort'      => $this->get('sort'),
            );
            if ($data['type'] ==2) {
                $data['appid'] =$this->get('appid');
            }
            $id = $this->get('id');
            if (!$id) {
                $data['created'] = time();
            }
            $bool = $id ? p_update('shop_advertisement',$data, array('id' => $id), array('id' => $id)) : p_insert('shop_advertisement', $data);
            message($bool ? '操作成功' : '操作失败', $this->createMobileUrl('shopAdvertising',array('userType' => $userType)), $bool ? 'success' : 'error');
        } elseif($behavior == 'delete'){
            $bool = p_delete('shop_advertisement', array('id' => $this->get('id')));
            json('', $bool ? 1 : 0);
        }else{
            $page = $this->get('page');
            $where  = "position = 1 AND salesman_id ={$this->member['id']} " .get_uniacid();
            $shopAdvertising = $this->getTableList('shop_advertisement',$page, $where);


            if ($shopAdvertising['list']) {
                $type = array(
                    1 => '当前小程序',
                    2 => '其他小程序',
                    3 => 'H5',
                );
                $position = array(
                    6 => '步数首页icon',
                    7 => '步数中间',
                    8 => '投票抽奖首页',
                );
                foreach ($shopAdvertising['list'] as & $value) {
                    $value['type_str'] =$type[$value['type']];
                    $value['position_str'] =$position[$value['position']];
                    $value['shop'] = p_get('shop', array('id' => $value['shop_id']));
                }
            }
            include  $this->template('shop_advertisement');
        }


    }
    public function doMobileShopMember()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $userType   = $this->get('userType');

        $page   = $this->get('page');
        $where  = "shop_id = {$this->member['id']} ".get_uniacid();

        $memberInfo = $this->getTableList('memberinfo', $page, $where);

        include $this->template('shopMember');

    }


    public function doMobileSalesmanShop()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $userType   = $this->get('userType');
        $salesman = p_get('salesman', array('id' => $this->member['id']));
        include $this->template('salesmanShop');
    }

    public function doMobileUpdateSalesman()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $userType   = $this->get('userType');
        $id = $this->get('id');
        $data = array(
            'share_text'    => $this->get('share_text'),
            'share_img'     => $this->get('share_img'),
            'shop_cover'    => $this->get('shop_cover'),
        );
        $bool = p_update('salesman', $data, array('id' => $id));
        message($bool ? '修改成功': '修改失败', $this->createMobileUrl('salesmanShop', array('userType' => $userType)),$bool ? 'success' :  'error');
    }
    public function doMobileExecuteCash()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];

        $money          =  $this->get('money');
        $shop_bank_id  =  $this->get('shop_bank_id');

        if (empty($money) || empty($shop_bank_id)) {
            message('数据不正确请重新操作', $this->createMobileUrl('shopWithdrawal'), 'error');
        }
        $shop   = p_get('shop', array('id' => $this->member['id']));
        $commission = number_format($money * ($shop['service'] / 100), 2);
        if ($money > ($shop['money'] + $commission)) {
            message('可提现金额不能大于账户余额', $this->createMobileUrl('shopWithdrawal'), 'error');
        }
        $shop_bank = p_get('shop_bank', array('id' => $shop_bank_id));
        $bool = false;
        if (p_update('shop', array('money' => $shop['money'] - ($money + $commission)), array('id' => $this->member['id']))) {
            $data = array(
                'relation_id' => $this->member['id'],
                'money'       => $money,
                'mode'        => $shop_bank['mode'],
                'no'          => $shop_bank['no'],
                'name'        => $shop_bank['name'],
                'opening_bank'=> $shop_bank['opening_bank'],
                'type'        => $this->userType == 2 ? 1 : 2,
                'created'     => time()
            );
            $bool = p_insert('shop_withdrawal', $data);
        }
        message($bool ? '提现成功': '提现失败', $this->createMobileUrl('shopWithdrawal',array('userType' => $this->userType)),$bool ? 'success' :  'error');

    }



    public function doMobileSalesmanWithdrawal()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $userType   = $this->get('userType');
        $shop   = p_get('salesman', array('id' => $this->member['id']));
        $shopBank = p_getall('shop_bank', array('relation_id' => $this->member['id'], 'type' => $this->userType ==2 ? 1 : 2 ));
        include $this->template('salesmanWithdrawal');

    }


    public function doMobileSalesmanExecuteCash()
    {
        $this->userLogin();
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];

        $money          =  $this->get('money');
        $shop_bank_id  =  $this->get('shop_bank_id');

        if (empty($money) || empty($shop_bank_id)) {
            message('数据不正确请重新操作', $this->createMobileUrl('shopWithdrawal'), 'error');
        }
        $salesman   = p_get('salesman', array('id' => $this->member['id']));

        $commission = number_format($money * ($salesman['service'] / 100), 2);

        if ($money > ($salesman['money'] + $commission)) {
            message('可提现金额不能大于账户余额', $this->createMobileUrl('shopWithdrawal'), 'error');
        }
        $shop_bank = p_get('shop_bank', array('id' => $shop_bank_id));
        $bool = false;
        if (p_update('salesman', array('money' => $salesman['money'] - ($money + $commission)), array('id' => $this->member['id']))) {
            $data = array(
                'relation_id' => $this->member['id'],
                'money'       => $money,
                'mode'        => $shop_bank['mode'],
                'no'          => $shop_bank['no'],
                'name'        => $shop_bank['name'],
                'opening_bank'=> $shop_bank['opening_bank'],
                'type'        => $this->userType == 2 ? 1 : 2,
                'created'     => time()
            );
            $bool = p_insert('shop_withdrawal', $data);
        }
        message($bool ? '提现成功': '提现失败', $this->createMobileUrl('salesmanWithdrawal', array('userType' => $this->userType)),$bool ? 'success' :  'error');

    }
    public function doMobileWithdrawal()
    {
        $this->userLogin();
        $id = $this->get('id');
        $type = $this->get('type');
        $withdrawal = p_get('shop_withdrawal', array('id' => $id));
        if (empty($withdrawal) || $withdrawal['status'] > 1) {
            json('该笔订单有异常,请检查', 0);
        }
        if ($type == 1) {
            $bool = p_update('shop_withdrawal', array('status' => 2, 'update' => time()), array('id' => $id));
            json($bool ? 'success' : 'error', $bool ? 1 : 0);
        } else {
            $bool = p_update('shop_withdrawal', array('status' => 3, 'update' => time()), array('id' => $id));
            $shop = p_get('shop', array('id' => $this->member['id']));
            $bool2 = p_update('shop', array('money' => $shop['money'] + $withdrawal['money']), array('id' => $this->member['id']));
            if ($bool && $bool2) {
                json('success', 1);
            }
            json('error', 0);
        }


    }
    public function doMobileShopCategory()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        include $this->template('shopCategory');
    }

    public function doMobileHandleShopCategory()
    {
        $this->userLogin();
        $behavior = $this->get('behavior');
        load()->app('tpl');
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        if ($behavior == 'add' || $behavior == 'edit') {
            $data = array(
                'category_name'     => trim($this->get('category_name')),
                'category_describe' => trim($this->get('category_describe')),
                'states'            => trim($this->get('states')),
                'sort'              => trim($this->get('sort')),
            );
            $id = $this->get('id');
            $shop_id = $this->get('shop_id');
            if (p_get('shop_category', array('category_name' => $data['category_name']))) {
                message('分类已经存在，请重新添加', $this->createMobileUrl('shopCategory'), 'error');
            }
            if($shop_id) {
                $data['salesman_id'] = p_getcolumn('shop', array('id' =>  $shop_id), 'salesman_id');
                $data['shop_id']     = $shop_id;
            }
            if ($id && empty($shop_id)) {
                $data['shop_id']     = '';
                $data['salesman_id'] = '';
            }
            $bool = $this->lucks->shop_category($id, $data);
            message($bool ? '操作成功' : '操作失败', $this->createMobileUrl('shop_category'), $bool ? 'success' : 'error');
        } else {
            include $this->template('shop_category_add');
        }

    }


    public function doMobileLoginShow()
    {
        $style_path = $this->style_path;
        include $this->template('login');
    }

    public function doMobileLogin()
    {
        $phone = trim($this->get('phone'));
        $pwd = trim($this->get('pwd'));
        if (!preg_match('/^0?1[3|4|5|6|7|8][0-9]\d{8}$/', $phone )) {
            message('电话号码不正确', $this->createMobileUrl('loginShow'), 'error');
        }
       /* if (strlen($pwd) < 6 || strlen($pwd) > 18) {
            message('请输入正确的密码, 密码在6-18位', $this->createMobileUrl('loginShow'), 'error');
        }*/
        // 业务员
        $salesman = p_get('salesman', array('phone' => $phone, 'pwd' => $pwd));
        if ($salesman) {
            $this->userType = 1;
            $_SESSION['salesman_id'] = $salesman['id'];
            message('登录成功', $this->createMobileUrl('shop', array('userType' => $this->userType)), 'success');
        }
        //商家
        $shop = p_get('shop', array('phone' => $phone, 'pwd' => $pwd));
        if ($shop) {
            $this->userType = 2;
            $_SESSION['shop_id'] = $shop['id'];
            message('登录成功', $this->createMobileUrl('goods', array('userType' => $this->userType)), 'success');
        }
        message('账号或密码不正确', $this->createMobileUrl('loginShow'), 'error');
    }


    /**
     * 注销
     */
    public function doMobileLogOut()
    {
        $_SESSION=array();
        $siteurl = $this->createMobileUrl('loginShow');
        header("Location: {$siteurl}");
    }

    /**
     * 获取参数
     * @param $key
     * @param string $default
     * @return mixed|string
     *
     */
    public function get($key, $default = '')
    {
        return isset($this->gpc[$key]) ? $this->gpc[$key] : $default;
    }

    protected function userLogin()
    {
        $salesman_id = $_SESSION['salesman_id'];
        if ($salesman_id) {
            $this->member = p_get('salesman', array('id' => $salesman_id));
            $this->userType = 1;
        } else {
            $shop_id = $_SESSION['shop_id'];
            if ($shop_id) {
                $this->userType = 2;
                $this->member = p_get('shop', array('id' => $shop_id));
            }
        }
        if (!$this->member) {
            message('请登录系统', $this->createMobileUrl('loginShow'), 'error');
        }

    }



    /**
     * 图片上传
     */
    public function doMobileUpload()
    {
        load()->func('file');
        $reslut = bh_file_upload($_FILES['file']);
        if (isset($reslut['errno'])) {
            json($reslut['message'], 0);
        }

        if (is_oss()) {
            $remotestatus = file_remote_upload($reslut['path']);
            if (is_error($remotestatus)) {
                json('远程附件上传失败', 0);
            }
        }
        $reslut['url'] = getImage($reslut['path']);

        json($reslut);
    }

    /**
     * @param $table
     * @param $page
     * @param $where
     * @return array
     */
    public function getTableList($table, $page, $where, $sequence = 'id', $desc = "DESC")
    {
        $table  = prefix($table, true);
        $page   = max(1, intval($page));
        $list   = p_fetchall('SELECT * FROM '.$table." WHERE {$where} ORDER BY {$sequence} {$desc} LIMIT ".($page - 1) * $this->pageSize.','.$this->pageSize);
        $total  = p_fetchcolumn("SELECT COUNT(*) FROM {$table} WHERE {$where}");
        $pager = pagination($total, $page, $this->pageSize);
        return array(
            'list' => $list,
            'pages' => $pager
        );
    }

}