<?php

defined('IN_IA') or exit('Access Denied');

include "lib/Wxadoc.php";
include "lib/function.php";
include "model/lucks.mod.php";
include "model/vote.mod.php";
include "lib/WxpayAPI_php_v3/WxpayAPI_php_v3.php";
include "controller/manger.php";

class bh_voteModuleSite extends manger
{
    public $lucks= '';
    public $vote= '';

    public $siteRoot = '';

    public $image_url = '';



    protected $advertise_position = array(
        1 => '首页',
        2 => '抽奖详情',
        3 => '全部抽奖参与人',
        4 => '投票成功页面',
        5 => '开奖后页面',
        6 => '首页上方',
        7 => '发起页面横幅广告',
        8 => '发起活动页图标广告',
        9 => '我的页面底部'
    );
    protected $advertise_type = array(
        1 => '当前小程序',
        2 => '其他小程序',
        3 => 'h5',
        4 => '仅做展示',
        5 => '流量主',
        6 => '直播间',
    );
    protected $member_log_type = array(
        1 => '购买',
        2 => '使用',
        3 => '转赠',
        4 => '领取转赠',
    );

    protected $luck_lottery_type = array(
        1 => '时间自动开奖',
        2 => '人数开奖',
        3 => '手动开奖',
        4 => '现场抽奖',
        5 => '满人分组开奖',
        6 => '即抽即中'
    );

    protected $luck_status = array(
        1 => '进行中',
        2 => '已结束',
        3 => '失败'
    );
    protected $luck_luck_mode =array(
        1 => '普通抽奖',
        2 => '组队抽奖',
        3 => '好友助力',
        4 => '口令抽奖'
    );

    protected $luck_type = array(
        1 => '实物',
        2 => '虚拟',
        3 => '红包'
    );

    protected $parOrderType = array(
        1 => '商城奖品抽奖'
    );

    protected $authenticationStatus = array(
        1 => '审核中',
        2 => '审核通过',
        3 => '未通过'
    );
    protected $homePosition = array(
        1 => '每日福利',
        2 => '自助福利',
        3 => '开奖后推荐',
        4 => '封面红包类型'
    );
    protected $homeType = array(
        1 => '抽奖',
        2 => '投票',
        3 => '集字'
    );

    protected $voteActivitySexType = array(
        0 => '不限制',
        1 => '男性投票',
        2 => '女性投票',
    );


    /**
     * 发起投票
     * @var array
     */
    protected $voteActivityStatus = array(
        1 => '审核中',
        2 => '通过审核',
        3 => '拒绝审核',
    );


    /**
     * 参与者
     * @var array
     */
    protected $voteJoinStatus = array(
        0 => '审核中',
        1 => '通过审核',
        2 => '拒绝审核',
    );

    protected $examine = array(
        1 => '审核中',
        2 => '审核通过',
        3 => '审核不通过',
    );

    /**
     * bh_voteModuleSite constructor.
     */
    public function __construct()
    {


        parent::__construct();
        global $_GPC, $_W;
        $this->gpc = $_GPC;
        $this->w = $_W;
        $this->lucks = new lucks();
        $this->vote = new vote();
        $this->siteRoot = $this->w['siteroot'];
        $this->image_url = $this->w['siteroot'] . 'addons/bh_vote/template/static/images/xcx/';
        define('UNIACID', $this->w['uniacid']);
    }

    public function images($key, $default, $path = false)
    {
        $image = getConfig($key);
        if ($path) {
            return $image ? $image : $default;
        }
        return $image ? getImage($image) : ($this->image_url . $default);
    }
    public function settingTemplate($template)
    {
        $this->__define = IA_ROOT . "/addons/bh_vote/luck.php";
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        include $this->template($template);
    }

    /**
     *  基本配置
     */
    public function doWebConfig()
    {

        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $challengeCrontab = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=challengeCrontab&m=bh_vote";
        $TPCrontabDy = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=TPCrontabDy&m=bh_vote";
        $TPCrontabQq = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=TPCrontabQq&m=bh_vote";
        $KjCrontabDy = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=KjCrontabDy&m=bh_vote";
        $KjCrontabQq = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=KjCrontabQq&m=bh_vote";
        $activitySend = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=activitySend&m=bh_vote";
        $activitySendQq = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=activitySendQq&m=bh_vote";
        $signRemind = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=signRemind&m=bh_vote";

        $handleIntegral = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=handleIntegral&m=bh_vote";
        $queryIntegral = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=queryIntegral&m=bh_vote";
        $integralList = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=integralList&m=bh_vote";
        $resetTheTimes = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=resetTheTime&m=bh_vote";
        $bonusLevel = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=bonusLevel&m=bh_vote";
        $demotionLevel = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=demotionLevel&m=bh_vote";
        $redTask = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=redTask&m=bh_vote";

        $real = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=real&m=bh_vote";

        $uniacid = "{$this->w['uniacid']}";

        $event = $siteRoot . 'app/index.php?i=' . $uniacid . '&from=wxapp&c=entry&a=wxapp&do=event&m=bh_vote&appid=/$APPID$';

        $authorizationEvents = $siteRoot . "app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=receive&m=bh_vote";

        load()->func('tpl');
        $keys = array(
            'ordinary' => array(
                array('key' => 'xcx_title'),
                array('key' => 'xcx_describe'),
                array('key' => 'adUnitId'),
                array('key' => 'ios_pay', 'default' => 2),
                array('key' => 'new_people_number', 'default' => 5),
                array('key' => 'home_public_number'),
                array('key' => 'lottery_max_number'),
                array('key' => 'luck_tips_pwd'),
                array('key' => 'luck_tips_group'),
                array('key' => 'team_number'),
                array('key' => 'public_number_name'),
                array('key' => 'auth_start'),
                array('key' => 'auth_industry'),
                array('key' => 'prize_default_picture'),
                array('key' => 'senior_image'),
                array('key' => 'senior_number', 'default' => 100),
                array('key' => 'senior_privilege'),
                array('key' => 'code_tips'),
                array('key' => 'info_code_tips'),
                array('key' => 'complaint_msg'),
                array('key' => 'complaint_content'),
                array('key' => 'down_share_img'),
                array('key' => 'send_message_kj_id'), // 抽奖
                array('key' => 'send_message_tp_id'), // 投票
                array('key' => 'new_activities'),
                array('key' => 'dy_send_message_kj_id'),
                array('key' => 'dy_send_message_tp_id'),
                array('key' => 'bomb_off', 'default' => 2),
                array('key' => 'luck_tips_addition'),
                array('key' => 'add_friend_txt'),
                array('key' => 'vote_introduce_url'),
                array('key' => 'use_substance'),
                array('key' => 'screen_ad'),
                array('key' => 'video_ad'),
                array('key' => 'single_ad'),
                array('key' => 'automatic_minute'),
                array('key' => 'disclaimer'),
                array('key' => 'automatic_default', 'default' => 1),
                array('key' => 'appoint_group_msg'),
                array('key' => 'luck_examine', 'default' => 2),
                array('key' => 'luck_cost_ad', 'default' => 1),
                array('key' => 'img_check', 'default' => 1),
                array('key' => 'launch_ad', 'default' => 1),
                array('key' => 'open_senior', 'default' => 2),
                array('key' => 'home_days', 'default' => 2),
                array('key' => 'write_off_code_type', 'default' => 2),
                array('key' => 'open_write', 'default' => 2),
                array('key' => 'full_screen_ad', 'default' => 2),
                array('key' => 'ad_time', 'default' => 5),
                array('key' => 'qq_map_key'),
                array('key' => 'user_look_video', 'default' => 1),
                array('key' => 'end_exhibition', 'default' => 1),
                array('key' => 'is_front_page', 'default' => 1),
                array('key' => 'home_screen', 'default' => 1),
                array('key' => 'vote_index_ad', 'default' => 1),
                array('key' => 'is_new_home', 'default' => 1),
                array('key' => 'luck_open_red', 'default' => 1),
                array('key' => 'screen_second', 'default' => 3),
                array('key' => 'home_title', 'default' => '公共福利'),
                array('key' => 'daily_benefits', 'default' => '每日福利'),
                array('key' => 'self_service', 'default' => '自助福利'),
                array('key' => 'cover_red_bag', 'default' => '红包封面'),
                array('key' => 'when_chief', 'default' => '我要当团长文案'),
                array('key' => 'luck_watch_video', 'default' => '观看视频广告，参与抽奖'),
                array('key' => 'share_help_pop_txt', 'default' => '邀请好友助力，可增加中奖机率！每邀请一位好友, 中奖概率提升一倍'),
                array('key' => 'watch_video_pop_txt', 'default' => '观看激励视频中奖几率翻倍'),
                array('key' => 'luck_hlep_txt'),
                array('key' => 'look_double_txt', 'default' => '观看视频广告，中奖几率提升100%'),
                array('key' => 'look_double_succ', 'default' => '观看完成，中奖几率已提升100%'),
                array('key' => 'my_title_bg_color', 'default' => '#ff3399'),
                array('key' => 'guide_bg_color', 'default' => '#ff3399'),
                array('key' => 'my_title_color', 'default' => '#ff3399'),
                array('key' => 'home_public_number_url'),
                array('key' => 'initiate_authentication', 'default' => 1),
                array('key' => 'home_show_guide', 'default' => 1),
                array('key' => 'is_personal', 'default' => 1),
                array('key' => 'slide_up_show', 'default' => 1),
                array('key' => 'is_sesame_customer', 'default' => 1),
                array('key' => 'user_is_double', 'default' => 1),
                array('key' => 'audit_model', 'default' => 1),
            ),
            'share' =>array(
                array('key' => 'share_text'),
                array('key' => 'share_tips'),
                array('key' => 'share_image'),
            ),
            'vote' => array(
                array('key' => 'vote_cost_ad', 'default' => 2),
                array('key' => 'vote_complaint'),
                array('key' => 'map_appkey'),
                array('key' => 'vote_rank_limit', 'default' => 8),
                array('key' => 'vote_examine', 'default' => 2),
            ),
            'home' => array(
                array('key' => 'up_home_mrfl_text'),
                array('key' => 'up_home_mrfl_details'),
                array('key' => 'up_home_zzfl_text'),
                array('key' => 'up_home_zzfl_details'),
            ),
            'sign' =>  array(
                array('key' => 'is_double', 'default' => 1),
                array('key' => 'integral_name', 'default' => '积分名字'),
                array('key' => 'sigin_title', 'default' => '签到'),
                array('key' => 'interaction_title', 'default' => '锦鲤互动'),
                array('key' => 'signin_one_day', 'default' => 1),
                array('key' => 'signin_two_day', 'default' => 1),
                array('key' => 'signin_three_day', 'default' => 1),
                array('key' => 'signin_four_day', 'default' => 1),
                array('key' => 'signin_five_day', 'default' => 1),
                array('key' => 'signin_six_day', 'default' => 1),
                array('key' => 'signin_seven_day', 'default' => 1),
                array('key' => 'sign_subscribe'),
                array('key' => 'earnings_send_hour'),
                array('key' => 'earnings_send_minute'),
                array('key' => 'goods_flow_group'),
                array('key' => 'integral_img'),
                array('key' => 'integral_key'),
                array('key' => 'sigin_plug_status', 'default' => 1),
                array('key' => 'sigin_synchronization', 'default' => 1),
                array('key' => 'sign_status', 'default' => 1),
                array('key' => 'integral_rule_url', 'default' => 1),
                array('key' => 'resetTheTime'),
                array('key' => 'open_bag', 'default' => 2),
                array('key' => 'red_grant_hour'),
                array('key' => 'red_grant_minute'),
                array('key' => 'today_dividend_default', 'default' => 9),
                array('key' => 'open_dividend', 'default' => 2),
                array('key' => 'dividend_level', 'default' => 1),
                array('key' => 'updatedNumber', 'default' => 1),
                array('key' => 'demotionNumber', 'default' => 1),
                array('key' => 'jizi_integral', 'default' => 1),
                array('key' => 'pdd_client_id'),
                array('key' => 'pdd_client_secret'),
                array('key' => 'pdd_pid', 'default'=> ''),
                array('key' => 'open_calligraphy', 'default' => 2),
                array('key' => 'examine_notice_id'),
                array('key' => 'open_hd', 'default' => 1),
            ),
            'qq' => array(
                array('key' => 'qq_mch_id')
            ),
            'withdrawals' => array(
                array('key' => 'cash_bg'),
                array('key' => 'apiclient_cert'),
                array('key' => 'apiclient_key'),
                array('key' => 'open_withdrawal', 'default' => 1),
                array('key' => 'cash_type', 'default' => 1),
                array('key' => 'cash_explain'),
                array('key' => 'bag_daily_upper'),
                array('key' => 'withdrawals_day_number'),
                array('key' => 'first_presentation', 'default' => 10),
                array('key' => 'follow_up_presentation', 'default' => 1),
                array('key' => 'cash_reviewed', 'default' => 10),
                array('key' => 'cash_password'),
                array('key' => 'open_cash_password', 'default' => 1),
                array('key' => 'pwd_guide_url'),
            ),
            'dividend' => array(
              array('key' => 'bonus_rule')
            ),
            'officialAccounts' => array(
                array('key' => 'official_account_tips', 'default' => '公众号粉丝参与介绍'),
                array('key' => 'open_official_account', 'default' => 1), // 1关闭 2开启
                array('key' => 'encodingAesKey', 'default' => '消息加解密Key'),
                array('key' => 'decryptToken', 'default' => '消息校验Token'),
                array('key' => 'component_appid', 'default' => '开放平台appid'),
                array('key' => 'component_appsecret', 'default' => '开放平台APPSECRET'),
            ),
            'shop' => array(
                array('key' => 'shop_share_text'),
                array('key' => 'shop_share_image'),
            ),
        );

        $op = $this->get('op', 'ordinary');
        if (!isset($keys[$op])) {
            message('参数错误', $this->createWebUrl('config'));
        }
        if ($this->w['ispost']) {
            foreach ($keys[$op] as $value) {
                $names = array('share_image');
                if (!in_array($value['key'], array('apiclient_cert', 'apiclient_key'))) {
                    $val = in_array($value['key'], $names) ? $this->get($value['key']) : $this->get($value['key']);
                    p_update('config', array('value' => $val), array('key' => $value['key']));
                }
                if ($value['key'] == 'team_number') {
                    $teamNumber = explode(',', $this->get('team_number'));
                    p_update('config', array('value' => json_encode($teamNumber)), array('key' => $value['key']));
                    continue;
                }
                if ($value['key'] == 'auth_start') {
                    $authStart = explode(',', $this->get('auth_start'));
                    p_update('config', array('value' => json_encode($authStart)), array('key' => $value['key']));
                    continue;
                }
                if ($value['key'] == 'auth_industry') {
                    $authIndustry = explode(',', $this->get('auth_industry'));
                    p_update('config', array('value' => json_encode($authIndustry)), array('key' => $value['key']));
                    continue;
                }
                if ($value['key'] == 'complaint_msg') {
                    $complaintMsg = explode('|', $this->get('complaint_msg'));
                    p_update('config', array('value' => json_encode($complaintMsg)), array('key' => $value['key']));
                    continue;
                }
                if ($value['key'] == 'vote_complaint') {
                    $voteComplaint = explode('|', $this->get('vote_complaint'));
                    p_update('config', array('value' => json_encode($voteComplaint)), array('key' => $value['key']));
                    continue;
                }
                if ($value['key'] == 'senior_privilege') {
                    $senior_privilege = explode('|', $this->get('senior_privilege'));
                    p_update('config', array('value' => json_encode($senior_privilege)), array('key' => $value['key']));
                    continue;
                }

                if ($value['key'] == 'cash_explain') {
                    $cash_explain = explode(',', $this->get('cash_explain'));
                    p_update('config', array('value' => json_encode($cash_explain)), array('key' => $value['key']));
                    continue;
                }

                if ($value['key'] == 'info_code_tips') {
                    $info_code_tips = explode('|', $this->get('info_code_tips'));

                    p_update('config', array('value' => json_encode($info_code_tips)), array('key' => $value['key']));
                    continue;
                }
                if ($value['key'] == 'disclaimer') {
                    $disclaimer = explode('|', $this->get('disclaimer'));

                    p_update('config', array('value' => json_encode($disclaimer)), array('key' => $value['key']));
                    continue;
                }

                if ($value['key'] == 'complaint_content') {
                    $complaintContent = explode('|', $this->get('complaint_content'));
                    p_update('config', array('value' => json_encode($complaintContent)), array('key' => $value['key']));
                    continue;
                }
                if ($value['key'] == 'up_home_mrfl_details') {
                    $up_home_mrfl_details = explode('|', $this->get('up_home_mrfl_details'));
                    p_update('config', array('value' => json_encode($up_home_mrfl_details)), array('key' => $value['key']));
                    continue;
                }
                if ($value['key'] == 'up_home_zzfl_details') {
                    $up_home_zzfl_details = explode('|', $this->get('up_home_zzfl_details'));
                    p_update('config', array('value' => json_encode($up_home_zzfl_details)), array('key' => $value['key']));
                    continue;
                }

                if ($value['key'] == 'treasure_rules_font') {
                    $treasure_rules_font = explode('|', $this->get('treasure_rules_font'));
                    p_update('config', array('value' => json_encode($treasure_rules_font)), array('key' => $value['key']));
                    continue;
                }

                if ($value['key'] == 'turntable_rule') {
                    $turntable_rule = explode('|', $this->get('turntable_rule'));
                    p_update('config', array('value' => json_encode($turntable_rule)), array('key' => $value['key']));
                    continue;
                }

                if ($value['key'] == 'resetTheTime') {
                    $resetTheTime = strtotime($this->get('resetTheTime'));
                    p_update('config', array('value' => $resetTheTime), array('key' => $value['key']));
                    continue;
                }

            }
            $path1 = ATTACHMENT_ROOT . $this->w['uniacid'] . 'cert/';
            if (!file_exists($path1)) {
                @mkdir($path1,0777,true);
            }


            if (isset($_FILES['_apiclient_cert']['tmp_name']) && file_exists($_FILES['_apiclient_cert']['tmp_name'])) {
                $path = $path1 . 'apiclient_cert.pem';
                if (move_uploaded_file($_FILES['_apiclient_cert']['tmp_name'], $path)) {
                    p_update('config', array('value' => $path), array('key' => 'apiclient_cert'));
                }
            }
            if (isset($_FILES['_apiclient_key']['tmp_name']) && file_exists($_FILES['_apiclient_key']['tmp_name'])) {
                $path = $path1 . 'apiclient_key.pem';
                if (move_uploaded_file($_FILES['_apiclient_key']['tmp_name'], $path)) {
                    p_update('config', array('value' => $path), array('key' => 'apiclient_key'));
                }
            }

        }
        $initial = function ($key, $default = 0){
            $config = p_get('config', array('key' => $key));
            if (empty($config)) {
                $config = array(
                    'key' => $key,
                    'value' => $default
                );
                p_insert('config', $config);
            }
            return $config;
        };
        foreach ($keys[$op] as $value) {
            $k = $value['key'];
            $$k = $initial($k, $value['default']);
        }

        $basename = pathinfo($this->w["siteroot"]);
        $basename = $basename["basename"];
        $w7_order_id = p_get('config', array('key' => "w7_order_id"));
        $activation_code = p_get('config', array('key' => "activation_code"));
        $w7_order_ids = '123456';
        if(empty($w7_order_id)){
              p_insert('config', array("key" => "w7_order_id", "value" => md5($basename . "1fdfd4c01357071e9fa6328a9d330c" . $w7_order_ids)));
        }else{
              p_update('config', array('value' => md5($basename . "1fdfd4c01357071e9fa6328a9d330c" . $w7_order_ids)), array('key' => 'w7_order_id'));
        }
        $w7_order_id = p_get('config', array('key' => "w7_order_id"));
        if(empty($activation_code)){
              p_insert('config', array("key" => "activation_code", "value" => md5($basename . "1fdfd4c01357071e9fa6328a9d330c" . $w7_order_id)));
        }else{
              p_update('config', array('value' => md5($basename . "1fdfd4c01357071e9fa6328a9d330c" . $w7_order_id)), array('key' => 'activation_code'));
        }

        if ($op == 'ordinary') {
            $team_number['value'] = !empty($team_number['value']) ? implode(',', json_decode($team_number['value'], true)) : '';
            $senior_privilege['value'] = !empty($senior_privilege['value']) ? implode('|', json_decode($senior_privilege['value'], true)) : '';
            //$code_tips['value'] = !empty($code_tips['value']) ? implode('|', json_decode($code_tips['value'], true)) : '';
            $info_code_tips['value'] = !empty($info_code_tips['value']) ? implode('|', json_decode($info_code_tips['value'], true)) : '';
            $disclaimer['value'] = !empty($disclaimer['value']) ? implode('|', json_decode($disclaimer['value'], true)) : '';
            $auth_start['value'] = !empty($auth_start['value']) ? implode(',', json_decode($auth_start['value'], true)) : '';
            $auth_industry['value'] = !empty($auth_industry['value']) ? implode(',', json_decode($auth_industry['value'], true)) : '';
            $complaint_msg['value'] = !empty($complaint_msg['value']) ? implode('|', json_decode($complaint_msg['value'], true)) : '';
            $complaint_content['value'] = !empty($complaint_content['value']) ? implode('|', json_decode($complaint_content['value'], true)) : '';
        }
        if ($op == 'vote') {
            $vote_complaint['value'] = !empty($vote_complaint['value']) ? implode('|', json_decode($vote_complaint['value'], true)) : '';
        }
        if ($op == 'home') {
            $up_home_mrfl_details['value'] = !empty($up_home_mrfl_details['value']) ? implode('|', json_decode($up_home_mrfl_details['value'], true)) : '';
            $up_home_zzfl_details['value'] = !empty($up_home_zzfl_details['value']) ? implode('|', json_decode($up_home_zzfl_details['value'], true)) : '';
        }
        if($op == 'stepShop') {
            $treasure_rules_font['value'] = !empty($treasure_rules_font['value']) ? implode('|', json_decode($treasure_rules_font['value'], true)) : '';
            $turntable_rule['value'] = !empty($turntable_rule['value']) ? implode('|', json_decode($turntable_rule['value'], true)) : '';
        }

        if ($op == 'withdrawals') {
            $cash_explain['value'] = !empty($cash_explain['value']) ? implode(',', json_decode($cash_explain['value'], true)) : '';
        }
        $is_integral_plugin =  $this->vote->is_integral_plugin();
        $isIntegralUser =  $this->vote->isIntegralUser();

        //$isIntegralUser = true;
        include $this->template('config');
    }


    public function doWebIndex()
    {

        $name = '投票小助手';
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $dailyData = $this->lucks->getDailyData();
        $getSeniorMemberLog = $this->lucks->getSeniorMemberLog();
        $newLuck = $this->lucks->getNewLuck();
        if ($newLuck) {
            foreach ($newLuck as & $value) {
                $memberLuck = $this->lucks->getLuckGoods($value['id']);
                $value['luckName'] = $this->lucks->getLuckGoodsName($value['id']);
                $value['lottery_type'] =$this->luck_lottery_type[$value['lottery_type']];
                $value['luck_mode'] = $this->luck_luck_mode[$value['luck_mode']];
                $value['type'] = $this->luck_type[$memberLuck['type']];
            }
        }
        $luckModeProportion = $this->lucks->getLuckProportion();

        $userMonthData = $this->lucks->getUserMonth();
        $payOrder = $this->lucks->getPayOrder();
        $luckCount = $this->lucks->getMonthLuckCount();

        include $this->template('index');
    }

    public function doWebHome()
    {
        $name = '投票小助手';
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        include $this->template('home');
    }


    public function doWebTemplate()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $where  = "1 = 1 ".get_uniacid();
        $template = $this->lucks->getTableList('vote_template',$page, $where);
        include $this->template('template');
    }

    public function doWebOperationTemplate()
    {
        $name        = $this->get('name');
        $states        = $this->get('states');
        $sort       = $this->get('sort');
        $id          = $this->get('id');

        $bool = $this->lucks->editTemplate($name, $states, $sort, $id);
        message($bool ? "操作成功" : "操作失败", $this->createWebUrl("template"),  $bool ? 'success': 'error');
    }

    public function doWebVote_activity()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $where  = "is_delete = 1 AND complete =2 ".get_uniacid();

        $nickname = $this->get('nickname');
        $member_ids = $this->lucks->searchMember($nickname);
        if ($member_ids) {
            $where .= " AND member_id in ({$member_ids})";
        }
        $status = $this->get('status', -1);
        if ($status >= 0 ) {
            $where .= " AND status = {$status}";
        }
        $complete = $this->get('complete');
        if ($complete) {
            $where .= " AND complete = {$complete}";
        }
        $voteActivity = $this->lucks->getTableList('vote_activity',$page, $where);
        if ($voteActivity['list']) {
            $xcx_path = 'bh_vote/pages/vote/webView/webView';
            foreach ($voteActivity['list'] as & $value) {
                $value['voteActivityCode'] = $this->vote->createWxCode($this, $value['id'] . '_' . $value['member_id'] , $xcx_path, 'vote_activity_code' . $value['id'] . '_' . $value['member_id'] . '.png');
                $value['sex_type_str'] = $this->voteActivitySexType[$value['sex_type']];
                $value['end_time'] = $value['end_type'] ==1 ? date('Y-m-d H:i:s', $value['end_time']) : $value['end_time'];
                $value['status_str'] = $this->voteActivityStatus[$value['status']];
                $value['vote_goods'] = p_get('vote_goods', array('vote_id' => $value['id']));
                $value['vote_complaint_number'] = p_fetchcolumn("select count(*) from " . prefix("vote_complaint") . " where vote_id={$value['id']}" . get_uniacid());

            }
        }
        include $this->template('vote_activity');
    }

    public function doWebVote_join()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $where  = "1 = 1 ".get_uniacid();
        $nickname = $this->get('nickname');
        if ($nickname) {
            $where .= " AND name like '%{$nickname}%'";
        }
        $status = $this->get('status');
        if ($status != '') {
            $where .=  " AND status = {$status}";
        }
        $voteJoin = $this->lucks->getTableList('vote_join',$page, $where);
        if ($voteJoin['list']) {
            foreach ($voteJoin['list'] as & $value) {
                $voteActivity =$this->lucks->getVote_activityOne($value['activity_id']);
                $value['status_str'] = $this->voteJoinStatus[$value['status']];
                $value['activityTitle'] = $voteActivity['title'];
                $value['thumb'] = $this->getSubmission($value['thumb'], 2);
            }

        }
        include $this->template('vote_join');
    }

    public function doWebDeleteVoteJoin()
    {
        $id = $this->get('id');

        $m = p_get('vote_join', array('id' => $id));
        if ($m['status'] == 1) {
            $join_num  = p_getcolumn('vote_activity', array('id' => $m['activity_id']), 'join_num');
            p_update('vote_activity', array('join_num' => $join_num -1), array('id' => $m['activity_id']));
        }
        $bool = p_delete('vote_join', array('id' => $id));

        json('', $bool ? 1 : 0);


    }
    public function doWebOperationVoteActivity()
    {
        $data = array(
            'cover_image'       => $this->get('cover_image'),
            'member_id'         => (int)$this->get('member_id', 0),
            'title'             => $this->get('title'),
            'template_id'       => $this->get('template_id'),
            'describe'          => $this->get('describe'),
            'describe_img'      => json_encode($this->voteDescribeImg($this->get('describe_img'))),
            'type'              => $this->get('type',1),
            'prize_type'        => $this->get('prize_type', 1),
            'end_type'          => $this->get('end_type' ,1),
            'start_time'        => strtotime($this->get('start_time')),
            'end_time'          => strtotime($this->get('end_time')),
            'sex_type'          => $this->get('sex_type'),
            'region_type'       => $this->get('region_type'),
            'sponsor_enabled'   => $this->get('sponsor_enabled'),
           /* 'share_thumb'       => $this->get('share_thumb'),*/
            'sign_enabled'      => $this->get('sign_enabled'),
            'sign_phone'        => $this->get('sign_phone'),
            'sign_wx'           => $this->get('sign_wx'),
            'day_votes'         => $this->get('day_votes'),
            'is_repeat'         => $this->get('is_repeat'),
            'lottery_type'      => $this->get('lottery_type'),
            'appoint_group'     => $this->get('appoint_group'),
            'is_verification'   => $this->get('is_verification'),
        );
        if(empty($data['title'])) {
            message("主题必须填写", $this->createWebUrl("vote_activity"),  'warning');
        }


       /* if (empty($data['cover_image']) || empty($data['bg_image']) || empty($data['votes_bg_image']) || empty($data['color'])) {
            $defaultBgInfo = $this->lucks->getDefaultTemplateOne(2);
            if (empty($defaultBgInfo)) {
                message("请设置背景相关数据或者在模块设置默认风格", $this->createWebUrl("template"),  'warning');
            }
            $data['cover_image']    = $defaultBgInfo['cover_image'];
            $data['bg_image']       = $defaultBgInfo['bg_image'];
            $data['votes_bg_image'] = $defaultBgInfo['votes_bg_image'];
            $data['color']          = $defaultBgInfo['color'];
        }*/
        //人数结束
        if ($data['end_type'] == 2) {
            $data['end_time'] = $this->get('end_number');
        }
        if ($data['sponsor_enabled'] == 2 ) {
            $data['sponsor_name']  = $this->get('sponsor_name');
            $data['sponsor_phone'] = $this->get('sponsor_phone');
        }
        if (empty($data['share_thumb'])) {
            $data['share_thumb'] = $data['cover_image'];
        }
        if ($data['sign_enabled'] == 2) {
            $data['sign_start_time'] = strtotime($this->get('sign_start_time'));
            $data['sign_end_time']  = strtotime($this->get('sign_end_time'));
        }

        if ($data['region_type'] == 2) {
            if ($region = $this->get('region')){
                foreach ($region as  $value) {
                    $regionData[] = $value;
                }
              $data['region'] = json_encode($regionData);
            }
        }


        $id = $this->get('id');
        if ($id) {
            $bool = $this->lucks->editVoteActivity($data, $id);
        } else {
            $data['complete'] = 2;
            $data['status'] = 2;
            $data['created'] = time();
            $bool = $this->lucks->editVoteActivity($data);
        }
        if ($bool) {
            $this->changeMember($data['member_id']);
        }
        message($bool ? "操作成功" : "操作失败", $this->createWebUrl("vote_activity"),  $bool ? 'success': 'error');
    }



    public function voteDescribeImg($data)
    {
        if ($data) {
            $imgData = array();
            foreach ($data as $k => $value) {
                $imgData[$k]['url'] = getImage($value);
                $imgData[$k]['path'] = $value;
            }
            return $imgData;
        }
        return $data;
    }
    public function doWebOperationVoteJoin()
    {
        $data = array(
        'name'        => $this->get('name'),
        'thumb'       => json_encode($this->get('thumb')),
        'share_thumb' => $this->get('share_thumb'),
        'intro'       => $this->get('intro'),
        'activity_id' => $this->get('activity_id'),
        'vote_num'    => $this->get('vote_num'),
        'type'        => 1,
        'status'      => 1,
        'is_img'      => $this->get('is_img'),
        );
        $id  = $this->get('id');
        $voteActivityBasis = $this->lucks->getVoteActivityBasis($data['activity_id']);
        if (empty($voteActivityBasis)) {
            message("投票活动不存在,请重新添加", $this->createWebUrl("vote_activity"),  'warning');
        }
        if ($voteActivityBasis['sign_enabled'] == 2) {
            if ( time() > $voteActivityBasis['sign_start_time']    && time()  < $voteActivityBasis['sign_end_time']  ) {
                $data['c_time'] = time();
            } else {
                message("投票报名时间错误", $this->createWebUrl("vote_activity"),  'warning');
            }
        }


        $voteJoin = p_get('vote_join', array('id' => $id));   //60

        $num = $data['vote_num'] - $voteJoin['vote_num'];

        if ($num > 0) {
            p_update('vote_activity', array('vote_num' => $voteActivityBasis['vote_num'] + $num), array('id' => $data['activity_id']));
        } else {
            p_update('vote_activity', array('vote_num' => $voteActivityBasis['vote_num'] - abs($num)), array('id' => $data['activity_id']));
        }

        if ($voteActivityBasis['sign_phone'] ==2) {
            $data['phone'] = $this->get('phone');
        }
        if ($voteActivityBasis['sign_wx'] ==2) {
            $data['wechat'] = $this->get('wechat');
        }
        $bool = $this->lucks->editVoteJoin($data, $id);
        if (!$id) {
            if ($bool) {
                $this->lucks->addVoteActivityJoinNum($data['activity_id']);
            }
        }

        message($bool ? "操作成功" : "操作失败", $this->createWebUrl("vote_activity"),  $bool ? 'success': 'error');
    }

    public function doWebOperationVoteGoods()
    {
        $data = array(
            'source'    => $this->get('source'),
            'number'    => (int)$this->get('number'),
            'vote_id'   => $this->get('id')
        );
        $id = $this->get('id');
        if ($id) {
            $data['created'] = time();
        }
        $voteActivity = $this->lucks->getVote_activityOne($data['vote_id']);
        if (time() > $voteActivity['start_time']) {
            message("投票活动已经开始,商品不能在添加,请在活动开始之前做好相关操作", $this->createWebUrl("vote_activity"),  'warning');
        }
        if ($data['number'] < 1) {
            message("奖品最低份额为1份", $this->createWebUrl("vote_activity"),  'warning');
        }
        if ($data['source'] ==2) {
            $goods = $this->lucks->getGoodsOne($this->get('goods_id'));
            if (empty($goods)) {
                message("商品不存在请重新选择", $this->createWebUrl("vote_activity"),  'warning');
            }
            $data['name']  = $goods['name'];
            $data['image'] = $goods['cover_image'];
            $data['goods_id']  = $goods['id'];
        } else {
            $data['member_id'] = $this->get('member_id');
            $data['name'] = $this->get('name');
            $data['image'] = $this->get('image');
        }
        $bool = $this->lucks->editVoteGoods($data);
        message($bool ? "操作成功" : "操作失败", $this->createWebUrl("vote_activity"),  $bool ? 'success': 'error');
    }
    public function doWebCheckVoteGoods()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $id = $this->get('id');
        $page   = $this->get('page');
        $where  = "vote_id = {$id} ".get_uniacid();
        $vote_goods = $this->lucks->getTableList('vote_goods',$page, $where);
        if ($vote_goods['list']) {
            foreach ($vote_goods['list'] as & $value) {
                $value['vote_activity'] = $this->lucks->getVote_activityOne($value['vote_id']);
                $value['nickname'] = $value ? $this->lucks->getMemberName($value['member_id']) : '商城提供';
            }
        }
        include $this->template('vote_goods_check');
    }


    public function doWebCheckVoteGoodsInfo()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $id = $this->get('id');
        $page   = $this->get('page');
        $where  = "vote_goods_id = {$id} ".get_uniacid();
        $vote_goods_info = $this->lucks->getTableList('vote_goods_info',$page, $where);
        if ($vote_goods_info['list']) {
            foreach ($vote_goods_info['list'] as & $value) {
                $value['vote_activity'] = $this->lucks->getVote_activityOne($value['vote_id']);
                $value['nickname'] = $value ? $this->lucks->getMemberName($value['member_id']) : '商城提供';
                $value['prize_nickname'] = $this->lucks->getMemberName($value['in_member_id']);
            }
        }
        include $this->template('vote_goods_info_check');
    }

    public function doWebVote_goods_info()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $where  = "source = 2 ".get_uniacid();
        $vote_goods_info = $this->lucks->getTableList('vote_goods_info',$page, $where);
        $status = array(
            1 => '未发货',
            2 => '已发货',
            3 => '已完成',
            4 => '已取消'
        );
        if ($vote_goods_info['list']) {
            foreach ($vote_goods_info['list'] as & $value) {
                $value['vote_activity'] = $this->lucks->getVote_activityOne($value['vote_id']);
                $value['nickname'] = $value['member_id'] ? $this->lucks->getMemberName($value['member_id']) : '商城提供';
                $value['prize_nickname'] = $this->lucks->getMemberName($value['in_member_id']);
                $value['status_str'] = $status[$value['status']];
            }
        }
        include $this->template('vote_goods_info');
    }

    public function doWebLuck_goods_info()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $where  = " source = 2 ".get_uniacid();
        $luck_goods_info = $this->lucks->getTableList('luck_goods_info',$page, $where);
        $status = array(
            1 => '未发货',
            2 => '已发货',
            3 => '已完成',
            4 => '已取消'
        );
        if ($luck_goods_info['list']) {
            foreach ($luck_goods_info['list'] as & $value) {
                $value['status_str'] = $status[$value['status']];
                $value['initiator'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                $value['winners'] = p_getcolumn('memberinfo', array('id' => $value['in_member_id']), 'nickname');
            }
        }
        include $this->template('luck_goods_info');
    }

    public function doWebRemoveVoteGoods()
    {
        $id = $this->get('id');
        $bool = $this->lucks->removeVoteGoods($id);
        message($bool ? "操作成功" : "操作失败", $this->createWebUrl("vote_activity"),  $bool ? 'success': 'error');
    }


    /**
     * 用户管理
     */
    public function doWebMember()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $is_integral_plugin =  $this->vote->is_integral_plugin();
        $isIntegralUser = $this->vote->isIntegralUser();
        $op = $this->get('op');
        $id = $this->get('id');
        if ($op == 'del') {
            $bool = p_delete('memberinfo', array('id' => $id));
            json($bool ? "操作成功" : "操作失败", $bool ? 1 : 0);
            //message($bool ? "操作成功" : "操作失败", $this->createWebUrl("member"),  );
        } elseif($op == 'clearIntegral'){
            $memberIntegral = p_getcolumn('memberinfo', array('id' => $id), 'integral');
            $bool = $this->vote->change_integral($id, $memberIntegral, 12,'手动清空积分');
            json($bool ? "操作成功" : "操作失败", $bool ? 1 : 0);
        } elseif($op == 'clearInfo') {
            //$data = p_getall('memberinfo', array('fictitious' => 1));
            $data = p_fetchall("SELECT id,integral FROM ".prefix('memberinfo'). " WHERE fictitious = 1 AND integral > 0 AND uniacid = {$this->w['uniacid']} LIMIT 500");
            foreach ($data as $val) {
                if (!$this->vote->change_integral($val['id'], $val['integral'], 12, '手动批量清空积分')) {
                    json('error',  0);
                }
            }
            json('success',  1);
        } else {
            $page   = $this->get('page');
            $filed = $this->get('filed');
            if ($filed) {
                $where = "(id='{$filed}' OR nickname LIKE '%{$filed}%')";
            } else {
                $where  = "nickname != '' ";
            }
            $where .= get_uniacid();
            $memberInfo = $this->lucks->getTableList('memberinfo',$page, $where);
            if ($memberInfo['list']) {
                foreach ($memberInfo['list'] as & $value) {
                    $value['phone'] = p_getcolumn('address', array('member_id' => $value['id']), 'phone');
                    $value['address'] = p_getcolumn('address', array('member_id' => $value['id']), 'address');
                    $value['shopName'] = p_getcolumn('merchant', array('id' => $value['shop_id']), 'shop_name') ? : '未关联';
                    $value['number']  = p_getcolumn('senior_member', array('member_id' => $value['id']), 'number');
                    $value['bonus_level'] = $this->vote->memberDemotion($value['id']) ? : '不达标';
                }
            }
            include $this->template('member');
        }


    }

    public function doWebMemberLucK()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $behavior = $this->get('behavior');
        if ($behavior == 'edit') {
            $member_id = $this->get('member_id');
            $number = $this->get('number');
            $bool = $this->vote->change_senior($member_id, $number, 5 ,'后台给用户增加次数');
            message($bool ? "操作成功" : "操作失败", $this->createWebUrl("member"),  $bool ? 'success': 'error');
        } else {
            $member= p_get('memberinfo', array('id' => $this->get('id')));
            $senior_member = p_get('senior_member', array('member_id' => $member['id']));
            include $this->template('memberLuck');
        }


    }
    public function doWebMemberShop()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];

        $op = $this->get('op');
        $id = $this->get('id');
        if ($op == 'relevancy') {
            $shopId = $this->get('shop_id');
            if (empty($shopId) || empty($id)) {
                message( "请正确操作", $this->createWebUrl("member"),  'error');
            }
            $bool = p_update('memberinfo', array('shop_id' => (int)$shopId), array('id' => $id));
            message($bool ? "关联成功" : "关联失败", $this->createWebUrl("member"),  $bool ? 'success': 'error');
        } elseif($op == 'cancel'){
            $bool = p_update('memberinfo', array('shop_id' => 0),array('id' => $id));
            json('', $bool ? 1 : 0);
        } else {
            $member = p_get('memberinfo', array('id' => $id));
            $shop = p_getall('merchant');
            include $this->template('memberShop');
        }

    }
    public function doWebCategory()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "is_delete = 1 ".get_uniacid();
        $category = $this->lucks->getTableList('category',$page, $where);
        include $this->template('category');
    }

    public function doWebGoods()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "is_delete = 1 ".get_uniacid();
        $goodsName = $this->get('goodsName');
        if ($goodsName) {
            $where .= " AND name LIKE '%{$goodsName}%'";
        }
        $status = $this->get('status');
        if ($status) {
            $where .= " AND status ={$status}";
        }
        $goods = $this->lucks->getTableList('goods',$page, $where);
        if ($goods['list']) {
            foreach ($goods['list'] as & $value) {
                $value['category'] = $this->lucks->getCategoryName($value['category_id']);
            }

        }
        include $this->template('goods');
    }

    public function doWebQuestion()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "1 = 1 ".get_uniacid();
        $question = $this->lucks->getTableList('question',$page, $where);
        include $this->template('question');
    }

    public function doWebOperationQuestion()
    {
        $title   = $this->get('title');
        $content = $this->get('content');
        $sort    = $this->get('sort');
        $id    = $this->get('id');
        $bool = $this->lucks->addQuestion($title, $content, $sort, $id);
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("question"), $bool ? 'success': 'error');
    }
    public function doWebLuck()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "is_delete = 1 AND complete = 2 ".get_uniacid();
        $luckId = $this->get('luckId');
        if ($luckId) {
            $where .= " AND id=".$luckId;
        }

        if ($nickname = $this->get('nickname')) {
            $member_ids = $this->lucks->searchMember($nickname);
            if ($member_ids) {
                $where .= " AND member_id in ({$member_ids})";
            } else {
                $where .= '1=2';
            }

        }


        $lottery_type = $this->get('lottery_type');
        if ($lottery_type) {
            $where .= " AND lottery_type = {$lottery_type}";
        }
        $status = $this->get('status');
        if ($status) {
            $where .= " AND status = {$status}";
        }
        $luck_mode = $this->get('luck_mode');
        if ($luck_mode) {
            $where .= " AND luck_mode = {$luck_mode}";
        }
        $luck = $this->lucks->getTableList('luck',$page, $where);
        if ($luck['list']) {
            $xcx_path = 'bh_vote/pages/userGame/userGame';

            foreach ($luck['list'] as & $value){
                $value['luckCode'] = $this->vote->createWxCode($this, $value['member_id'] . '_' . $value['id'] . '_' . 0, $xcx_path, 'luck' . $value['id'] . '-' . 0 . '_' . $value['member_id'] . '.png');

                $value['examine_str'] = $this->examine[$value['examine']];
                $value['lottery_type_str'] = $this->luck_lottery_type[$value['lottery_type']];
                $value['luck_mode_str'] = $this->luck_luck_mode[$value['luck_mode']];
                if ($value['lottery_type'] == 1) {
                    $value['lottery_value'] = date('Y-m-d H:i:s', $value['lottery_value']);
                }
                $value['status_str'] = $this->luck_status[$value['status']];
                $memberLuck = $this->lucks->getLuckGoods($value['id']);
                $value['username'] = $this->lucks->getMemberName($memberLuck['member_id']);
                $value['luck_type'] = $this->luck_type[$memberLuck['type']];
                $value['luck_name'] = $memberLuck['name'];
                $value['luck_image'] = $memberLuck['image'] ? : $this->images('prize_default_picture', 'prize_default_picture.png');
                $value['luck_goods_number'] = $this->lucks->getLuckGoodsInfo($value['id']);
                $value['goods_id']  = $memberLuck['goods_id'];
                if ($value['id'] == 29) {
                    $value['is_prize'] = $this->lucks->getLuckIsPrize($value['id'], $memberLuck['goods_id']);
                }
                $value['luck_participate_count'] = $this->lucks->luckParticipateCount($value['id']);
                $value['luck_complaint'] = p_fetchcolumn("select count(*) from " . prefix("luck_complaint") . " where luck_id={$value['id']}" . get_uniacid()) ? : 0;
            }
        }
        //var_dump($this->vote->automaticArize(34));
        $is_personal = getConfig('is_personal');
        include $this->template('luck');
    }


    public function doWebGenerateOuterPath()
    {

        $option = array(
            'appid' => $this->w['uniaccount']['key'],
            'secret' => $this->w['uniaccount']['secret'],
        );
        $wxObj = new Wxadoc($option);

        $id = $this->get('id');

        $openlink= $wxObj->generatescheme(('id=' . $id), '', 'bh_vote/pages/userGame/userGame');
        $openLike = urlencode($openlink['openlink']);
        $outerPath =  "{$this->w['siteroot']}app/index.php?i={$this->w['uniacid']}&from=wxapp&c=entry&a=wxapp&do=bounce&m=bh_vote&openlink={$openLike}";

        header('Location: '. $outerPath . ' ');

    }
    public function doWebLuckGroup()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "1 = 1 ".get_uniacid();
        $luckGroup = $this->lucks->getTableList('luck_group',$page, $where);
        if ($luckGroup['list']) {
            foreach ($luckGroup['list'] as & $value) {
                $value['creatorUsername'] = $this->lucks->getMemberName($value['member_id']);
                $value['luckName'] = $this->lucks->getLuckGoodsName($value['luck_id']);
                $value['groupCount'] = $value['current_number'];
                $value['luckParticipate'] = $this->lucks->luckParticipate($value['id']);
            }

        }
        include $this->template('luckGroup');

    }

    public function doWebLuckGroupCount()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $group_id = $this->get('group_id');
        $where = "group_id = {$group_id}".get_uniacid();
        $luckGroupCount = $this->lucks->getTableList('group_member',$page, $where);
        if ($luckGroupCount['list']) {
            foreach ($luckGroupCount['list'] as & $value) {
                $value['participateName'] = $this->lucks->getMemberName($value['member_id']);
                $value['creatorUsername'] = $this->lucks->getMemberName($value['l_member_id']);

            }

        }
        include $this->template('luckGroupCount');
    }

    public function doWebLuckParticipate()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $group_id = $this->get('group_id');
        $where = "group_id = {$group_id}".get_uniacid();
        $luckParticipate = $this->lucks->getTableList('luck_participate',$page, $where);
        if ($luckParticipate['list']) {
            foreach ($luckParticipate['list'] as & $value) {
                $value['luckName'] = $this->lucks->getLuckGoodsName($value['luck_id']);
                $value['participationUsername'] = $this->lucks->getMemberName($value['member_id']);
            }
        }
        include $this->template('luckParticipate');
    }

    public function doWebTask()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');

        $where = "1 = 1".get_uniacid();
        $task = $this->lucks->getTableList('task',$page, $where);
        if ($task['list']) {
            $type = array(
                1 => '参加抽奖次数',
                2 => '发起抽奖',
                3 => '观看激励视频',
                4 => '试玩其他小程序',
            );
            foreach ($task['list'] as & $value) {
                $value['type'] = $type[$value['type']];
            }
        }
        include $this->template('task');
    }


    public function doWebIntegralGoods()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "1 = 1".get_uniacid();

        $goods_name = $this->get('goodsName');
        if ($goods_name) {
            $where .= " AND goods_name like '%{$goods_name}%'";
        }
        $status = $this->get('status');
        if ($status != 0) {
            $where .=  " AND status = {$status}";
        }
        $integralGoods = $this->lucks->getTableList('integral_goods',$page, $where);

        if ($integralGoods['list']) {
            foreach ($integralGoods['list'] as & $value) {
                $value['goods_name'] = strlen($value['goods_name']) > 10 ? mb_substr($value['goods_name'], 0, 10, 'UTF-8'). '....' : $value['goods_name'] ;
                $value['remnantInventory'] = p_getcolumn('order', array('goods_id' => $value['id']), 'COUNT(*)');

            }
        }
        include $this->template('integralGoods');
    }

    public function doWebLuckCodes()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "1 = 1".get_uniacid();

        $goods_name = $this->get('goodsName');
        if ($goods_name) {
            $where .= " AND goods_name like '%{$goods_name}%'";
        }
        $status = $this->get('status');
        if ($status != 0) {
            $where .=  " AND status = {$status}";
        }
        $luckCode = $this->lucks->getTableList('luck_code',$page, $where);
        if ($luckCode['list']) {
            foreach ($luckCode['list'] as & $value) {
                $luckCode['luckCodeNumber'] = p_getcolumn('luck_code', array('member_id' => $value['member_id']), 'COUNT(*)');
            }
        }
        include $this->template('luck_codes');
    }
    public function doWebAddOrder()
    {
        $id = $this->get('id');
        $op = $this->get('op');
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        if ($op == 'addShow') {
            $member = p_getall('memberinfo', array('fictitious' => 2));
            $goods = p_get('integral_goods', array('id' => $id));
            include $this->template('add_order');
        } elseif($op == 'add') {

            $data = array(
                'member_id' => $this->get('member_id'),
                'name' => $this->get('name'),
                'phone' => $this->get('phone'),
                'courier_name' => $this->get('courier_name'),
                'courier_number' => $this->get('courier_number'),
                'address' => $this->get('address'),
                'goods_id' => $this->get('goods_id'),
                'status' => 3,
                'is_pay' => 2,
                'delivery_time' => time(),
                'complete_time' => time() + (86400 * 3),
            );
            $bool = p_insert('order', $data);
            message($bool ? '操作成功': '操作失败', $this->createWebUrl("integralGoods"), $bool ? 'success': 'error');
        }else{


        }
    }
    public function doWebOperationTask()
    {
        $data = array(
            'type' => $this->get('type'),
            'number' => $this->get('number'),
            'title' => $this->get('title'),
            'integral' => $this->get('integral'),
            'appid' => $this->get('appid'),
            'path' => $this->get('path'),
            'sort' => $this->get('sort'),
        );
        $id = $this->get('id');
        if (!$id) {
            $data['created'] = time();
        }
        $bool = $id ? p_update('task', $data, array('id' => $id)) : p_insert('task' , $data);
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("task"), $bool ? 'success': 'error');
    }


    public function doWebOperationIntegralGoods()
    {
        $data = array(
            'type' => $this->get('type'),
            'goods_name' => $this->get('goods_name'),
            'share_title' => $this->get('share_title'),
            'exchange_type' => $this->get('exchange_type'),
            'original_price' => $this->get('original_price'),
            'money' => $this->get('money'),
            'exchange_number' => $this->get('exchange_number'),
            'cover_image' => $this->get('cover_image'),
            'image' => json_encode($this->get('image')),
            'is_free' => $this->get('is_free'),
            'free' => $this->get('free'),
            'inventory_type' => $this->get('inventory_type'),
            'inventory' => $this->get('inventory'),
            'introduce' => $this->get('introduce'),
            'allow_number' => $this->get('allow_number'),
            'status' => $this->get('status'),
            'sigin' => $this->get('sigin'),
            'sort' => $this->get('sort'),
        );
        if ($data['type'] ==2) {
            $relation_goods_id  = $this->get('relation_goods_id');
            $pddData = $this->lucks->detail($relation_goods_id);
            $data['relation_goods_id'] = $relation_goods_id;
            $data['goods_name'] = $pddData['goods_name'];
            $data['original_price'] = $pddData['min_normal_price'] / 100;
            $data['cover_image'] = $pddData['goods_image_url'];
            $data['image'] = json_encode($pddData['goods_gallery_urls']);
            $data['inventory'] = mt_rand(90, 500);
        }
        $id = $this->get('id');
        if (!$id) {
            $data['created'] = time();
        }
        if ($shop_ids = $this->get('shop_ids')) {
            $data['shop_ids'] = implode(',', $shop_ids);
        }
        if ($data['type'] == 3 &&  empty($data['shop_ids']) ) {
            message('请选择商家', $this->createWebUrl("integralGoods"),  'error');
        }
        $bool = $id ? p_update('integral_goods', $data, array('id' => $id)) : p_insert('integral_goods' , $data);
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("integralGoods"), $bool ? 'success': 'error');
    }
    public function doWebIntegralLog()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "1 = 1 ". get_uniacid();


        if ($nickname = $this->get('nickname')) {
            $where .= " AND member_id in ({$this->getMemberId($nickname)})";
        }

        $end = date('Y-m-d');
        $created = $this->get('created');
        if (!$created || empty($created['start'])) {
            $created = array(
                'start' => date('Y-m-d', strtotime($end) - (86400 * 6)) ,
                'end'   => $end
            );
        }
        $where .= " AND  created BETWEEN ". strtotime($created['start']). " AND ". (strtotime($created['end']) + 86400);


        $integralLog = $this->lucks->getTableList('integral_log',$page, $where);
        if ($integralLog['list']) {
            $type = array(
                1 => '签到',
                2 => '签到翻倍',
                3 => '兑换礼品',
                4 => '完成任务',
                5 => '接口加积分',
                6 => '接口减积分',
                7 => '积分抽奖',
                8 => '取消订单,退回积分',
                9 => '积分清零',
                10 => '兑换红包',
                11 => '升级分红等级',
                12 => '手动清除积分',
                13 => '中奖赠送积分',
                14 => '集字消耗',

            );
            foreach ($integralLog['list'] as & $value) {
                $value['type'] = $type[$value['type']];
                $value['name'] = $this->lucks->getMemberName($value['member_id']);
            }
        }
        include $this->template('integralLog');
    }


    public function doWebTaskMember()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $member_id = $this->get('member_id');
        $where = "1 = 1 ".get_uniacid();

        if ($member_id) {
            $where .= " AND member_id ={$member_id}";
        }
        $taskMember = $this->lucks->getTableList('task_member',$page, $where);
        if ($taskMember['list']) {

            foreach ($taskMember['list'] as & $value) {
                $value['task'] = p_getcolumn('task', array('id' => $value['task_id']), 'title');
                $value['name'] = $this->lucks->getMemberName($value['member_id']);
            }
        }
        include $this->template('taskMember');
    }


    public function doWebMemberLog()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "1 = 1 ".get_uniacid();
       /* $seniorMemberLogId = $this->get('id');
        if ($seniorMemberLogId) {
            $where .= " AND remarks =" .$seniorMemberLogId;
        }*/
        $memberLog = $this->lucks->getTableList('senior_member_log',$page, $where);
        if ($memberLog['list']) {
            foreach ($memberLog['list'] as & $value) {
                $value['type'] = $this->member_log_type[$value['type']];
                $value['name'] = $this->lucks->getMemberName($value['member_id']);
            }
        }
        include $this->template('memberLog');
    }

    public function doWebRecommendManage()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "1 = 1 ".get_uniacid();
        $home = $this->lucks->getTableList('home',$page, $where);
        if ($home['list']) {
            foreach ($home['list'] as & $value) {
                if ($value['type'] == 2 ) {
                    $value['image'] = $value['image'] ? getImage($value['image']) : getVoteImageCover($this->lucks->getVote_activityOne($value['relation_id']));
                } else {
                    $value['image'] = $value['image'] ? getImage($value['image']) : '';
                }
                $value['position'] = $this->homePosition[$value['position']];
                $value['type'] = $this->homeType[$value['type']];
            }
        }


        include $this->template('recommendManage');
    }


    public function doWebBarrage()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "1 = 1 ".get_uniacid();
        $voteDanMu = $this->lucks->getTableList('vote_danmu',$page, $where);
        if ($voteDanMu['list']) {
            foreach ($voteDanMu['list'] as & $value) {
                $activity = $this->lucks->getVote_activityOne($value['activity_id']);
                $value['nickname'] = $this->lucks->getMemberName($value['uid']);
                $value['activityName'] =$activity['title'];
                $value['ballplayer'] = $this->lucks->getMemberName($value['join_id']);
            }
        }
        include $this->template('barrage');
    }
    public function doWebEditRecommend()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $homeId = $this->get('homeId');
        $column_data = $this->lucks->getHomeOne($homeId);
        $type  = $column_data['type'];
        include $this->template('luck_recommend');
    }
    public function doWebRecommend()
    {

        $position = $this->get('position');
        $start = $this->get('start');
        $end = $this->get('end');
        $type = $this->get('type');
        $relation_id = $this->get('relation_id');
        $homeId = $this->get('homeId');
        $image = $this->get('image');
        $sort = $this->get('sort');
        $tag = $this->get('tag');
        $tag_bg_color = $this->get('tag_bg_color');
        if (!$homeId) {
            if ($this->lucks->checkRecommend($relation_id, $position, $type)) {
                message('已经推荐过了,请重新推荐', $this->createWebUrl('recommendManage'));
            }
        }
        $bool = $this->lucks->addRecommend($homeId, $relation_id, $type, $position, strtotime($start), strtotime($end), $image, $sort,$tag,$tag_bg_color);
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("recommendManage"), $bool ? 'success': 'error');
    }
    public function doWebComplaint()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "1 = 1 ".get_uniacid();
        $luck_id = $this->get('luck_id');
        if ($luck_id) {
            $where .= " AND luck_id = {$luck_id}";
        }
        $luckComplaint = $this->lucks->getTableList('luck_complaint',$page, $where);
        if ($luckComplaint['list']) {
            foreach ($luckComplaint['list'] as & $value) {
                $value['name'] = $this->lucks->getMemberName($value['member_id']);
            }
        }
        include $this->template('luckComplaint');
    }
    public function doWebVoteComplaint()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "1 = 1 ".get_uniacid();
        $vote_id = $this->get('vote_id');
        if ($vote_id) {
            $where .= " AND vote_id = {$vote_id}";
        }
        $voteComplaint = $this->lucks->getTableList('vote_complaint',$page, $where);
        if ($voteComplaint['list']) {
            foreach ($voteComplaint['list'] as & $value) {
                $value['name'] = $this->lucks->getMemberName($value['member_id']);
            }
        }
        include $this->template('voteComplaint');
    }
    public function doWebAddress()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $filed = $this->get('filed');
        $where = "1 = 1 ".get_uniacid();
        $member_ids = $this->lucks->searchMember($filed);
        if ($member_ids) {
            $where .= " AND member_id in ({$member_ids})";
        }
        $address = $this->lucks->getTableList('address',$page, $where);
        if ($address['list']) {
            foreach ($address['list'] as & $value) {
                $value['nickname'] = $this->lucks->getMemberName($value['member_id']);
            }
        }
        include $this->template('address');
    }
    public function doWebAdvertisement()
    {
        $siteRoot       = $this->siteRoot;
        $modular_name   = $this->gpc['m'];
        $page   = $this->get('page');
        $where  = "1 = 1 ".get_uniacid();
        $advertise = $this->lucks->getTableList('advertisement',$page, $where);
        if ($advertise['list']) {
            foreach ($advertise['list'] as & $value) {
                $value['position']  = $this->advertise_position[$value['position']];
                $value['type']      = $this->advertise_type[$value['type']];
            }
        }

        include $this->template('advertise');
    }

    public function doWebAuthentication()
    {
        $siteRoot       = $this->siteRoot;
        $modular_name   = $this->gpc['m'];
        $page   = $this->get('page');
        $where  = "1 = 1 ".get_uniacid();
        $authentication = $this->lucks->getTableList('authentication',$page, $where);
        if ($authentication['list']) {
            foreach ($authentication['list'] as & $value) {
                $value['statusStr'] = $this->authenticationStatus[$value['status']];
                $value['auth_images'] = $this->getSubmission($value['image']);
            }
        }

        include $this->template('authentication');
    }


    public function getSubmission($submission, $type = 1)
    {
        if ($submission) {
            $data = json_decode($submission, true);
            $string = "";
            foreach ($data as $val) {
                $src = $type == 1 ? getImage($val['path']) : getImage($val);
                $string .= "<img class='img' src='{$src}' width='60px' height='60px'>";
            }
            return $string;
        }
        return '';
    }
    public function doWebAuthenticationHandle()
    {
        $id     = $this->get('id');
        $type   = $this->get('type');
        $bool   = $this->lucks->authenticationHandle($id, $type);
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("authentication"), $bool ? 'success': 'error');
    }
    public function doWebGoodsFeedback()
    {
        $siteRoot       = $this->siteRoot;
        $modular_name   = $this->gpc['m'];
        $page   = $this->get('page');
        $where  = "1 = 1 ".get_uniacid();
        $goodsFeedback = $this->lucks->getTableList('goods_feedback',$page, $where);

        if ($goodsFeedback['list']) {
            foreach ($goodsFeedback['list'] as & $value) {
                $value['name'] = $this->lucks->getMemberName($value['member_id']);
            }
        }
        include $this->template('goods_feedback');
    }
    /**
     * 高级版本
     */
    public function doWebSenior()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "is_delete= 1 ".get_uniacid();
        $senior = $this->lucks->getTableList('senior',$page, $where);
        include $this->template('senior');
    }
    public function doWebPayOrder()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');

        $where = "1 = 1 ".get_uniacid();

        $nickname = $this->get('nickname');
        $member_ids = $this->lucks->searchMember($nickname);
        if ($member_ids) {
            $where .= " AND member_id in ({$member_ids})";
        }
        $memberId = $this->get('memberId');
        if($memberId){
            $where .= " AND member_id = {$memberId}";
        }
        $time = $this->get('time');
        if ($time) {
            $where .= " AND created <=".strtotime($time);
        }

        $payOrder = $this->lucks->getTableList('pay_order',$page, $where);
        if ($payOrder['list']) {
            foreach ($payOrder['list'] as & $value) {
                $value['nickname'] = $this->lucks->getMemberName($value['member_id']);
                $value['type'] = $this->parOrderType[$value['type']];
                $corePayLog = p_fetch("SELECT uniontid FROM ims_core_paylog WHERE uniacid ={$this->w['uniacid']} AND  `module` = 'bh_vote' AND tid = {$value['trade_no']}");
                $value['transaction_id'] = $corePayLog['uniontid'];
            }
        }

        include $this->template('payOrder');
    }

    /**
     *  栏目 添加 or 编辑  页面
     *
     */
    public function doWebOperation()
    {
        $column = $this->get('column');
        $op = $this->get('behavior');
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $voteActivityId  = $this->get('voteActivityId');
        if ($voteActivityId) {
            $voteActivityBasis = $this->lucks->getVoteActivityBasis($voteActivityId);
        }
        if ($id = $this->get('id')) {
            $function = "get".ucfirst($column)."One";
            $column_data = $this->lucks->$function($id);
        }
        if ($column == 'goods') {
            $column_data['category'] = $this->lucks->getCategory();
            $column_data['images'] = json_decode($column_data['images']);
        }
        if ($column == 'luck') {
            $column_data['goods'] = $this->lucks->getGoods();
            $column_data['image_text'] = json_decode($column_data[0]['image_text'], true);

            //var_dump($column_data['image_text']);
            $member = $this->lucks->getParticipate($id);
            $luckGoods = $this->lucks->getLuckGoodsAll($id);
            $type = $this->get('type');
            $luck_goods_info_id = $this->get('luck_goods_info_id');
            if ($column_data[0]['sponsor_type'] == 2) {
                $sponsor = json_decode($column_data[0]['sponsor_text'], true);
                if ($sponsor['type'] == 1) {
                    $column_data[0]['sponsor_image'] =  $sponsor['image'];
                } else {
                    $column_data[0]['appid'] =  $sponsor['appid'];
                    $column_data[0]['path'] =  $sponsor['path'];
                }
                $column_data[0]['type'] =  $sponsor['type'];
            }
        }
        if ($column == 'launch') {
            $column_data['describe'] = implode('|',json_decode($column_data['describe'], true));
            $bgColor = json_decode($column_data['bgcolor'], true);
            $column_data['bgColorStart'] =$bgColor[0];
            $column_data['bgColorEnd'] =$bgColor[1];
        }
        if ($column == 'vote_activity') {
            $column_data['goods'] = $this->lucks->getGoods();
            $describe_img = json_decode($column_data['describe_img'],true);

            $column_data['describe_img'] = array_column($describe_img, 'path');
            if ($column_data['end_type'] == 2) {
                $column_data['end_number'] = $column_data['end_time'];
            }
            $column_data['vote_template'] = $this->lucks->voteTemplate();

        }
        if ($op == 'recommend') {
            $homeInfo = $this->lucks->getRelationIdOne($id);
            $homeId = $homeInfo['id'];
        }
        if ($op == 'interact') {
            $fictitiousMember = $this->lucks->getMemberFictitious();
        }
        if ($column == 'vote') {
            $column_data['goods'] = $this->lucks->getGoods();
            $column_data['image_text'] = json_decode($column_data[0]['image_text'], true);
            $luckGoods = $this->lucks->getLuckGoodsAll($id);
        }
        if ($column == 'vote_join') {
            $column_data['thumb'] = json_decode($column_data['thumb'], true);
        }
        if ($column == 'shop') {
            $column_data['shop'] = p_getall('salesman');
        }
        if ($column == 'shop_category') {
            $column_data['shop'] = p_getall('shop');
        }
        if ($column == 'integral_goods') {
            $column_data['category'] = $this->lucks->getGoodsCategory();
            $column_data['salesman'] = $this->lucks->getGoodsSalesman();
            $column_data['shop'] = $this->lucks->getGoodsShop();

            $column_data['image'] = json_decode($column_data['image'], true);
            $shopIds = array();
            if ($shop_ids = p_getcolumn('integral_goods', array('id' => $id), 'shop_ids')) {
                $shopIds = explode(',', $shop_ids);
            }
        }
        $isIntegralUser = $this->vote->isIntegralUser();
        $shop = p_getall('merchant');
        include $this->template($column.'_'.$op);
    }

    public function doWebOperationMember()
    {
        $nickname = $this->get('nickname');
        $headImgUrl = $this->get('headimgurl');
        $bool = $this->lucks->addMember($nickname, getImage($headImgUrl));
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("luck"), $bool ? 'success': 'error');
    }
    public function doWebOperationSenior()
    {
        $behavior = $this->get('behavior');
        $number = $this->get('number');
        $money = $this->get('money');
        if ($behavior == 'add') {
            $bool = $this->lucks->addSenior($number, $money);
        } else {
            $id = $this->get('id');
            $bool = $this->lucks->editSenior($id, $number, $money);
        }
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("senior"), $bool ? 'success': 'error');
    }

    public function doWebOperationCategory()
    {
        $behavior = $this->get('behavior');
        $name = $this->get('name');
        $sort = $this->get('sort');
        $is_delete = $this->get('is_delete');
        if ($behavior == 'add') {
            $bool = $is_delete == 2 ? true : $this->lucks->addCategory($name, $sort, $is_delete);
        } else {
            $id = $this->get('id');
            $bool = $this->lucks->editCategory($id, $name, $sort, $is_delete);
        }
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("category"), $bool ? 'success': 'error');
    }

    public function doWebOperationGoods()
    {
        $behavior       = $this->get('behavior');
        $category_id    = $this->get('category_id');
        $name           = $this->get('name');
        $price          = $this->get('price');
        $cover_image    = $this->get('cover_image');
        $images         = json_encode($this->get('images'));
        $details        = $this->get('details');
        $sort           = $this->get('sort');
        $status         = $this->get('status');
        if ($behavior == 'add') {
            $bool = $this->lucks->addGoods($category_id, $name, $price, $cover_image, $images, $details, $sort, $status);
        } else {
            $id = $this->get('id');
            $bool = $this->lucks->editgoods($id, $category_id, $name, $price, $cover_image, $images, $details, $sort, $status);
        }
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("goods"), $bool ? 'success': 'error');
    }

    public function doWebOperationAdvertise()
    {
        $behavior   = $this->get('behavior');
        $title      = $this->get('title');
        $image      = $this->get('image');
        $position   = $this->get('position');
        $type       = $this->get('type');
        $group_id   = $this->get('group_id');
        $appId      = $this->get('appid');
        $url        = $this->get('url');
        $sort       = $this->get('sort', 1);
        $describe   = $this->get('describe');

        if ($behavior == 'add') {
            $bool = $this->lucks->addAdvertise($title, $image, $position, $type, $group_id, $appId, $url, $sort, $describe);
        } else {
            $id = $this->get('id');
            $bool = $this->lucks->addAdvertise($title, $image, $position, $type, $group_id, $appId, $url, $sort,$describe, $id);
        }
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("advertisement"), $bool ? 'success': 'error');
    }
    public function doWebOperationLuck()
    {

        $behavior   = $this->get('behavior');
        $source     = $this->get('source');
        $number     = $this->get('number');
        $lottery_type = $this->get('lottery_type');
        $member_id  = $this->get('member_id');
        $appoint_group = $this->get('appoint_group');
        $is_share = $this->get('is_share');
        $automatic = $this->get('automatic');
        if (in_array($lottery_type, array(1, 6))) {
            $lottery_value = strtotime($this->get('lottery_value'));
        } else {
            $lottery_value = $this->get('lottery_value_people');
        }

        $luck_mode = $this->get('luck_mode');
        if ($luck_mode == 4) {
            $luck_pwd = $this->get('luck_pwd');
        }
        if ($luck_mode == 2) {
            $team_number = $this->get('team_number');
        }
        $lottery_explain = $this->get('lottery_explain');
        $image_text      = $this->get('image_text');

        if ($image_text) {
            $image_text = json_encode($this->lucks->getImagesText($image_text));
        }
        if ($source == 2) {
            $name       = $this->get('name');
            $image      = $this->get('image');
        } else {
            $goods_id   = $this->get('goods_id');
            $goodsInfo  = $this->lucks->getGoodsOne($goods_id);
            $name       = $goodsInfo['name'];
            $image      = $goodsInfo['cover_image'];
        }
        $type = $this->get('type');

        if ($type == 2) {
            $fictitious = $this->get('fictitious', '');
        }
        $isAd = $this->get('is_ad');

        if ($isAd == 3) {
            $integral = $this->get('integral');
        }
        $sponsor = $this->get('sponsor');
        $sponsor_type = $this->get('sponsor_type');
        if ($sponsor_type == 1) {
            $sponsor_text = $this->get('sponsor_text');
        } elseif($sponsor_type == 2) {
            $type_type = $this->get('type_type');
            if ($type_type == 1) {
                $data = array(
                    'type'  => $type_type,
                    'image' => $this->get('sponsor_image'),
                );
            } else {
                $data = array(
                    'type'   => $type_type,
                    'appid'  => $this->get('appid'),
                    'path'   => $this->get('path'),
                );
            }
            $sponsor_text = json_encode($data);
        } else{
            $sponsor_text = $this->get('sponsor_text');
        }



        if ($luck_mode == 2 && $lottery_type !=5) {
            if ($number % $team_number > 0) {
                message("奖品数量必须为成团人数的整数倍", $this->createWebUrl("Luck"), 'error');
            }
        }
        $receive_type = $this->get('receive_type');
        $receive_url = $this->get('receive_url');
        $loop = $this->get('loop');
        $is_screen = $this->get('is_screen');

       /* $is_fans = $this->get('is_fans');
        $fans_url = '';
        if ($is_fans) {
            $fans_url = $this->get('fans_url');
        }*/
        $group_money = 0;
        if ($lottery_type ==5) {
            $invite_sh = (int)$this->get('invite_sh');
            $luck_mode = 2;
            $team_number = $team_number ? $team_number : 15 ;
            $group_money = $this->get('group_money');
        }

        $is_double = $this->get('is_double', 1);


        if ($behavior == 'add') {
            $bool = $this->lucks->editingLuck($source, $lottery_type, $lottery_value,$member_id,
               $lottery_explain ,$image_text, $luck_mode, $luck_pwd,$team_number, $name, $image, $type,$fictitious,
                $number, $goods_id, $isAd,$sponsor,$sponsor_type,$sponsor_text ,$appoint_group, $integral,$is_share,$automatic, $receive_type, $receive_url, $loop, $is_screen, $invite_sh,$group_money,$is_double);
        } else {
            $id = $this->get('id');
            $bool = $this->lucks->editingLuckData($id, $source, $lottery_type, $lottery_value,$member_id,
                $lottery_explain ,$image_text, $luck_mode, $luck_pwd,$team_number, $name, $image, $number, $goods_id, $isAd,
                $sponsor,$sponsor_type,$sponsor_text, $appoint_group, $integral,$is_share, $receive_type, $receive_url, $loop, $is_screen, $invite_sh,$group_money,$is_double);
        }

        message($bool ? '操作成功': '操作失败', $this->createWebUrl("Luck"), $bool ? 'success' : 'error');
    }

    public function doWebCompile()
    {

        $op = $this->get('op');
        $id = $this->get('id');
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $isIntegralUser =  $this->vote->isIntegralUser();

        $is_union =  $this->vote->is_union();
        $code = $this->getCode($id);
        if ($op == 'editShow') {
            $luck = p_get('luck', array('id' => $id));
            include $this->template('luck_edit');
        } elseif($op == 'edit') {
            $data = array(
                'is_new'  => $this->get('is_new'),
                'share_images'  => $this->get('share_images'),
                'is_share'      => $this->get('is_share'),
                'is_ad'         => $this->get('is_ad'),
                'appoint_group' => $this->get('appoint_group'),
                'lottery_type'  => $this->get('lottery_type'),
                'luck_mode'     => $this->get('luck_mode'),
                'lottery_explain'=> $this->get('lottery_explain'),
                'automatic'     => $this->get('automatic'),
                'receive_type'  => $this->get('receive_type'),
                'receive_url'   => $this->get('receive_url'),
                'loop'          => $this->get('loop'),
                'is_screen'     => $this->get('is_screen'),
                'is_fans'       => $this->get('is_fans'),
                'fans_url'      => $this->get('fans_url'),
                'invite_sh'     => (int)$this->get('invite_sh') ,
                'group_money'   => $this->get('group_money') ,
                'prize_integral'=> $this->get('prize_integral') ,
                'is_cover_bag' => $this->get('is_cover_bag') ,
                'is_double' => $this->get('is_double', 1) ,
            );

            if ($data['luck_mode'] == 2) {
                $data['team_number'] = $this->get('team_number');
            }
            if ($data['luck_mode'] == 4) {
                $data['luck_pwd'] = $this->get('luck_pwd');
            }
            if (in_array($data['lottery_type'], array(1, 6))) {
                $data['lottery_value'] =strtotime($this->get('lottery_value'));
            }
            if ($data['lottery_type'] ==2) {
                $data['lottery_value'] = $this->get('lottery_value_people');
            }
            if ($data['is_ad'] == 3) {
                $data['integral'] = $this->get('integral');
            }
            $bool = p_update('luck', $data, array('id' => $id));
            message($bool ? '修改成功': '修改失败', $this->createWebUrl('luck'), $bool ? '': 'error');

        }

    }

    protected function getCode($id)
    {
        $str = '<a data-miniprogram-appid="'.$this->w['account']['key'].'" data-miniprogram-path="bh_vote/pages/userGame/userGame?id='.$id.'" data-miniprogram-nickname="'.getConfig('xcx_title').'" href="" data-miniprogram-type="text" data-miniprogram-servicetype="">点我参与抽奖</a>';
        return $str;

    }
    public function doWebLuckCode()
    {
        $id = $this->get('id');
        $luckId = $this->get('luckId');
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "1=1".  get_uniacid();
        if ($luckId) {
            $where .= " AND luck_id = {$luckId} ";
        }
        $op = $this->get('op');
        if ($nickname = $this->get('nickname')) {
            $where .= " AND member_id in ({$this->getMemberId($nickname)})";
        }
        if ($op == 'assign') {
            $luck_code = p_get('luck_code', array('id' => $id));
        } elseif ($op == 'delete') {
            $bool = p_delete('luck_code', array('id' => $id));
            json('', $bool ? 1 : 0 );
        } else {
            $luckCode = $this->lucks->getTableList('luck_code', $page, $where);
            if ($luckCode['list']) {
                foreach ($luckCode['list'] as & $value){
                    $value['number'] = p_getcolumn('luck_code', array('member_id' => $value['member_id'], 'luck_id' => $value['luck_id']), 'COUNT(*)');
                    $value['nickname'] = $this->lucks->getMemberName($value['member_id']);
                    $value['inviteNickname'] = $this->lucks->getMemberName($value['invitation_member_id']);
                    $value['is_appoint']     = $value['is_appoint'] == 1 ? '不指定' : '指定';
                    $value['in_prize'] = $value['in_prize'] ==1 ? '未中奖' : '中奖';

                }
            }
        }




        include $this->template('luck_code');
    }

    public function doWebCheckGoods()
    {
        $luck_id = $this->get('id');
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $column = $this->get('column');
        $behavior = $this->get('behavior');
        $page = $this->get('page');
        $where = "luck_id = {$luck_id} ".get_uniacid();
        $luckGoods = $this->lucks->getTableList('luck_goods', $page, $where);
        if ($luckGoods['list']) {
            foreach ($luckGoods['list'] as & $value){
                $value['image'] = $value['image'] ? : $this->images('prize_default_picture', 'prize_default_picture.png');
                $value['nickname'] = $this->lucks->getMemberName($value['member_id']);
                $value['types']     = $this->luck_type[$value['type']];
                $value['in_prize'] = $this->lucks->getLuckIsPrize($value['id'], $value['goods_id']);
                $value['merchant'] = p_getcolumn('merchant', array('id' => $value['shop_id']), 'shop_name') ? : '非商家';
                $value['underLine'] = $value['type'] == 2 ?  $value['is_under_line'] ==1 ? '线上' : '线下' : '非核销';
            }
        }
        include $this->template($column.'_'.$behavior);
    }


    public function doWebLuckAddGood()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $luck_id = $this->get('id');
        $op = $this->get('op');
        $luck = p_get('luck', array('id' => $luck_id));
        if ($op == 'add') {
            $luckId     = $this->get('luck_id');
            $name       = $this->get('name');
            $coverImage = $this->get('cover_image');
            $number     = $this->get('number');
            $type       = $this->get('type');
            $fictitious = $this->get('fictitious');

            $fictitiousData = array();
            $isAutomatic = 0;
            if ($type ==2) {
                $underLine = array(
                    'is_under_line' => $this->get('is_under_line'),
                    'shop_id'       => $this->get('shop_id')
                );
                if ($underLine['is_under_line'] == 2) {
                    $isAutomatic = $this->get('isAutomatic');
                }

                if ($underLine['is_under_line'] ==2 && $isAutomatic !=1) {
                    $fictitiousData = explode(',' , $fictitious);
                    if ( $number != count($fictitiousData)) {
                        message('兑换码和分数不相等', $this->createWebUrl('luck'),  'error');
                    }
                }

                if ($underLine['is_under_line'] ==1) {
                    $fictitiousData = explode(',' , $fictitious);
                    if ($number != count($fictitiousData)) {
                        message('兑换码和分数不相等', $this->createWebUrl('luck'),  'error');
                    }
                }
            }

            if ($type ==3) {
                $redData = array(
                    'red_type' => $this->get('red_type'),
                    'red_money' => $this->get('red_money')
                );
            }

            if ($luck['luck_mode'] ==2 && $type ==3) {
                message('组队抽奖不支持红包商品', $this->createWebUrl('luck'),  'error');
            }
            $probability = 0;
            if ($luck['lottery_type'] == 6) {
                $probability = $this->get('probability');

            }
            $bool = (new vote())->addVoteGoods($luckId, $name, $coverImage, $number, $type, $fictitiousData, $redData, $underLine, $isAutomatic, $probability);
            message( $bool ? '成功' : '失败', $this->createWebUrl('luck'));
        } else {
            $luckMode = array(
                1 => '普通抽奖',
                2 => '组队抽奖',
                3 => '好友助力',
                4 => '口令抽奖'
            );

            $luckModes = $luckMode[$luck['luck_mode']];
            $shop  = p_getall('merchant');
            include $this->template('luck_goods_2');
        }

    }

    public function doWebLuckAddGoodRed()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $luck_id = $this->get('id');
        $op = $this->get('op');
        $luck = p_get('luck', array('id' => $luck_id));
        if ($op == 'add') {
            $data = array(
                'luck_id' => $this->get('luck_id'),
                'name' => $this->get('name'),
                'image' => $this->get('image'),
                'number' => $this->get('number'),
                'type' => 3,
                'red_money' => $this->get('red_money'),
                'created' => time(),
            );
            if ($data['number'] > p_getcolumn('luck', array('id' => $data['luck_id']), 'team_number')) {
                message('红包份数不能大于组队人数', $this->createWebUrl('luck'),  'error');
            }
            if (p_get('luck_goods', array('luck_id' => $data['luck_id']))) {
                p_delete('luck_goods', array('luck_id' => $data['luck_id']));
            }
            p_insert('luck_goods', $data);
            message('添加成功', $this->createWebUrl('luck'),  'success');
        } else {
            include $this->template('luck_goods_red');
        }



    }

    public function doWebDelLuckGood()
    {
        $id = $this->get('id');

        $luckGoods = p_get('luck_goods', array('id' => $id));
        $luck = p_get('luck', array('id' => $luckGoods['luck_id']));
        if ($luckGoods && $luck) {
            p_update('luck', array('prize_number' => $luck['prize_number'] - $luckGoods['number']), array('id' => $luck['id']));
            p_delete('luck_goods', array('id' => $id));
            p_delete('luck_goods_info', array('luck_goods_id' => $id));
        }

        json('', 1);
    }
    public function doWebGetLuckParticipate()
    {
        $nickname = $this->get('nickname');
        $luck_id = $this->get('luck_id');
        $table = prefix('luck_participate');
        $nData = array();
        if ($nickname) {
            $where = " member_id in ({$this->getMemberId($nickname)})" . get_uniacid();
            if ($luck_id) {
                $where .= " AND luck_id={$luck_id}";
            }
            //var_dump("SELECT member_id FROM {$table} WHERE {$where} ORDER BY id DESC ");
            $nData = p_fetchall("SELECT member_id FROM {$table} WHERE {$where} ORDER BY id DESC ");
            if ($nData) {
                foreach ($nData as & $value) {
                    $value['nickname'] = $this->lucks->getMemberName($value['member_id']);
                }
            }
        }
        json($this->getStr($nData));
    }

    protected function getStr($nData)
    {
        $str = "<option value='0'>请选择</option>";
        if ($nData) {
            foreach ($nData as $val) {
                $str .= "<option value='".$val['member_id']."'>{$val['member_id']}-{$val['nickname']}</option>";
            }
        }
        return $str;
    }

    public function doWebCheckGoodsDetails()
    {
        $luck_id = $this->get('id');
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $luckGoodsDetails = $this->lucks->getLuckGoodsInfoAll($luck_id);
        if($luckGoodsDetails) {
            foreach ($luckGoodsDetails as & $val) {
                $val['nickname'] = $this->lucks->getMemberName($val['member_id']) ? : '后台提供';
                $val['types'] = $this->luck_type[$val['type']];
                $val['merchant'] = p_getcolumn('merchant', array('id' => $val['shop_id']), 'shop_name') ? : '非商家';
                $val['underLine'] = $val['type'] == 2 ?  $val['is_under_line'] ==1 ? '线上' : '线下' : '非核销';
                $val['verifier'] = $this->lucks->getMemberName($val['write_off_id']) ? : '未核销';
                $val['verifierTime'] = ($val['shop_id'] > 0  && !empty($val['write_off_time']))  ? date('Y-m-d H:i', $val['write_off_time']) : '未核销';
                if ($val['is_appoint'] == 2) {
                    $member_id = p_getcolumn('luck_participate', array('id' => $val['appoint_id']), 'member_id');
                    $val['nominator'] = '昵称:' .p_getcolumn('memberinfo', array('id' => $member_id), 'nickname') . 'id:'.$member_id;
                }
            }
        }
        include $this->template('luck_goods_assign');
    }

    public function doWebLaunch()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "1 = 1".get_uniacid();
        $launch = $this->lucks->getTableList('launch', $page, $where);
        if ($launch['list']) {
            foreach ($launch['list'] as & $value) {
                if ($value['describe']) {
                    $value['describe'] = implode('|', json_decode($value['describe'], true));
                }
            }
        }
        include $this->template('launch');
    }

    public function doWebOperationLaunch()
    {
        $name = $this->get('name');
        $icon = $this->get('icon');
        $path = $this->get('path');
        $sort = $this->get('sort');
        $id   = $this->get('id');
        $status   = $this->get('status');
        $subtitle = $this->get('subtitle');
        $tags = $this->get('tags');
        $bool = $this->lucks->editLaunch($name, $subtitle, $icon, $path, $tags, $sort, $status, $id);
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("launch"), $bool ? 'success' : 'error');
    }
    public function doWebOperationLuckGoods()
    {
        $goods_id = $this->get('goods_id');
        $luck_id  = $this->get('id');
        $number   = $this->get('number');

        $bool = $this->lucks->addLuckGoods($luck_id, $goods_id, $number);
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("Luck"), $bool ? 'success' : 'error');
    }
    public function doWebOperationLuckPeople()
    {
        $memberId = $this->get('member_id');
        $luckId   = $this->get('id');
        $goods_id = $this->get('goods_id', 0);
        $luck = p_get('luck', array('id' => $luckId));


        if (is_array($memberId)) {
            $bool = true;
            foreach ($memberId as $value) {
                if (!$this->getLuckMember($value, $luckId)) {
                    message('用户与这期抽奖不在一个平台下不能指定', $this->createWebUrl("Luck"), 'warning');
                }
                if (!$this->lucks->addLuckPeople($luckId, $value, $goods_id)) {
                    $bool = false;
                } else {
                    if ($luck['luck_mode'] == 3) {
                        $this->vote->create_luck_code($value, $luckId);
                    }
                }
            }
        } else {
            if (!$this->getLuckMember($memberId, $luckId)) {
                message('用户与这期抽奖不在一个平台下不能指定', $this->createWebUrl("Luck"), 'warning');
            }
            $bool = $this->lucks->addLuckPeople($luckId, $memberId, $goods_id);
            if ($bool) {
                if ($luck['luck_mode'] == 3) {
                    $this->vote->create_luck_code($memberId, $luckId);
                }
            }
        }

        if ($luck['lottery_type'] == 2) {
            $count = p_getcolumn('luck_participate', array('luck_id' => $luckId), 'COUNT(*)');
            if ($count >= $luck['lottery_value']) {
                (new vote())->lottery($luckId);
            }
        }
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("Luck"), $bool ? 'success' : 'error');
    }

    /**
     *
     * @param $memberId
     * @param $luckId
     * @return bool
     */
    protected function getLuckMember($memberId, $luckId)
    {
        $mUniacid = pdo_getcolumn('memberinfo', array('id' => $memberId), 'uniacid');
        $LUniacid = pdo_getcolumn('luck', array('id' => $luckId) , 'uniacid');
        if ($mUniacid != $LUniacid) {
            return false;
        }
        return true;

    }
    public function doWebOperationLuckAssign()
    {
        $memberId = $this->get('member_id');
        $luckId   = $this->get('id');
        $luck_goods_info_id   = $this->get('luck_goods_info_id');
        $bool = $this->lucks->addLuckAssign($luckId, $memberId, $luck_goods_info_id);
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("Luck"), $bool ? 'success' : 'error');
    }

    public function doWebLuckCancel()
    {
        $luck_id = $this->get('luck_id');
        $goods_id = $this->get('goods_id');

        $bool = $this->lucks->cancelLuck($luck_id, $goods_id);
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("Luck"), $bool ? 'success' : 'error');
    }
    public function doWebPosters()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $posters = $this->lucks->getPosters();
        include $this->template('posters');
    }

    public function doWebPostersHandle()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $icon   = $this->get('icon');
        $bg     = $this->get('bg');
        $color     = $this->get('color');
        if ($icon && $bg && $color) {
            $bool = $this->lucks->postersHandle($icon, $bg, $color);
            message($bool ? '操作成功': '操作失败', $this->createWebUrl("posters"), $bool ? 'success' : 'error');
        } else {
            include $this->template('postersHandle');
        }
    }
    public function doWebEditPosters()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $key = $this->get('key');
        $behavior = $this->get('behavior');
        $bool = $this->lucks->editPosters($key, $behavior);

        if ($behavior == 'delete') {
            message($bool ? '操作成功': '操作失败', $this->createWebUrl("posters"), $bool ? 'success' : 'error');
        } else {
            $bool['key'] = $key;
            include $this->template('editPostersHandle');
        }
    }
    public function doWebEditPostersHandle()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $icon   = $this->get('icon');
        $bg     = $this->get('bg');
        $key    = $this->get('key');
        $color    = $this->get('color');
        $bool = $this->lucks->editPostersHandle($key, $icon, $bg, $color);
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("posters"), $bool ? 'success' : 'error');
    }
    /**
     * 上下架
     */
    public function doWebUpDown()
    {
        $column = $this->get('column');
        $id = $this->get('id');
        $status = $this->get('status');
        $bool = $this->lucks->upDown($column, $id, $status);

        if ($column == 'vote_join') {
            $activity_id = p_getcolumn($column, array('id' => $id), 'activity_id');
            $join_num = p_getcolumn('vote_activity', array('id' => $activity_id), 'join_num');
            p_update('vote_activity', array('join_num' => $join_num + 1), array('id' => $activity_id));
        }
        if ($column == 'subscribe_queue') {
            $column = 'subscribe';
        }
        message($bool ? '操作成功': '操作失败', $this->createWebUrl($column), $bool ? 'success' : 'error');
    }
    /**
     * 上下架
     */
    public function doWebSuspended()
    {
        $column = $this->get('column');
        $id = $this->get('id');
        $is_suspend = $this->get('is_suspend');
        $bool = $this->lucks->suspended($column, $id, $is_suspend);
        message($bool ? '操作成功': '操作失败', $this->createWebUrl($column), $bool ? 'success' : 'error');
    }

    public function doWebCancelLuck()
    {
        $bool = p_update('luck', array('is_delete' => 2), array('id' => $this->get('id')));
        json('', $bool ? 1: 0);
    }
    /**
     * 删除
     */
    public function doWebRemove()
    {
        $column = $this->get('column');
        $id = $this->get('id');
        $type = $this->get('type', 1);
        if ($column == 'vote_activity') {
            $vote_activity_member_id = p_getcolumn('vote_activity', array('id' => $id), 'member_id');
            if ($vote_activity_member_id) {
                $memberInfo = p_get('memberinfo', array('id' => $vote_activity_member_id));
                $number = $memberInfo['activity_fq_num'] - 1;
                p_update('memberinfo', array('activity_fq_num' => $number), array('id' => $vote_activity_member_id));
            }

        }
        $bool = $this->lucks->delete($column, $id, $type);
        if ($column == 'home') {
            $column = 'recommendManage';
        }
        if ($column == 'vote_template') {
            $column = 'template';
        }

        if ($column == 'subscribe_queue') {
            $column = 'subscribe';
        }
        if ($column == 'integral_goods') {
            $column = 'integralGoods';
        }
        if ($column == 'red_bag') {
            $column = 'redBag';
        }
        if ($column == 'bonus_level') {
            $column = 'bonusLevel';
        }

        message($bool ? '操作成功': '操作失败', $this->createWebUrl($column), $bool ? 'success' : 'error');
    }

    public function doWebSponsor()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];

        $id = $this->get('id');
        $behavior = $this->get('behavior');
        if ($behavior == 'edit') {
            $data = array(
                'sponsor' => $this->get('sponsor'),
                'sponsor_type' => $this->get('sponsor_type'),
            );
            if (in_array($data['sponsor_type'], array(1))) {
                $sponsor_text = $this->get('sponsor_text');
            } else {
                $type_type = $this->get('type_type');
                if ($type_type ==1) {
                    $sponsor_text =  array(
                        'type'  => $type_type,
                        'image' => $this->get('sponsor_image')
                    );
                } else {
                    $sponsor_text = array(
                        'type'   => $type_type,
                        'appid'  => $this->get('appid'),
                        'path'   => $this->get('path'),
                    );
                }
                $sponsor_text = json_encode($sponsor_text);
            }


            if (in_array($data['sponsor_type'], array(3,4,5))) {
                if ($data['sponsor_type'] ==3) {
                    $img = $this->get('sponsor_image_o');
                }
                if ($data['sponsor_type'] ==4) {
                    $img = $this->get('sponsor_image_id');
                }
                if ($data['sponsor_type'] ==5) {
                    $img = $this->get('sponsor_image_group');
                }
                $sponsor_text =  array(
                    'type'  => 1,
                    'image' => $img
                );
                $sponsor_text = json_encode($sponsor_text);
                $data['sponsor_text'] = $sponsor_text;
            }
            $bool = p_update('luck', $data, array('id' => $id));
            message($bool ? '修改成功': '修改失败', $this->createWebUrl('luck'), $bool ? '': 'error');
        }  else {
            $luck = p_get('luck', array('id' => $id));
            if ($luck) {
                if ($luck['sponsor_type'] == 2) {
                    $sponsor = json_decode($luck['sponsor_text'], true);
                    if ($sponsor['type'] == 2) {
                        $luck['appid'] =  $sponsor['appid'];
                        $luck['path'] =  $sponsor['path'];
                    } else {
                        $luck['sponsor_image'] =  $sponsor['image'];
                    }
                }
                if (in_array($luck['sponsor_type'], array(3,4,5))) {
                    $sponsor = json_decode($luck['sponsor_text'], true);
                    $luck['sponsor_image'] =  $sponsor['image'];

                }
                $luck['type'] = $sponsor['type'];
            }

            include $this->template('sponsor');
        }
    }

    public function doWebWinners()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $luck_id = $this->get('id');
        $luckInfo = p_getall('luck_goods_info', array('luck_id' => $luck_id));

        if ($luckInfo) {
            foreach ($luckInfo as & $value) {
                $value['type'] = $this->luck_type[$value['type']];
                $value['initiator'] = $value['member_id'] > 0 ? p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname') : '后台发起';
                $value['winners'] = $value['in_member_id'] > 0 ? p_getcolumn('memberinfo', array('id' => $value['in_member_id']), 'nickname') : '未开奖';
            }
        }
        include $this->template('winners');
    }
    public function doWebVoteSend()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $id = $this->get('id');
        $type = $this->get('type');
        if ($type == 2) {
            $luckSendData = p_get('luck_goods_info', array('id' => $id));
            if (!$luckSendData) {
                message('订单不存在,请重新选择', $this->createWebUrl('luck_goods_info'), 'error');
            }
            $luckSendData['prizewinner'] = p_getcolumn('memberinfo',array('id' => $luckSendData['in_member_id']), 'nickname');
            $luckSendData['initiator'] = p_getcolumn('memberinfo',array('id' => $luckSendData['member_id']), 'nickname');
            $member = p_get('address', array('member_id' => $luckSendData['in_member_id']));
            include $this->template('luckSend');
        } else {
            $voteSendData = p_get('vote_goods_info', array('id' => $id));
            if (!$voteSendData) {
                message('订单不存在,请重新选择', $this->createWebUrl('vote_goods_info'), 'error');
            }
            $voteSendData['prizewinner'] = p_getcolumn('memberinfo',array('id' => $voteSendData['in_member_id']), 'nickname');
            $voteSendData['initiator'] = p_getcolumn('memberinfo',array('id' => $voteSendData['member_id']), 'nickname');
            $member = p_get('address', array('member_id' => $voteSendData['in_member_id']));
            include $this->template('voteSend');
        }


    }

    public function doWebSend()
    {
        $type = $this->get('type');
        $id = $this->get('id');
        if ($type ==1) {
            if (!p_get('vote_goods_info', array('id' => $id))) {
                message('订单不存在,请重新选择', $this->createWebUrl('vote_goods_info'), 'error');
            }
            $data = array(
                'status' => $this->get('status'),
                'courier_name' => $this->get('courier_name'),
                'courier_number' => $this->get('courier_number'),
            );
            $bool = p_update('vote_goods_info', $data, array('id' => $id));
            message($bool ? '操作成功' : '操作失败', $this->createWebUrl('vote_goods_info'), $bool ? 'success' : 'error');

        } else {
            if (!p_get('luck_goods_info', array('id' => $id))) {
                message('订单不存在,请重新选择', $this->createWebUrl('luck_goods_info'), 'error');
            }
            $data = array(
                'status' => $this->get('status'),
                'courier_name' => $this->get('courier_name'),
                'courier_number' => $this->get('courier_number'),
            );
            $bool = p_update('luck_goods_info', $data, array('id' => $id));
            message($bool ? '操作成功' : '操作失败', $this->createWebUrl('luck_goods_info'), $bool ? 'success' : 'error');
        }
    }

    public function doWebFinish()
    {
        $type = $this->get('type');
        $id = $this->get('id');
        if ($type == 1) {
            $bool = p_update('vote_goods_info', array('status' => 3, 'complete_time' => time()), array('id' => $id));
            message($bool ? '操作成功' : '操作失败', $this->createWebUrl('vote_goods_info'), $bool ? 'success' : 'error');
        } else {
            $bool = p_update('luck_goods_info', array('status' => 3, 'complete_time' => time()), array('id' => $id));
            message($bool ? '操作成功' : '操作失败', $this->createWebUrl('luck_goods_info'), $bool ? 'success' : 'error');
        }

    }
    public function doWebCancel()
    {
        $type = $this->get('type');
        $id = $this->get('id');
        if ($type == 1) {
            $bool = p_update('vote_goods_info', array('status' => 3, 'complete_time' => time()), array('id' => $id));
            message($bool ? '取消成功' : '取消失败', $this->createWebUrl('vote_goods_info'), $bool ? 'success' : 'error');
        } else {
            $bool = p_update('luck_goods_info', array('status' => 3, 'complete_time' => time()), array('id' => $id));
            message($bool ? '取消成功' : '取消失败', $this->createWebUrl('luck_goods_info'), $bool ? 'success' : 'error');
        }

    }







    public function doWebOperationSalesman()
    {
        $data = array(
            'salesman_name' => trim($this->get('salesman_name')),
            'pwd'           => trim($this->get('pwd')),
            'service'       => trim($this->get('service')),
            'phone'         => trim($this->get('phone')),
        /*    'share_text'    => trim($this->get('share_text')),
            'share_img'     => trim($this->get('share_img')),
            'shop_cover'    => trim($this->get('shop_cover')),*/
        );
        if (!preg_match('/^0?1[3|4|5|6|7|8][0-9]\d{8}$/', $data['phone'] ) ) {
            message('电话号码不正确', $this->createWebUrl('salesman'), 'error');
        }
        $id = $this->get('id');
        if (!$id) {
            $data['created'] = time();
        }
      /*  if (strlen($data['pwd']) != 32) {
            if (strlen($data['pwd']) < 6 || strlen($data['pwd']) > 18) {
                message('登录密码在8-16位之间', $this->createWebUrl('salesman'), 'error');
            }
            $data['pwd'] = md5($data['pwd']);
        }*/
        $bool = $this->lucks->salesman($id, $data);
        message($bool ? '操作成功' : '操作失败', $this->createWebUrl('salesman'), $bool ? 'success' : 'error');
    }
    public function doWebOperationShop()
    {
        $data = array(
            'shop_name'     => trim($this->get('shop_name')),
            'pwd'           => trim($this->get('pwd')),
            'phone'         => trim($this->get('phone')),
            'salesman_id'   => trim($this->get('salesman_id')),
            'address'       => trim($this->get('address')),
            'service'       => trim($this->get('service')),
            'is_examine'    => trim($this->get('is_examine')),
            'is_default'    => trim($this->get('is_default')),
            'latitude'      => trim($this->get('latitude')),
            'longitude'     => trim($this->get('longitude')),
            'share_text'     => trim($this->get('share_text')),
            'share_img'     => trim($this->get('share_img')),
            'shop_cover'     => trim($this->get('shop_cover')),
            'ball_image'     => trim($this->get('ball_image')),
        );
        if (!preg_match('/^0?1[3|4|5|6|7|8][0-9]\d{8}$/', $data['phone'] ) ) {
            message('电话号码不正确', $this->createWebUrl('shop'), 'error');
        }
        $id = $this->get('id');
        if (!$id) {
            $data['created'] = time();
        }
        if (empty($data['salesman_id'])) {
            message('请先添加业务员', $this->createWebUrl('shop'), 'error');
        }
        /*if (strlen($data['pwd']) != 32) {
            if (strlen($data['pwd']) < 6 || strlen($data['pwd']) > 18) {
                message('登录密码在8-16位之间', $this->createWebUrl('shop'), 'error');
            }
            $data['pwd'] = md5($data['pwd']);
        }*/
        if ($data['is_default'] == 2) {
            p_update('shop', array('is_default' => 1));
        }
        $bool = $this->lucks->shop($id, $data);

        message($bool ? '操作成功' : '操作失败', $this->createWebUrl('shop'), $bool ? 'success' : 'error');
    }

    public function doWebOperationShop_category()
    {
        $data = array(
            'category_name'     => trim($this->get('category_name')),
            'category_describe' => trim($this->get('category_describe')),
            'states'            => trim($this->get('states')),
            'sort'              => trim($this->get('sort')),
        );
        $id = $this->get('id');
        if (p_get('shop_category', array('category_name' => $data['category_name']))) {
            message('分类已经存在，请重新添加', $this->createWebUrl('shop_category'), 'error');
        }
        $bool = $this->lucks->shop_category($id, $data);
        message($bool ? '操作成功' : '操作失败', $this->createWebUrl('shop_category'), $bool ? 'success' : 'error');
    }

    public function doWebOperationShop_goods()
    {
        $data = array(
          'shop_id' => $this->get('shop_id'),
          'salesman_id' => $this->get('salesman_id'),
          'category_id' => $this->get('category_id'),
          'original_price' => $this->get('original_price'),
          'goods_name' => $this->get('goods_name'),
          'share_title' => $this->get('share_title'),
          'share_image' => $this->get('share_image'),
          'exchange_type' => $this->get('exchange_type'),
          'money'   => $this->get('money'),
          'currency' => $this->get('currency'),
          'cover_image' => $this->get('cover_image'),
          'image' => json_encode($this->get('image')),
          'is_free' => $this->get('is_free'),
          'inventory_type' => $this->get('inventory_type'),
          'inventory' => $this->get('inventory'),
          'introduce' => $this->get('introduce'),
          'allow_number' => $this->get('allow_number'),
          'status' => $this->get('status'),
          'examine_status' => 2,
          'sort' => $this->get('sort'),
        );



        if ($data['is_free'] == 2) {
            $data['free'] = $this->get('free');
        }
        $id = $this->get('id');
        if (!$id) {
            $data['created']  = time();
        }
        $bool = $this->lucks->shop_goods($id, $data);
        message($bool ? '操作成功' : '操作失败', $this->createWebUrl('shop_goods'), $bool ? 'success' : 'error');
    }


    public function doWebPermissions()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $id = $this->get('id');
        $shopName = p_getcolumn('shop', array('id' => $id), 'shop_name');

        $shop_category  = p_getall('shop_category', array('states' => 1, 'is_delete' => 1));
        $shop_category_use = p_getall('shop_category_use', array('shop_id' => $id));
        $category_id = array_column($shop_category_use, 'category_id');
        if ($shop_category) {
                foreach ($shop_category as & $value) {
                    if (in_array($value['id'], $category_id)) {
                        $value['is_exist'] = 'success';
                    } else {
                        $value['is_exist'] = 'error';
                    }
                }
        }
        include  $this->template('permissions');
    }


    public function doWebPermissionsAssign()
    {
        $shop_id = $this->get('shop_id');
        $categoryId = $this->get('category_id');
        if (empty($shop_id) || empty($categoryId)) {
            message('商户不存在或没有选择权限，请重新添加权限', $this->createWebUrl('shop'), 'error');
        }
        $bool = $this->lucks->permissionsAssign($shop_id, $categoryId);
        message($bool ? '操作成功' : '操作失败', $this->createWebUrl('shop'), $bool ? 'success' : 'error');

    }
    public function doWebPartyLuck()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $id = $this->get('id');
        if ($id) {
            $luckGroup = p_fetchall("SELECT * FROM ".prefix('luck_group')." WHERE luck_id={$id}  AND is_appoint = 1");
            foreach ($luckGroup as & $value) {
                $value['nickname'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
            }

            $luckGoods = p_fetchall("SELECT * FROM " .prefix('luck_goods'). " WHERE luck_id={$id}");
        }
        include  $this->template('partyLuck');
    }


    public function doWebPartyLuckRed()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $id = $this->get('id');

        $a = p_getall('luck_goods', array('luck_id' => $id));
        if ($a) {
            foreach ($a as & $va) {
                $va['type'] = $this->luck_type[$va['type']];
            }
        }
        include  $this->template('partyLuckRed');
    }
    public function doWebOperationLuckGroup()
    {
        $luck_goods_id = $this->get('luck_goods_id');
        $luck_group_id = $this->get('luck_group_id');
        $bool = p_update('luck_group', array('is_appoint' => 2, 'appoint_goods_id' => $luck_goods_id), array('id' => $luck_group_id));
        message($bool ? '指定成功' : '指定失败', $this->createWebUrl('luck'), $bool ? 'success' : 'error');

    }

    public function doWebCheck()
    {
        $id = $this->get('id');
        $type = $this->get('type');
        $table = $this->get('table');

        $examine = $type == 1 ? 2 : 3;

        if (empty($id) || empty($type) || empty($table)) {
          json('error' , 0);
        }
        $bool = p_update($table, array('examine' => $examine), array('id' => $id));
        json($bool ? 'success': 'error', $bool ? 1: 0);
    }



    public function doWebOrder()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $op = $this->get('op');
        $page = $this->get('page', 1);

        $where  = "is_pay = 2 " . get_uniacid();

        if ($member_id = $this->get('member_id')) {
            $where .= " AND member_id = {$member_id}";
        }
        if ($order_id = $this->get('order_id')) {
            $where .= " AND id = {$order_id}";
        }
        if ($nickname = $this->get('nickname')) {
            $where .= " AND member_id in ({$this->getMemberId($nickname)})";
        }
        if ($goodsName = $this->get('goodsName')) {
            $where .= " AND goods_id in ({$this->getGoodsId($goodsName)})";
        }
        if ($stats = $this->get('stats')) {
            $where .= " AND status = {$stats}";
        }
        $end = date('Y-m-d');
        $created = $this->get('created');
        if (!$created || empty($created['start'])) {
            $created = array(
                'start' => date('Y-m-d', strtotime($end) - (86400 * 6)) ,
                'end'   => $end
            );
        }

        if ($st = $this->get('start')) {
            $created['start'] =  $st;
        }
        if ($en = $this->get('end')) {
            $created['end'] = $en;
        }

        $where .= " AND  created BETWEEN ". strtotime($created['start']). " AND ". (strtotime($created['end']) + 86400);

        $isIntegralUser =  $this->vote->isIntegralUser() ;
        if ($op == 'send') {
            $order = p_get('order', array('id' => $this->get('id')));
            $order['goods_name'] = p_getcolumn('integral_goods', array('id' => $order['goods_id']), 'goods_name');
            $order['member'] = p_getcolumn('memberinfo', array('id' => $order['member_id']), 'nickname');
            if (!$order['address']) {
                $memberAddress = p_get('address', array('member_id' =>$order['member_id']));
                $order['address'] = $memberAddress['address'];
                $order['name'] = $memberAddress['name'];
                $order['phone'] = $memberAddress['phone'];
            }

            include  $this->template('order_send');
        } elseif($op == 'sends'){
            $id = $this->get('id');
            $data = array(
                'status'        => $this->get('status'),
                'courier_name'  => $this->get('courier_name'),
                'courier_number'=> $this->get('courier_number'),
            );
            if ($data['status'] ==2 ) {
                $data['delivery_time'] = time();
            }
            if ($data['status'] == 4) {
                $data['complete_time'] = time();
            }


            $bool = p_update('order', $data, array('id' => $id));


            message($bool ? '操作成功' : '操作失败', $this->createWebUrl('order', array('page' => $page,'start' => $created['start'], 'end' => $created['end'],'member_id' =>$member_id, 'order_id'=> $order_id,'nickname' => $nickname, 'goodsName' => $goodsName)), $bool ? 'success' : 'error');
        } elseif($op == 'handle'){
            $handle['status'] = $this->get('status');
            if ($handle['status'] == 3) {
                $handle['complete_time'] = time();
            }
            $id =  $this->get('id');
            $data = array(
                'status' => 0,
                'msg'    => 'error'
            );
            if ($handle['status'] ==4) {
                $order = p_get('order', array('id' => $id));
                $payOrder = p_get('pay_order', array('relation_id' => $order['id'], 'type' => 5));

                if  ($order['money'] > 0 || $order['free'] > 0) {
                    $data = $this->myRefund($payOrder['trade_no'],'bh_vote', ($order['money'] + $order['free']));
                }
                $this->vote->change_integral($order['member_id'], $order['exchange_number'], 8, '订单取消退回积分');
                $bool = p_update('order', $handle, array('id' => $id));

            } else {
                $bool = p_update('order', $handle, array('id' => $id));
            }
            json($bool ? 'success' : $data['msg'], $bool ? 1 : 0);

        } else {

            $order = $this->lucks->getTableList('order', $page, $where);
            if ($order['list']) {
                $status = array(
                    1 => '未发货',
                    2 => '已发货',
                    3 => '已完成',
                    4 => '已取消',
                );
                $types = array(
                    1=> '实物',
                    2=> '拼多多',
                    3=> '线下优惠券'
                );
                foreach ($order['list'] as & $value) {
                    $value['nickname']   = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                    $value['goods_name'] = mb_substr(p_getcolumn('integral_goods', array('id' => $value['goods_id']), 'goods_name'), 0, 5 ,'utf-8').'...';

                    $value['goodsName'] = p_getcolumn('integral_goods', array('id' => $value['goods_id']), 'goods_name');
                    $value['shop_name'] = p_getcolumn('merchant', array('id' => $value['shop_id']), 'shop_name') ? : '非店铺';
                    $value['types'] = $types[$value['type']];
                    $value['writeOffId'] = p_getcolumn('memberinfo', array('id' => $value['write_off_id']), 'nickname');
                    if ($value['type'] == 3) {
                        $value['status_str'] =$value['status'] ==1 ? '未核销' : '已核销';
                    } else {
                        $value['status_str'] =$status[$value['status']];
                    }

                    if (!$value['address']) {
                        $memberAddress = p_get('address', array('member_id' =>$value['member_id']));
                        $value['address'] = $memberAddress['address'];
                        $value['name'] = $memberAddress['name'];
                        $value['phone'] = $memberAddress['phone'];
                    }

                }
            }

            include  $this->template('order');
        }

    }


    public function doWebOrderExport()
    {
        $table = prefix('order');
        $where = "is_pay = 2";
        if ($stat = $this->get('stats')) {
            $where .= " AND status = {$stat}";
        }
        $created = $this->get('created');
        $end = date('Y-m-d');
        if (!$created || empty($created['start'])) {
            $created = array(
                'start' => date('Y-m-d', strtotime($end) - (86400 * 6)) ,
                'end'   => $end
            );
        }
        $where .= " AND  created BETWEEN ". strtotime($created['start']). " AND ". (strtotime($created['end']) + 86400);


        $list = p_fetchall("SELECT id,member_id ,goods_id,created,exchange_type,courier_name,courier_number,status, address,delivery_time,complete_time, `name`, phone FROM {$table} WHERE {$where} AND uniacid= {$this->w['uniacid']} ORDER BY id DESC");
        $status = array(
            1 => '未发货',
            2 => '已发货',
            3 => '已完成',
            4 => '已取消',
        );
        if ($list) {
            foreach ($list as & $value) {
                //$value['member_id']   = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                //$value['member_id']   = iconv('gb2312//ignore', 'utf-8', iconv('utf-8', 'gb2312//ignore', p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname')));
                if (!$value['address']) {
                    $memberAddress = p_get('address', array('member_id' =>$value['member_id']));
                    $value['address'] = $memberAddress['address'];
                }
                $value['member_id'] = filterEmoji(p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname'));
                $value['goods_id'] = p_getcolumn('integral_goods', array('id' => $value['goods_id']), 'goods_name');
                $value['created'] = date('Y-m-d H:i:s', $value['created']);
                $value['status'] = $status[$value['status']];
                $value['complete_time'] = date('Y-m-d H:i:s', $value['complete_time']);
                $value['delivery_time'] = date('Y-m-d H:i:s', $value['delivery_time']);
                $value['exchange_type'] = $value['exchange_type'] == 1 ? '金币' : '金币+钱';
                //unset($value['member_id']);
                //unset($value['goods_id']);
            }
            $name   = 'order';
            $header = array('订单id','用户昵称','商品名称','下单时间','兑换方式','快递公司名字', '快递单号','状态', '收货人地址', '发货时间','完成时间','收货人姓名', '收货人电话');
            $this->excelExport($name, $header, $list);

        }
        var_dump($list);

    }



    /**

     * excel表格导出

     * @param string $fileName 文件名称

     * @param array $headArr 表头名称

     * @param array $data 要导出的数据

     * @author static7
     */
    public function excelExport($fileName = '', $headArr = [], $data = [])
    {
        load()->library('phpexcel/PHPExcel');
        $fileName .= "_" . date("Y_m_d", time()) . ".xls";
        $objPHPExcel = new \PHPExcel();
        $objPHPExcel->getProperties();
        $key = ord("A"); // 设置表头

        foreach ($headArr as $v) {

            $colum = chr($key);

            $objPHPExcel->setActiveSheetIndex(0)->setCellValue($colum . '1', $v);

            $objPHPExcel->setActiveSheetIndex(0)->setCellValue($colum . '1', $v);

            $key += 1;

        }

        $column = 2;

        $objActSheet = $objPHPExcel->getActiveSheet();

        foreach ($data as $key => $rows) { // 行写入

            $span = ord("A");
            foreach ($rows as $keyName => $value) { // 列写入

                $objActSheet->setCellValue(chr($span) . $column, $value);
                $span++;
            }
            $column++;
        }
        $fileName = iconv("utf-8", "gb2312", $fileName); // 重命名表

        $objPHPExcel->setActiveSheetIndex(0); // 设置活动单指数到第一个表,所以Excel打开这是第一个表

        header('Content-Type: application/vnd.ms-excel');

        header("Content-Disposition: attachment;filename= $fileName ");

        header('Cache-Control: max-age=0');

        $objWriter = \PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');

        $objWriter->save('php://output'); // 文件通过浏览器下载

        exit();

    }


    protected function myRefund($tid, $module = 'bh_vote', $fee = 0, $reason = '取消订单退款')
    {

        load()->model('refund');

        $refund_id = refund_create_order($tid, $module, $fee, $reason);
        if (is_error($refund_id)) {
            return array('status' => 0, 'mgs' => $refund_id['message']);
        }
        $refund_result = refund($refund_id);
        if (is_error($refund_result)) {
            return array('status' => 0, 'mgs' => $refund_result['message']);
        } else {
            pdo_update('core_refundlog', array('status' => 1), array('id' => $refund_id));
            return array('status' => 200,'msg' => 'success');
        }
    }


    public function doWebMerchant()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $op = $this->get('op');
        $id = $this->get('id');
        if ($op == 'addShow' || $op == 'editShow') {
            $merchant = p_get('merchant', array('id' => $id));
            $merchant['business_imgs'] = json_decode($merchant['business_imgs'], true);
            include  $this->template('merchant_add');
        } elseif($op == 'add' || $op == 'edit') {
            $data = array(
                'member_id' => $this->get('member_id'),
                'shop_head' => $this->get('shop_head'),
                'shop_name' => $this->get('shop_name'),
                'longitude'  => $this->get('longitude'),
                'latitude'  => $this->get('latitude'),
                'address'  => $this->get('address'),
                'phone'     => $this->get('phone'),
                'name'     => $this->get('name'),
                'we_chat'     => $this->get('we_chat'),
                'participants'     => $this->get('participants'),
                'introduction'     => $this->get('introduction'),
                'brand'     => $this->get('brand'),
                'industry'     => $this->get('industry'),
                'add_group_txt'     => $this->get('add_group_txt'),
                'add_group_url'     => $this->get('add_group_url'),
                'business_imgs'     => json_encode($this->get('business_imgs')),
            );
            if (!$id) {
                $data['created'] = time();
            }
            $bool = $id ? p_update('merchant', $data, array('id' => $id)) : p_insert('merchant', $data);
            message($bool ? '编辑成功' : '编辑失败', $this->createWebUrl('merchant'), $bool ? 'success' : 'error');
        } elseif($op == 'delete') {
            $bool = p_delete('merchant', array('id' => $id));
            json('', $bool ? 1 : 0);
        } elseif($op == 'check'){
            $bool = p_update('merchant', array('status' => $this->get('status')), array('id' => $this->get('id')));
            json('', $bool ? 1 : 0);
        } else {
            $page = $this->get('page');
            $where  = "1 = 1 " . get_uniacid();
            $merchant = $this->lucks->getTableList('merchant', $page, $where);
            if ($merchant['list']) {
                $status = array(
                    1 => '审核中',
                    2 => '通过认证',
                    3 => '审核未通过'
                );
                foreach ($merchant['list'] as & $value) {
                    $value['stat'] = $status[$value['status']];
                    $value['nickname'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                }
            }
            include  $this->template('merchant');
        }
    }

    public function doWebTurntableMember()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];

        $op = $this->get('op');
        if ($op == 'send') {
            $turntableMember = p_get('turntable_member', array('id' => $this->get('id')));
            $turntableMember['prizeName'] = p_getcolumn('turntable', array('id' => $turntableMember['turntable_id']), 'prize_name');
            $turntableMember['member'] = p_getcolumn('memberinfo', array('id' => $turntableMember['member_id']), 'nickname');

            if (!$turntableMember['address']) {
                $memberAddress = p_get('address', array('member_id' =>$turntableMember['member_id']));
                $turntableMember['address'] = $memberAddress['address'];
                $turntableMember['name'] = $memberAddress['name'];
                $turntableMember['phone'] = $memberAddress['phone'];
            }
            include  $this->template('turntableMember_send');
        } elseif($op == 'sends'){
            $id = $this->get('id');
            $data = array(
                'status'        => $this->get('status'),
                'courier_name'  => $this->get('courier_name'),
                'courier_number'=> $this->get('courier_number'),
            );
            if ($data['status'] ==2 ) {
                $data['delivery_time'] = time();
            }
            if ($data['status'] == 4) {
                $data['complete_time'] = time();
            }
            $bool = p_update('turntable_member', $data, array('id' => $id));
            message($bool ? '操作成功' : '操作失败', $this->createWebUrl('turntableMember'), $bool ? 'success' : 'error');

        } elseif ($op == 'handle'){

            $handle['status'] = $this->get('status');
            if ($handle['status'] == 3) {
                $handle['complete_time'] = time();
            }
            $bool = p_update('turntable_member', $handle, array('id' => $this->get('id')));
            json('', $bool ? 1 : 0);
        } else {
            $page = $this->get('page');
            $where  = "type = 2 " .get_uniacid();
            $turntableMember = $this->lucks->getTableList('turntable_member', $page, $where);
            if ($turntableMember['list']) {
                $type = array(
                    1 => '活力币',
                    2 => '实物',
                    3 => '谢谢参与',
                );
                $status = array(
                    1 => '未发货',
                    2 => '已发货',
                    3 => '已完成',
                    4 => '已取消',
                );
                foreach ($turntableMember['list'] as & $value) {
                    $value['nickname'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                    $value['prizeName'] = p_getcolumn('turntable', array('id' => $value['turntable_id']), 'prize_name');
                    $value['type'] = $type[$value['type']];
                    $value['status_str'] = $status[$value['status']];
                    if (!$value['address']) {
                        $memberAddress = p_get('address', array('member_id' =>$value['member_id']));
                        $value['address'] = $memberAddress['address'];
                        $value['name'] = $memberAddress['name'];
                        $value['phone'] = $memberAddress['phone'];
                    }
                }
            }
            include  $this->template('turntableMember');
        }
    }





    public function doWebComment()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $op = $this->get('op');
        if ($op == 'delete') {
            $id = $this->get('id');
            $bool = p_delete('topic_comment', array('id' => $id));
            json('', $bool ? 1 : 0);
        } elseif($op == 'successAudit') {
            $id = $this->get('id');
            $bool = p_update('topic_comment', array('examine' => 2),array('id' => $id));
            json('', $bool ? 1 : 0);
        } elseif($op == 'errorAudit') {
            $id = $this->get('id');
            $bool = p_update('topic_comment', array('examine' => 3),array('id' => $id));
            json('', $bool ? 1 : 0);
        } else {
            $topic_member_id = $this->get('topic_member_id');
            $topic_member_info = p_get('topic_member',array('id' => $topic_member_id));
            $topic = p_getcolumn('topic', array('id' => $topic_member_info['topic_id']), 'name');
            $topic_comment_examine = getConfig('topic_comment_examine' , 1);
            $topic_member_info['images'] = $this->getSubmission($topic_member_info['image']);
            $topic_member_info['username'] = p_getcolumn('memberinfo', array('id' => $topic_member_info['member_id']), 'nickname');
            $topic_member_info['comment_count'] = p_getcolumn('topic_comment', array('topic_member_id' => $topic_member_id), 'COUNT(*)') ? : 0;
            $list = p_getall('topic_comment', array('topic_member_id' => $topic_member_id));
            if ($list) {
                foreach ($list as & $value) {
                    if ($value['comment_member_id'] > 0) {
                        $value['comment_member'] = p_get('member', array('id' => $value['comment_member_id']));
                    }
                    $value['member'] = p_get('member', array('id' => $value['member_id']));
                    $value['created'] = formatTime($value['created']);
                }
            }
            include $this->template('topicComment');

        }

    }


    public function doWebPartner()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $op = $this->get('op');
        if ($op == 'delete') {
            $id = $this->get('id');
            $bool = p_delete('partner', array('id' => $id));
            json('', $bool ? 1 : 0);
        } elseif($op == 'successAudit') {
            $id = $this->get('id');
            $bool = p_update('partner', array('examine' => 2),array('id' => $id));
            json('', $bool ? 1 : 0);
        } elseif($op == 'errorAudit') {
            $id = $this->get('id');
            $bool = p_update('partner', array('examine' => 3),array('id' => $id));
            json('', $bool ? 1 : 0);
        } else {
            $page = $this->get('page');
            $where  = "1 = 1 " .get_uniacid();
            $partner = $this->lucks->getTableList('partner', $page, $where);

            if ($partner['list']) {
                foreach ($partner['list'] as & $value) {
                    $value['address']  = json_decode($value['address']) ? : array('北京','北京市','东城区');
                    $value['nickname'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                }
            }
            include $this->template('partner');

        }

    }




    public function doWebCollection()
    {
        $topic_id = $this->get('topic_id');
        $table = prefix('topic_collection');
        $where = "uniacid = {$this->w['uniacid']} AND topic_id = {$topic_id}";
        $pindex = max(1, intval($this->get('page')));
        $psize = 20;
        $topic = p_getcolumn('topic', array('id' => $topic_id), 'name');
        $list = pdo_fetchall('SELECT * FROM '.$table." WHERE {$where} ORDER BY id DESC LIMIT ".($pindex - 1) * $psize.','.$psize);
        if($list) {
            foreach ($list as & $value) {
                $content = p_get('topic_member', array('id' => $value['topic_member_id']));
                $value['release_member'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                $value['collection_member'] = p_getcolumn('memberinfo', array('id' => $value['c_member_id']), 'nickname');
                $value['release_collection_text'] = $content['allocation'];
                $value['release_collection_images'] = $this->getSubmission($content['image']);
                $value['topic_name'] = p_getcolumn('topic', array('id' => $value['topic_id']), 'name');
            }
        }
        $total = pdo_fetchcolumn("SELECT COUNT(*) FROM {$table} WHERE {$where}");
        $pager = pagination($total, $pindex, $psize);
        include $this->template('topic_collection');
    }


    public function doWebFabulous()
    {
        $where = " uniacid = {$this->w['uniacid']} ";
        $page = $this->get('page');
        if ($topic_id = $this->get('topic_id')) {
            $where .= " AND topic_id={$topic_id}";
            $topic = p_getcolumn('topic', array('id' => $topic_id), 'name');
        }
        $topic_fabulous = $this->lucks->getTableList('topic_fabulous', $page, $where);
        if($topic_fabulous['list']) {
            foreach ($topic_fabulous['list'] as & $value) {
                $content = p_get('topic_member', array('id' => $value['topic_member_id']));
                $value['release_member'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                $value['collection_member'] = p_getcolumn('memberinfo', array('id' => $value['f_member_id']), 'nickname');
                $value['release_collection_text'] = $content['allocation'];
                $value['release_collection_images'] = $this->getSubmission($content['image']);
                $value['topic_name'] = p_getcolumn('topic', array('id' => $value['topic_id']), 'name');
            }
        }
        include $this->template('topicFabulous');
    }



    public function doWebMoneyLog()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $where = " uniacid = {$this->w['uniacid']} ";
        $page = $this->get('page');
        if ($filed = $this->get('filed')) {
            if ($member_ids =  $this->lucks->searchMember($filed)) {
                $where .= " AND member_id in ({$member_ids})";
            }
        }
        if ($member_id = $this->get('member_id')) {
            $where .= " AND member_id = {$member_id}";
        }
        $money_log = $this->lucks->getTableList('money_log', $page, $where);
        if($money_log['list']) {
            $type = array(
                1 => '抽奖',
                2 => '提现',
                3 => '积分兑换红包',
                4 => '等级分红'
            );
            foreach ($money_log['list'] as & $value) {
                $value['nickname'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                $value['type'] = $type[$value['type']];

            }
        }
        include $this->template('moneyLog');

    }


    public function doWebBonusLevel()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $op = $this->get('op');
        $id = $this->get('id');
        if ($op == 'addshow' || $op == 'editShow') {
            $bonusLevel = p_get('bonus_level', array('id' => $id));
            include $this->template('bonus_level_add');
        } elseif ($op == 'add' || $op == 'edit') {
            $data = array(
                'level'  => $this->get('level'),
                'level_name' => $this->get('level_name'),
                'level_image'    => $this->get('level_image'),
                'share_number'   => $this->get('share_number'),
                'integral'      => $this->get('integral'),
                'proportion'  => $this->get('proportion'),
            );

            if (!$id) {
                $data['created'] = time();
                if (p_get('bonus_level', array('level' => $data['level']))) {
                    message($data['level_name'] . ": 等级已经存在", $this->createWebUrl('bonusLevel'));
                }
            }
            $bool = $id ? p_update('bonus_level', $data, array('id' => $id)) : p_insert('bonus_level', $data);
            message($bool ? "操作成功": "操作失败", $this->createWebUrl('bonusLevel'));
        } elseif($op == 'sort') {
            $sort = (int)$this->get('sort');
            $bool = p_update('bonus_level', array('sort' =>$sort ), array('id'=> $id));
            json('', $bool ? 1 : 0);
        } elseif ($op == 'delete'){
            $bool = p_delete('bonus_level', array('id' => $id));
            json('', $bool ? 1 : 0);
        } else {
            $page   = $this->get('page');
            $where  = "1 = 1 ".get_uniacid();
            $bonusLevel = $this->lucks->getTableList('bonus_level',$page, $where);

            if ($bonusLevel['list']) {
                foreach ($bonusLevel['list'] as & $value){
                    $number = p_getcolumn('memberinfo', array('bonus_level' => $value['level']), 'COUNT(*)');
                    $value['dividend'] = number_format((getConfig('today_dividend_default') * $value['proportion']) / 100 * $number ,2);
                    $value['number'] = $number;
                }

            }
            include $this->template('bonus_level');
        }
    }
    public function doWebMemberRedBag()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $where = " uniacid = {$this->w['uniacid']} ";
        $page = $this->get('page');
        if ($filed = $this->get('filed')) {
            if ($member_ids =  $this->lucks->searchMember($filed)) {
                $where .= " AND member_id in ({$member_ids})";
            }
        }
        if ($member_id = $this->get('member_id')) {
            $where .= " AND member_id = {$member_id}";
        }
        $money_log = $this->lucks->getTableList('member_red_bag', $page, $where);
        if($money_log['list']) {
            foreach ($money_log['list'] as & $value) {
                $value['nickname'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');

            }
        }
        include $this->template('member_red_bag');

    }


    public function doWebFollow()
    {
        $member_id = $this->get('member_id');
        $table = prefix('topic_follow');
        $where = "uniacid = {$this->w['uniacid']} AND member_id = {$member_id}";
        $pindex = max(1, intval($this->get('page')));
        $psize = 20;
        $userName = p_getcolumn('memberinfo', array('id' => $member_id), 'nickname');
        $list = pdo_fetchall('SELECT * FROM '.$table." WHERE {$where} ORDER BY id DESC LIMIT ".($pindex - 1) * $psize.','.$psize);
        if($list) {
            foreach ($list as & $value) {
                $value['release_member'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                $value['collection_member'] = p_getcolumn('memberinfo', array('id' => $value['follow_member_id']), 'nickname');
            }
        }
        $total = pdo_fetchcolumn("SELECT COUNT(*) FROM {$table} WHERE {$where}");
        $pager = pagination($total, $pindex, $psize);
        include $this->template('topic_follow');
    }

    public function doWebSubscribe()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page = $this->get('page');
        $where = "1 = 1 ".get_uniacid();
        $subscribeQueue = $this->lucks->getTableList('subscribe_queue',$page, $where);
        if ($subscribeQueue['list']) {
            $status = array(
                1 => '发送中',
                2 => '发送完成',
                3 => '停止'
            );
            foreach ($subscribeQueue['list'] as & $value) {
                $value['status'] =$status[$value['status']];
                $value['content'] = json_decode($value['content'], true);
            }
        }
        include $this->template('subscrib');
    }


    public function doWebOperationSubscribe()
    {
        $behavior = $this->get('behavior');
        $activityName = $this->get('activityName');
        $activityTime = $this->get('activityTime');
        $activityText = $this->get('activityText');
        $skipUrl      = $this->get('skipUrl');
        if ($behavior == 'add') {
            $bool = $this->lucks->subscribeQueue($activityName, $activityTime, $activityText, $skipUrl);
        } else {
            $id = $this->get('id');
            $bool = $this->lucks->subscribeQueue($activityName, $activityTime, $activityText, $skipUrl, $id);
        }
        message($bool ? '操作成功': '操作失败', $this->createWebUrl("subscribe"), $bool ? 'success': 'error');


    }



    public function doWebRedBag()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $op = $this->get('op');
        $id = $this->get('id');
        if ($op == 'addshow' || $op == 'editShow') {
            $redBag = p_get('red_bag', array('id' => $id));
            include $this->template('red_bag_add');
        } elseif ($op == 'add' || $op == 'edit') {
            $data = array(
                'integral'  => $this->get('integral'),
                'sign_days' => $this->get('sign_days'),
                'number'    => $this->get('number'),
                'receive'   => $this->get('receive'),
                'type'      => $this->get('type'),
                'describe'  => $this->get('describe'),
                'sort'      => $this->get('sort'),
            );

            if ($data['type'] ==1) {
                $data['money'] =  $this->get('money');
            } else {
                $data['start'] = $this->get('start');
                $data['end'] = $this->get('end');
            }
            if (!$id) {
                $data['created'] = time();
                if (p_getcolumn('red_bag', array(), 'COUNT(*)') >= 4) {
                    message("红包数量不超过4个", $this->createWebUrl('redBag'));
                }
            }
            $bool = $id ? p_update('red_bag', $data, array('id' => $id)) : p_insert('red_bag', $data);
            message($bool ? "操作成功": "操作失败", $this->createWebUrl('redBag'));
        } elseif($op == 'sort') {
            $sort = (int)$this->get('sort');
            $bool = p_update('red_bag', array('sort' =>$sort ), array('id'=> $id));
            json('', $bool ? 1 : 0);
        } elseif ($op == 'delete'){
            $bool = p_delete('red_bag', array('id' => $id));
            json('', $bool ? 1 : 0);
        } else {
            $page   = $this->get('page');
            $where  = "1 = 1 ".get_uniacid();
            $redBag = $this->lucks->getTableList('red_bag',$page, $where);
            include $this->template('red_bag');
        }

    }

    public function doWebDemoJump()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $op = $this->get('op');
        $id = $this->get('id');
        if ($op == 'addshow' || $op == 'editShow') {
            $demoJump = p_get('demo_jump', array('id' => $id));
            include $this->template('demo_jump_add');
        } elseif ($op == 'add' || $op == 'edit') {
            $data = array(
                'type'      => $this->get('type'),
                'appid'     => $this->get('appid'),
                'path'      => $this->get('path'),
                'need_jump_number'   => $this->get('need_jump_number'),
                'image'     => $this->get('image'),
                'demo_time' => $this->get('demo_time'),
                'remarks'   => $this->get('remarks'),
            );
            $bool = $id ? p_update('demo_jump', $data, array('id' => $id)) : p_insert('demo_jump', $data);
            message($bool ? "操作成功": "操作失败", $this->createWebUrl('demoJump'));
        } elseif($op == 'sort') {
            $sort = (int)$this->get('sort');
            $bool = p_update('demo_jump', array('sort' => $sort), array('id'=> $id));
            json('', $bool ? 1 : 0);
        } elseif ($op == 'delete'){
            $bool = p_delete('demo_jump', array('id' => $id));

            json('', $bool ? 1 : 0);
        } else {
            $page   = $this->get('page');
            $where  = "1 = 1 ".get_uniacid();
            $demoJump = $this->lucks->getTableList('demo_jump',$page, $where);
            include $this->template('demo_jump');
        }

    }

    /**
     * @param $length
     * @return string
     */
    protected function getIssueNumber($length)
    {
        $str ='201812345678998765412307899638527411236987412';
        $len =strlen($str)-1;
        $randStr='';
        for($i=0;$i<$length;$i++){
            $num=mt_rand(0,$len);
            $randStr .= $str[$num];
        }
        $str = date('Ymd') . $randStr;
        return $str;
    }
    public function doWebInitializeVoteDefault()
    {
        $data = array(
            array('name' => '迎国庆“最美”家庭评选','template_id' => 1,'states'  => 1,'sort'=> 1,
            ),
            array('name' => '我的超人爸爸评选','template_id' => 2,'states' => 1, 'sort'=> 2,
            ),
            array('name' => '六一童星评选活动','template_id' => 3,'states' => 1,'sort'=> 3,
            ),
            array('name' => '“我的妈呀！你真美”评选活动', 'template_id' => 4, 'states'=> 1,'sort'  => 4,
            ),
            array('name' => '圣诞最美装饰评选','template_id' => 5,'states' => 1,'sort'  => 5,
            ),
            array('name'=> '最萌圣诞宝贝评选', 'template_id'   => 6,'states' => 1, 'sort' => 6,
            ),
            array( 'name' => '2018年度影响人物', 'template_id' => 7, 'states'=> 1,'sort'  => 7,
            ),
            array('name' => '我最喜爱的表演节目','template_id' => 8,'states' => 1, 'sort' => 8,
            ),
            array('name' => '评选七夕情人节最佳旅游目的地','template_id' => 9,'states'  => 1,'sort'=> 9,
            ),
            array('name' => '七夕“天生一对”评选','template_id' => 10,'states'  => 1,'sort'=> 10,
            ),
            array('name' => '评选七夕最适合一起看的爱情电影','template_id' => 11,'states'  => 1,'sort'=> 11,
            ),
            array('name' => '七夕情侣自拍大赛','template_id' => 12,'states'  => 1,'sort'=> 12,
            ),
            array('name' => '七夕最美汉服评选','template_id' => 13,'states'  => 1,'sort'=> 13,
            ),
            array('name' => '七夕最佳CP','template_id' => 14,'states'  => 1,'sort'=> 14,
            ),
            array('name' => '七夕最佳礼物评选','template_id' => 15,'states'  => 1,'sort'=> 15,
            ),
            array('name' => '建军节主题作品评选','template_id' => 16,'states'  => 1,'sort'=> 16,
            ),
            array('name' => '八一最美军嫂评选活动','template_id' => 17,'states'  => 1,'sort'=> 17,
            ),
            array('name' => '七夕情侣摄影大赛，记录甜蜜瞬间','template_id' => 18,'states'  => 1,'sort'=> 18,
            ),
            array('name' => '七夕最佳情话','template_id' => 19,'states'  => 1,'sort'=> 19,
            ),
            array('name' => '庆八一，先进模范评选活动','template_id' => 20,'states'  => 1,'sort'=> 20,
            ),
            array('name' => '八一最美退伍军人','template_id' => 21,'states'  => 1,'sort'=> 21,
            ),
            array('name' => '科技评选大赛','template_id' => 22,'states'  => 1,'sort'=> 22,
            ),
            array('name' => '万能投票模块','template_id' => 23,'states'  => 1,'sort'=> 23,
            ),
            array('name' => '工业作业评选','template_id' => 24,'states'  => 1,'sort'=> 24,
            ),
            array('name' => '520最美情侣评选','template_id' => 25,'states'  => 1,'sort'=> 25,
            ),
            array('name' => '520网络情人节评选活动','template_id' => 26,'states'  => 1,'sort'=> 26,
            ),
            array('name' => '七夕人气评选','template_id' => 27,'states'  => 1,'sort'=> 27,
            ),
            array('name' => '评选最具青春风采的舞者','template_id' => 28,'states'  => 1,'sort'=> 28,
            ),
            array('name' => '家乡美食评选大赛','template_id' => 29,'states'  => 1,'sort'=> 29,
            ),
            array('name' => '室内设计评选','template_id' => 30,'states'  => 1,'sort'=> 30,
            ),
            array('name' => '经济人物评选','template_id' => 31,'states'  => 1,'sort'=> 31,
            ),
            array('name' => '小学生绘画作品评选','template_id' => 32,'states'  => 1,'sort'=> 32,
            ),
            array('name' => '最佳团队评选','template_id' => 33,'states'  => 1,'sort'=> 33,
            ),
            array('name' => '最强大脑评选','template_id' => 34,'states'  => 1,'sort'=> 34,
            ),
            array('name' => 'pick最佳街舞选手','template_id' => 35,'states'  => 1,'sort'=> 35,
            ),
            array('name' => '五一劳动小能手','template_id' => 36,'states'  => 1,'sort'=> 36,
            ),
        );
        foreach ($data as $val) {
            if (!p_get('vote_template', array('name' => $val['name'], 'template_id' => $val['template_id']))) {
                p_insert('vote_template', $val);
            }
        }

        message( '同步成功', $this->createWebUrl('template'),  'success');

    }


    /**
     *  提现管理
     */
    public function doWebWithdrawals()
    {
        $siteRoot   = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $op = $this->get('op');
        if ($op == 'sgree') {
            $id = $this->get('id');
            $cash = p_get('withdrawals', array('id' => $id));
            if ($cash['status'] > 1) {
                json(1);
            }
            $cash_type = getConfig('cash_type', 1);
            if ($cash_type == 2 ) {
                p_update('withdrawals', array('status' => 2,'success_time' => time()), array('id' => $id));
                json(1);
            } else {
                pdo_begin();
                try{
                    $this->setPayment();
                    if (!p_update('withdrawals' , array('status' => 2, 'success_time' => time()), array('id' => $id, 'status' => 1))) {
                        throw new Exception('提现失败');
                    }

                    if (!$this->vote->cash($cash['money'], $cash['member_id'])) {
                        throw new Exception($this->vote->error);
                    }

                    pdo_commit();
                    json(1);
                } catch (Exception $e) {
                    pdo_rollback();
                    json($e->getMessage(), 0);
                }
            }

        } elseif ($op == 'refuse') {
            $id = $this->get('id');
            $cash = p_get('withdrawals', array('id' => $id));
            if ($cash['status'] > 1) {
                json(1);
            }
            p_update('withdrawals', array('status' => 3), array('id' => $id));
            json(1);
        } else {
            $table = prefix('withdrawals');
            $where = "uniacid=" . UNIACID;
            $status = $this->get('status', 0);
            if ($status > 0) {
                $where .= " AND status={$status}";
            }
            $nickname = $this->get('nickname');
            if ( $nickname ) {
                $where .=  " AND member_id in ({$this->lucks->searchMember($nickname)}) ";
            }
            if ($member_id = $this->get('member_id')) {
                $where .= " AND  member_id ={$member_id}";
            }
            $pindex = max(1, intval($this->get('page')));
            $psize = 20;
            $list = p_fetchall("SELECT * FROM {$table} WHERE {$where}  ORDER BY id DESC LIMIT " . ($pindex - 1) * $psize.','.$psize);
            $statusStr = array(
                1 => '申请成功',
                2 => '提现成功',
                3 => '提现失败'
            );
            if ($list) {
                foreach ($list as & $value) {
                    $value['nickname'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                    $value['type'] = $value['type'] == 1 ? '企业零钱': '收款码';
                    $value['statusStr'] = $statusStr[$value['status']];
                }
            }
            $total = pdo_fetchcolumn("SELECT COUNT(*) FROM {$table} WHERE {$where}");
            $pager = pagination($total, $pindex, $psize);
            include $this->template('withdrawals');
        }
    }
    public function changeMember($member_id = '')
    {
        if ($member_id) {
            $memberInfo = p_get('memberinfo', array('id' => $member_id));
            $number = $memberInfo['activity_fq_num'] + 1;
            p_update('memberinfo', array('activity_fq_num' => $number), array('id' => $member_id));
        }
    }


    public function doWebVirtual()
    {
        $siteRoot   = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $goodsId = $this->get('goodsId');
        $stock = $this->get('number');
        $op = $this->get('op');
        if ($op == 'delete') {
            $bool = p_delete('integral_goods_fictitious', array('id' => $this->get('id')));
            json('', $bool ? 1 : 0);
        } else {
            $page   = $this->get('page');
            $where  = "goods_id = {$goodsId} ".get_uniacid();
            $goodsFictitious = $this->lucks->getTableList('integral_goods_fictitious',$page, $where);

            if ($goodsFictitious['list']) {
                foreach ($goodsFictitious['list'] as & $value) {
                    $value['goodsName'] = p_getcolumn('integral_goods', array('id' => $value['goods_id']), 'goods_name');
                }
            }
            include $this->template('goods_fictitious');
        }


    }

    public function doWebLuckGoodsCode()
    {
        $siteRoot   = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $op = $this->get('op');
        if ($op == 'delete') {
            $bool = p_delete('luck_goods_code', array('id' => $this->get('id')));
            json('', $bool ? 1 : 0);
        } elseif($op == 'addShow') {
            include $this->template('luck_goods_code_add');
        } elseif($op == 'add'){
            $fictitious = $this->get('fictitious');
            $fictitiousData = explode("\n",$fictitious);
            $use_id = $this->get('use_id');
            if ($fictitiousData) {
                foreach ($fictitiousData as $val) {
                    $data = array(
                        'fictitious' => $val,
                        'status' => 1,
                        'use_id' => $use_id,
                    );
                    p_insert('luck_goods_code', $data);
                }
            }
            message("操作成功",$this->createWebUrl('luckGoodsCode'));
        } else {
            $page   = $this->get('page');
            $where  = "1 = 1 ".get_uniacid();
            $luckGoodsCode = $this->lucks->getTableList('luck_goods_code',$page, $where);
            include $this->template('luck_goods_code');
        }

    }
    public function doWebManualVoucher()
    {
        $siteRoot   = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $goodsId = $this->get('goodsId');
        $goods_name = p_get('integral_goods', array('id' => $goodsId));
        $count = p_getcolumn('integral_goods_fictitious', array('goods_id' => $goodsId), 'COUNT(*)');
        $stock = $this->get('number');
        $op = $this->get('op');

        if ($op == 'edit') {
            if ($count >= $goods_name['inventory']) {
                message("虚拟码已满不需要在操作",$this->createWebUrl('integralGoods'), 'warning');
            }

            $differential = $goods_name['inventory'] - $count;

            $voucherInfo = $this->get('voucherInfo');
            $voucherData = explode(',' , $voucherInfo);
            if (count($voucherData) != $differential) {
                message("虚拟码份数不相符合,请重新添加 {$differential}份",$this->createWebUrl('integralGoods'), 'warning');
            }

            foreach ($voucherData as $val) {
                    $data = array(
                        'goods_id' => $goodsId,
                        'fictitious' => $val,
                        'status' => 1,
                        'created' => time()
                    );
                    p_insert('integral_goods_fictitious', $data);
            }
            message("操作成功",$this->createWebUrl('integralGoods'), 'success');
        } else {
            include $this->template('manual_goods_fictitious');
        }
    }

    public function doWebCreateVoucher()
    {
        $siteRoot   = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $goods_id = $this->get('goodsId');
        $numbers = $this->get('number');

        $count = p_getcolumn('integral_goods_fictitious', array('goods_id' => $goods_id), 'COUNT(*)');

        $number = $numbers - $count;
        if ($number < 0) {
            message("你删除后再点生成你反人类操作,请重新去商品管理点虚拟在生成" , $this->createWebUrl('integralGoods'));
        }
        $data = array(
            'goods_id' => $goods_id,
            'status' => 1,
            'created' => time()
        );
        for ($i = 0; $i < $number; $i++) {
            if (!p_insert('integral_goods_fictitious', $data)) {
                continue;
            }
            $id = pdo_insertid();
            $no = $id . time();
            $content = str_pad($no, 18, '0', STR_PAD_LEFT);
            p_update('integral_goods_fictitious', array('fictitious' => $content), array('id' => $id));
        }
        message("生成成功" , $this->createWebUrl('virtual', array('goodsId' => $goods_id)));

    }


    public function doWebNavigation()
    {
        $op = $this->get('op');
        $id = $this->get('id');
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        if ($op == 'add' || $op == 'edit') {
            $data = array(
                'name'      => $this->get('name'),
                'position'  => $this->get('position'),
                'path'      => $this->get('path'),
                'selection_image'  => $this->get('selection_image'),
                'unchecked_images' => $this->get('unchecked_images'),
                'selection_color'  => $this->get('selection_color'),
                'unchecked_color'  => $this->get('unchecked_color'),
                'sort'             => $this->get('sort'),
            );
            if (!$id) {
                $data['created'] = time();
            }
            $bool = $id ? p_update('navigation', $data, array('id' => $id)) : p_insert('navigation', $data);
            message($bool ? '操作成功': '操作失败', $this->createWebUrl('navigation'), $bool ? 'success': 'error');
        } elseif ($op == 'editShow' || $op == 'addShow') {
            $navigation = p_get('navigation', array('id' => $id));
            include $this->template('navigation_add');
        } elseif($op == 'sort') {
            $sort = $this->get('sort');
            $bool = p_update('navigation', array('sort' => $sort), array('id' => $id));
            json('', $bool ? 1 : 0);
        } elseif ($op == 'delete') {
            $bool = p_delete('navigation', array('id' => $id));
            json('', $bool ? 1 : 0);
        } else {
            $table = prefix('navigation');
            $where = "uniacid = {$this->w['uniacid']} AND 1 = 1";
            $pindex = max(1, intval($this->get('page')));
            $psize = 20;
            $list = pdo_fetchall('SELECT * FROM '.$table." WHERE {$where} ORDER BY id DESC LIMIT ".($pindex - 1) * $psize.','.$psize);
            $position = array(
                'index_index'    => '首页',
                'index_newLaunch'=> '发起活动',
                'user_index'     => '个人中心',
                'interaction_activity'     => '锦鲤活动',
            );
            if ($list) {
                foreach ($list as & $value) {
                    $value['position'] =$position[$value['position']];
                }
            }
            $total = pdo_fetchcolumn("SELECT COUNT(*) FROM {$table} WHERE {$where}");
            $pager = pagination($total, $pindex, $psize);
            include $this->template('navigation');
        }
    }


    public function doWebCalligraphy()
    {
        $op = $this->get('op');
        $id = $this->get('id');
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];

        if ($op == 'add' || $op == 'edit') {
            $data = array(
                'name' => $this->get('name'),
                'end_time' => strtotime($this->get('end_time')),
                'stock' => $this->get('stock'),
                'status' => $this->get('status'),
                'share_txt' => $this->get('share_txt'),
                'share_image' => $this->get('share_image'),
                'cover_img' => $this->get('cover_img'),
                'images' => json_encode($this->get('images')),
                'details' => $this->get('details'),
            );


            if (!$id) {
                $data['created'] =  time();
            }
            $bool = $id ? p_update('calligraphy', $data, array('id' => $id)) : p_insert('calligraphy', $data);
            message($bool ? '操作成功': '操作失败', $this->createWebUrl('calligraphy'), $bool ? 'success': 'error');
        } elseif ($op == 'addShow' || $op == 'editShow') {
            $calligraphy  = p_get('calligraphy', array('id' => $id));
            //$calligraphy['images'] = json_decode($calligraphy['images'], true);
            $calligraphy['images'] = $this->getImagesInfo($calligraphy['images']);
            include $this->template('calligraphy_add');
        } elseif($op == 'is_down'){
            $status = $this->get('status');
            $bool = p_update('calligraphy', array('status' => $status), array('id' => $id));
            json('', $bool ? 1 : 0);
        } elseif($op == 'delete'){
            $bool = p_delete('calligraphy', array('id' => $id));
            json('', $bool ? 1 : 0);
        } else {
            $page   = $this->get('page');
            $where  = "is_delete = 1 ".get_uniacid();
            $calligraphy = $this->lucks->getTableList('calligraphy',$page, $where);

            if ($calligraphy['list']) {
                foreach ($calligraphy['list'] as & $value) {
                    $value['images'] = $this->getSubmission($value['images'], 2);
                    $value['peopleNumber'] = p_getcolumn('calligraphy_member', array('calligraphy_id' => $value['id']), 'COUNT(*)');
                    $value['number'] = $this->getCalligraphy($value['id']);
                    $value['sum']   = p_getcolumn('calligraphy_member', array('calligraphy_id' => $value['id']), 'SUM(success)') ? : 0;


                }
            }
            include $this->template('calligraphy');
        }
    }



    public function getImagesInfo($submission)
    {
        if ($submission) {
            $data = json_decode($submission, true);
            $string = "";
            foreach ($data as $val) {
                $src = getImage($val);
               /* $string .= "<div class='multi-item'>
                            <img class='img-responsive img-thumbnail' src='{$src}'>
                            <input type='hidden' name='images[]' value='{$val}'>
                            <em class='close' style='position:absolute; top: 0px; right: -14px;' title='删除这张图片' onclick='deleteImage(this)'>×</em>
                            </div>";*/

                $string .= "<div class='multi-item'>  
                        <img src='{$src}' onerror='this.src='./resource/images/nopic.jpg'; this.title='图片未找到.'' class='img-responsive img-thumbnail'>  
                        <input type='hidden' name='images[]' value='{$val}' >  
                        <em class='close' title='删除这张图片' onclick='deleteMultiImage(this)'>×</em>  
                        </div> ";

            }
            return $string;
        }
        return '';
    }


    protected function getCalligraphy($calligraphyId)
    {
        $details = p_getall('calligraphy_details', array('calligraphy_id' => $calligraphyId));

        $word = '';
        if ($details) {
            foreach ($details as $v) {
                $word .= $v['word']. ',';
            }
        }

        return substr($word, 0,'-1');

    }

    public function doWebCalligraphyLog()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];

        $page   = $this->get('page');
        $where  = "1 = 1 ".get_uniacid();

        $nickname = $this->get('nickname');
        $member_ids = $this->lucks->searchMember($nickname);
        if ($member_ids) {
            $where .= " AND member_id in ({$member_ids})";
        }
        $calligraphyLog = $this->lucks->getTableList('calligraphy_member_log',$page, $where);
        $status = array(
            1 => '未使用',
            2 => '已兑换',
            3 => '已赠送好友',

        );
        if ($calligraphyLog['list']) {
            foreach ($calligraphyLog['list'] as & $value) {
                $value['nickname'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                $value['calligraphyName'] = p_getcolumn('calligraphy', array('id' => $value['calligraphy_id']), 'name');
                $value['source'] = $value['source'] ==1 ? '参与抽奖获得' : '好友赠送';
                $value['status'] = $status[$value['status']];
                $value['word'] = p_getcolumn('calligraphy_details', array('id' => $value['calligraphy_details_id']),'word');
                if ($value['give_id'] > 0) {
                    $value['give_id'] = p_getcolumn('memberinfo', array('id' => $value['give_id']), 'nickname');
                }
            }
        }
        include $this->template('calligraphyLog');

    }

    public function doWebCalligraphyOrder()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];

        $page   = $this->get('page');
        $op = $this->get('op');
        $id = $this->get('id');
        if ($op == 'editShow')  {
            $order = p_get('calligraphy_order', array('id' => $id));
            $order['nickname'] = p_getcolumn('memberinfo', array('id' => $order['member_id']), 'nickname');
            $order['name'] = p_getcolumn('calligraphy', array('id' => $order['calligraphy_id']), 'name');
            include $this->template('calligraphyOrder_edit');
        } elseif($op == 'sends'){
            $orderId = $this->get('orderId');
            $data = array(
                'courier_name' => $this->get('courier_name'),
                'courier_number' => $this->get('courier_number'),
                'status' => $this->get('status'),
                'delivery_time' => time(),
            );
            $bool = p_update('calligraphy_order', $data, array('id' => $orderId));
            message($bool ? '操作成功': '操作失败', $this->createWebUrl('calligraphyOrder'), $bool ? 'success': 'error');
        } elseif($op == 'is_down'){
            $status = $this->get('status');
            $bo = p_update('calligraphy_order', array('status' => $status), array('id' => $id));
            json('' , $bo ? 1: 0);
        } elseif ($op == 'delete') {
            $bo = p_delete('calligraphy_order', array('id' => $id));
            json('' , $bo ? 1: 0);
        } else {
            $where  = "1 = 1 ".get_uniacid();
            $nickname = $this->get('nickname');
            $member_ids = $this->lucks->searchMember($nickname);
            if ($member_ids) {
                $where .= " AND member_id in ({$member_ids})";
            }
            $calligraphyOrder = $this->lucks->getTableList('calligraphy_order',$page, $where);
            if ($calligraphyOrder['list']) {
                $status= array(
                    1 => '未发货',
                    2 => '已发货',
                    3 => '已完成',
                    4 => '已取消',
                );
                foreach ($calligraphyOrder['list'] as & $value) {
                    $value['nickname'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                    $value['calligraphyName'] = p_getcolumn('calligraphy', array('id' => $value['calligraphy_id']), 'name');
                    $value['st'] = $status[$value['status']];
                    $value['delivery_time'] = $value['delivery_time'] > 0 ?  date('Y-m-d H:i:s', $value['delivery_time']) : '未发货';
                }
            }
            include $this->template('calligraphyOrder');
        }

    }
    public function doWebCalligraphyInfo()
    {
        $op = $this->get('op');
        $calligraphyId = $this->get('calligraphyId');
        $id = $this->get('id');
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        if($op == 'add' || $op == 'edit') {
            $data = array(
                'calligraphy_id' => $calligraphyId,
                'word' => $this->get('word'),
                'weight' => $this->get('weight'),
                'sort' => $this->get('sort'),
            );
            $bool = $id ? p_update('calligraphy_details', $data, array('id' => $id)) : p_insert('calligraphy_details', $data);
            message($bool ? '操作成功': '操作失败', $this->createWebUrl('calligraphyInfo', array('calligraphyId' => $calligraphyId)), $bool ? 'success': 'error');
        } elseif($op == 'addShow' || $op == 'editShow'){
            $calligraphyInfo = p_get('calligraphy_details', array('id' => $id));
            include $this->template('calligraphyInfo_add');
        } elseif($op == 'delete') {

            $bool = p_delete('calligraphy_details', array('id' => $id));
            json('', $bool ? 1 : 0);
        } else {

            $page   = $this->get('page');
            $where  = "calligraphy_id = {$calligraphyId} ".get_uniacid();

            $calligraphyInfo = $this->lucks->getTableList('calligraphy_details',$page, $where);
            if ($calligraphyInfo['list']) {
                foreach ($calligraphyInfo['list'] as & $value) {
                    $value['name'] = p_getcolumn('calligraphy', array('id' => $value['calligraphy_id']), 'name');
                }
            }

            include $this->template('calligraphyInfo');
        }


    }

    public function doWebActivity()
    {
        $op = $this->get('op');
        $id = $this->get('id');
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        if ($op == 'add' || $op == 'edit') {
            $data = array(
                'name'      => $this->get('name'),
                'start_time'=> strtotime($this->get('start_time')),
                'end_time'  => strtotime($this->get('end_time')),
                'is_home'   => $this->get('is_home'),
                'integral'  => $this->get('integral'),
                'base_map'  => $this->get('base_map'),
                'share_img'  => $this->get('share_img'),
                'sort'      => $this->get('sort'),
                'fabulous_number'      => $this->get('fabulous_number'),
            );
            if (!$id) {
                $data['created'] = time();
            }
            $bool = $id ? p_update('hd_activity', $data, array('id' => $id)) : p_insert('hd_activity', $data);
            message($bool ? '操作成功': '操作失败', $this->createWebUrl('activity'), $bool ? 'success': 'error');
        } elseif ($op == 'addShow' || $op == 'editShow') {
            $activity = p_get('hd_activity', array('id' => $id));
            include $this->template('activity_add');
        } elseif($op == 'delete'){
            $bool = p_delete('hd_activity', array('id' => $id));
            json('', $bool ? 1 : 0);
        } else {
            $page   = $this->get('page');
            $where  = "is_delete = 1".get_uniacid();
            $activity = $this->lucks->getTableList('hd_activity',$page, $where);
            if ($activity['list']) {
                foreach ($activity['list'] as & $value) {
                    $value['fabulous'] = p_getcolumn('hd_activity_fabulous', array('activity_id' => $value['id']), 'COUNT(*)') ? : 0;
                    $value['participate'] = p_getcolumn('hd_activity_participate', array('activity_id' => $value['id']), 'COUNT(*)')  ? : 0;
                }
            }
            include $this->template('activity');
        }
    }


    public function doWebPicture()
    {
        $op = $this->get('op');
        $id = $this->get('id');
        $activityId = $this->get('activityId');
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];

        if ($op == 'add' || $op == 'edit') {
            $data = array(
                'activity_id' => $activityId,
                'title'       => $this->get('title'),
                'image'       => $this->get('image'),
                'type'       => $this->get('type'),
                'url'       => $this->get('url'),
                'sort'       => $this->get('sort'),
            );
            if (!$id) {
                $data['created'] = time();
            }
            if ($data['type'] ==2) {
                $data['appid'] = $this->get('appid');
            }
            $bool = $id ? p_update('hd_head_picture', $data, array('id' => $id)) : p_insert('hd_head_picture', $data);
            message($bool ? '操作成功': '操作失败', $this->createWebUrl('picture', array('activityId' => $activityId)), $bool ? 'success': 'error');
        } elseif ($op == 'addShow' || $op == 'editShow') {
            $picture = p_get('hd_head_picture', array('id' => $id));
            include $this->template('picture_add');
        } elseif ($op == 'delete') {
            $bool = p_delete('hd_head_picture', array('id' => $id));
            json('', $bool ? 1 : 0);
        } else {
            $page   = $this->get('page');
            $where  = "activity_id = {$activityId}".get_uniacid();
            $picture = $this->lucks->getTableList('hd_head_picture',$page, $where);
            if ($picture['list']) {
                $type = array(
                    1 => '当前小程序',
                    2 => '其他小程序',
                    3 => 'H5'
                );
                foreach ($picture['list'] as & $value) {
                    $value['name'] = p_getcolumn('hd_activity', array('id' => $value['activity_id']), 'name');
                    $value['type'] = $type[$value['type']];
                }
            }
            include $this->template('picture');
        }
    }


    public function doWebParticipate()
    {
        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $id = $this->get('id');
        $op = $this->get('op');

        if ($op == 'add' || $op == "edit") {
            $data = array(
                'activity_id' => $this->get('activity_id'),
                'member_id' => $this->get('member_id'),
                'title' => $this->get('title'),
                'content' => $this->get('content'),
                'images' => json_encode($this->get('images')),
                'forward' => $this->get('forward'),
                'fabulous' => $this->get('fabulous'),
                'sort' => $this->get('sort'),
            );
            if(!$id) {
                $data['created'] = time();
            } else {
                $data['updated'] =time();
            }
            $bool = $id ? p_update('hd_activity_participate', $data, array('id' => $id)) : p_insert('hd_activity_participate', $data);
            message($bool ? '操作成功': '操作失败', $this->createWebUrl('participate'), $bool ? 'success': 'error');
        } elseif ($op == 'addShow' || $op == 'editShow') {
            $activity = p_getall('hd_activity', array('is_delete' => 1));
            $participate = p_get('hd_activity_participate', array('id' => $id));
            $participate['images'] = json_decode($participate['images'], true);
            include $this->template('participate_add');
        } elseif($op == 'delete'){
            $bool = p_delete('hd_activity_participate', array('id' => $id));
            json('', $bool ? 1 : 0);
        } elseif($op == 'audit') {
            $status = $this->get('status');
            $person = $this->get('person');
            $bool = p_update('hd_activity_participate', array('status' => $status), array('id' => $id));
            if ($status == 2) {
                $activityParticipate = p_get('hd_activity_participate', array('id' => $id));
                $integral = p_get('hd_activity', array('id' => $activityParticipate['activity_id']));
                $bool = (new vote())->change_integral($activityParticipate['member_id'], $integral['integral'], 15, '参加活动('.  $integral['name']. ')' );
            }

            $activity = p_get('hd_activity_participate', array('id' => $id));
            if ($activity) {
                $option = array(
                    'appid' => $this->w['uniaccount']['key'],
                    'secret' => $this->w['uniaccount']['secret'],
                );
                $wxObj = new Wxadoc($option);

                $openid = p_getcolumn('memberinfo', array('id' => $activity['member_id']), 'openid');
                $projectName = p_getcolumn('hd_activity', array('id' => $activity['activity_id']), 'name');
                $projectName = strlen($projectName) > 19 ? mb_substr($projectName, 0 ,18) : $projectName;
                $content = array(
                    'thing1'            => array('value' => $projectName),
                    'phrase2'           => array('value' => $status == 2 ? '通过': '未通过'),
                    'time3'             => array('value' => date('Y').'年'.date('m'). '月'.date('d').'日'),
                    'thing4'            => array('value' => $status ? '点击查看详情': $person),
                );

                $urlPath = $status == 2 ?  'interaction/pages/detail/detail?id='.$id : 'interaction/pages/my/my';
                $sucData = $wxObj->sendSubscribe($openid, getConfig('examine_notice_id'), $urlPath, $content);
                if ($sucData['errcode'] !=0) {
                    file_put_contents('auditLog.txt', $sucData['errcode'] .'错误值'.$sucData['errmsg'] . PHP_EOL , FILE_APPEND);
                }
            }

            json('', $bool ? 1 : 0);

        } else{
            $page   = $this->get('page');
            $where  = "1 = 1". get_uniacid();
            if ($nickname = $this->get('nickname')) {
                $where .= " AND member_id in ({$this->getMemberId($nickname)})";
            }
            if ($name = $this->get('name')) {
                $where .= " AND activity_id in ({$this->getActivityId($name)})";
            }
            if ( 0 != $statu = $this->get('status')) {
                $where .= " AND status ={$statu}";
            }
            $participate = $this->lucks->getTableList('hd_activity_participate',$page, $where);
            if ($participate['list']) {
                $status = array(
                    1 => '审核中',
                    2 => '审核通过',
                    3 => '审核未通过'
                );
                foreach ($participate['list'] as & $value) {
                    $value['name'] = p_getcolumn('hd_activity', array('id' => $value['activity_id']), 'name');
                    $value['nickname'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
                    $value['images'] = $this->getSubmission($value['images'], 2);
                    $value['statu'] = $status[$value['status']];
                }
            }

            include $this->template('participate');
        }

    }
    public function doWebActivityFabulous()
    {

        $siteRoot = $this->siteRoot;
        $modular_name = $this->gpc['m'];
        $page   = $this->get('page');
        $participate_id = $this->get('id');
        $where  = "participate_id = {$participate_id} ". get_uniacid();
        $fabulous = $this->lucks->getTableList('hd_activity_fabulous',$page, $where);
        if ($fabulous['list']) {
            foreach ($fabulous['list'] as & $value) {
                $fabulous['name'] = p_getcolumn('hd_activity', array('id' => $value['activity_id']), 'name');
                $fabulous['nickname'] = p_getcolumn('memberinfo', array('id' => $value['member_id']), 'nickname');
            }
        }
        include $this->template('activityFabulous');

    }
    private function setPayment()
    {
        WxPayConfig::$APPID = $this->w['uniaccount']['key'];
        WxPayConfig::$MCHID = $this->w['account']['setting']['payment']['wechat']['mchid'];
        WxPayConfig::$KEY = $this->w['account']['setting']['payment']['wechat']['signkey'];
        WxPayConfig::$APPSECRET = $this->w['uniaccount']['secret'];

        $apiclient_cert = getConfig('apiclient_cert');
        if (!empty($apiclient_cert)) {
            WxPayConfig::$SSLCERT_PATH = $apiclient_cert;
        }
        $apiclient_key = getConfig('apiclient_key');
        if (!empty($apiclient_key)) {
            WxPayConfig::$SSLKEY_PATH = $apiclient_key;
        }
    }

    /**
     * 获取用户ids
     * @param $nickname
     * @return bool|string
     */
    public function getMemberId($nickname)
    {
        $table = prefix('memberinfo');
        $where = " 1 = 1 AND nickname LIKE '%{$nickname}%'";
        $member = p_fetchall("SELECT * FROM {$table} WHERE  {$where}");
        if ($member) {
            foreach ($member as $item) {
                $member_id[] = $item['id'];
            }
        }
        if ($member_id) {
            return implode(',', $member_id);
        }
        return false;

    }

    public function getActivityId($name)
    {
        $table = prefix('hd_activity');
        $where = " 1 = 1 AND name LIKE '%{$name}%'";
        $member = p_fetchall("SELECT * FROM {$table} WHERE  {$where}");
        if ($member) {
            foreach ($member as $item) {
                $activityId[] = $item['id'];
            }
        }
        if ($activityId) {
            return implode(',', $activityId);
        }
        return false;
    }

    public function getGoodsId($goodsName)
    {
        $table = prefix('integral_goods');
        $where = " 1 = 1 AND goods_name LIKE '%{$goodsName}%'";
        $member = p_fetchall("SELECT id,goods_name,type FROM {$table} WHERE  {$where}");
        $goods_id = array();
        if ($member) {
            foreach ($member as $item) {
                $goods_id[] = $item['id'];
            }
        }
        if ($goods_id) {
            return implode(',', $goods_id);
        }
        return false;
    }

    public function doWebEditorUpload()
    {
        if (!isset($_FILES['imgFile'])) {
            json('请上传图片', 0);
        }
        load()->func('file');
        $reslut = file_upload($_FILES['imgFile']);
        if (isset($reslut['errno'])) {
            json($reslut['message'], 0);
        }
        $pic =  '/' . $reslut['path'];

        if (is_oss()) {
            $remotestatus = file_remote_upload($reslut['path']);
            if (is_error($remotestatus)) {
                json('远程附件上传失败', 0);
            }
        }

        die(json_encode(array('error' => 0, 'url' => getImage($pic))));
    }





}