var is_request = 1;

$(function () {
    if (surplus_time > 1) {
        showCountDown(surplus_time)
    }

    $('#administration').click(function () {
        var id = $(this).data('id')
        wx.miniProgram.navigateTo({url: '/bh_vote/pages/vote/myVoteDetail/myVoteDetail?id=' + id})
    });
});


function showCountDown(leftTime) {

    if (leftTime < 1) {
        location.href = location.href;
        return;
    }
    var dd = parseInt(leftTime / 60 / 60 / 24, 10);//计算剩余的天数
    var hh = parseInt(leftTime / 60 / 60 % 24, 10);//计算剩余的小时数
    var mm = parseInt(leftTime / 60 % 60, 10);//计算剩余的分钟数
    var ss = parseInt(leftTime % 60, 10);//计算剩余的秒数

    dd = checkTime(dd);
    hh = checkTime(hh);
    mm = checkTime(mm);
    ss = checkTime(ss);//小于10的话加0
    leftTime--;

    $('#down_dd').html(dd);
    $('#dowm_hh').html(hh);
    $('#dowm_mm').html(mm);
    $('#dowm_ss').html(ss);

    //t.setData({ surplus_time_msg: dd + "天 " + hh + "小时 " + mm + "分 " + ss + "秒", surplus_time: t.data.surplus_time});

    setTimeout(function(){
        showCountDown(leftTime)
    }, 1000)
}


function checkTime(i) {
    if (i < 10) {
        i = "0" + i;
    }
    return i;
}


function votePlayer(id) {
    if (is_request != 1) {
        return ;
    }
    is_request = 2;
    if (region_type == 2 && navigator.geolocation) {
        navigator.geolocation.getCurrentPosition(
            function (position) {
                longitude = position.coords.longitude;
                latitude = position.coords.latitude;

                var map = new BMap.Map("allmap");
                map.centerAndZoom(new BMap.Point(longitude, latitude), 11);
                // 创建地理编码实例
                var myGeo = new BMap.Geocoder();
                // 根据坐标得到地址描述
                myGeo.getLocation(new BMap.Point(longitude, latitude), function(result){
                    if (result){
                        var local = (result.addressComponents.province + ',' + result.addressComponents.city + ',' + result.addressComponents.district)
                        $.post(vote_url, {id:id, local:local}, function (data) {
                            is_request = 1;
                            if (data.status == 2) {
                                $('#tip_msg').html(data.info);
                                $('#activityEndTip').show();
                            } else {
                                $('#voteScuu' + succ_status).show();
                                $.each(joins_list, function (k, v) {
                                    if (v.id == id) {
                                        joins_list[k].vote_num = parseInt(joins_list[k].vote_num) + 1;
                                        return false;
                                    }
                                });

                                if (is_search == 2) {
                                    $('#search').click();
                                } else {
                                    loadPlayer(joins_list);
                                }
                                var all_vote_num = parseInt($('#all_vote_num').html()) + 1;
                                $('#all_vote_num').html(all_vote_num);
                            }

                        }, 'json');
                    }
                });
            },
            function (e) {
                throw(e.message);
            }
        )
    } else {
        $.post(vote_url, {id:id}, function (data) {
            is_request = 1;
            if (data.status == 2) {
                $('#tip_msg').html(data.info);
                $('#activityEndTip').show();
            } else {
                $('#voteScuu' + succ_status).show();
                $.each(joins_list, function (k, v) {
                    if (v.id == id) {
                        joins_list[k].vote_num = parseInt(joins_list[k].vote_num) + 1;
                        return false;
                    }
                });

                if (is_search == 2) {
                    $('#search').click();
                } else {
                    loadPlayer(joins_list);
                }
                var all_vote_num = parseInt($('#all_vote_num').html()) + 1;
                $('#all_vote_num').html(all_vote_num);
            }

        }, 'json');
    }
}

function closeTipMsg(id) {
    $('#' + id).hide();
}

function luckDraw(id) {
    wx.miniProgram.navigateTo({url: '/bh_vote/pages/userGame/userGame?id=' + id})
}

function gotoHome() {
    wx.miniProgram.reLaunch({url: '/bh_vote/pages/index/index'})
}


function gotoDetails(id) {
    wx.miniProgram.navigateTo({url: '/bh_vote/pages/vote/detailsView/detailsView?id=' + id})
}

function createActivity(id) {
    wx.miniProgram.navigateTo({url: '/bh_vote/pages/vote/voteInput/voteInput?id=' + id})
}


function myCenter() {
    wx.miniProgram.navigateTo({url: '/bh_vote/pages/my/my'})
}