var _tools = require("../../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

function _defineProperty(t, a, e) {
    return a in t ? Object.defineProperty(t, a, {
        value: e,
        enumerable: !0,
        configurable: !0,
        writable: !0
    }) : t[a] = e, t;
}

var qqmapsdk, that, QQMapWX = require("../../../../utils/qqmap-wx-jssdk.min.js"), app = getApp();

Page({
    data: {
        selectText: "",
        image: [],
        auth_industry: [],
        name: "",
        category: "",
        introduction: "",
        showMap: !1,
        latitude: "",
        longitude: "",
        is_map: !0,
        address: "",
        shop_head: ""
    },
    cancleMap: function() {
        this.setData({
            showMap: !1
        }), this.data.address || this.newAddress(this.data.latitude, this.data.longitude);
    },
    getTextareaInput: function(t) {
        0 < t.detail.cursor ? this.setData({
            isHidePlaceholder: !0,
            foucs: !0
        }) : this.setData({
            isHidePlaceholder: !1,
            foucs: !1
        });
    },
    inputName: function(t) {
        this.setData({
            name: t.detail.value
        }), t.detail.value && this.setData({
            name_msg: !1
        });
    },
    inputIntroduce: function(t) {
        this.setData({
            introduction: t.detail.value
        });
    },
    bindAddress: function(t) {
        that.setData({
            address: t.detail.value
        }), t.detail.value && this.setData({
            address_msg: !1
        });
    },
    setAddress: function() {
        this.data.is_map && this.getMap();
    },
    getMap: function() {
        this.setData({
            showMap: !0,
            is_map: !1
        });
    },
    onReady: function() {
        wx.setNavigationBarColor({
            frontColor: "#000000"
        });
    },
    onLoad: function() {
        that = this;
        var t = {
            action: "authStart2",
            contr: "user",
            token: wx.getStorageSync("token")
        };
        _tools2.default.request(t, function(t) {
            that.setData(t.info), qqmapsdk = new QQMapWX({
                key: t.info.qq_map_key
            }), that.onInit();
        });
    },
    onInit: function() {
        this.data.latitude && this.data.longitude ? this.loadMap() : wx.getLocation({
            type: "wgs84",
            success: function(t) {
                console.log(t);
                var a = t.latitude, t = t.longitude;
                that.setData({
                    latitude: a,
                    longitude: t
                }), that.loadMap();
            },
            fail: function(t) {}
        });
    },
    loadMap: function() {
        var t = [ {
            latitude: this.data.latitude,
            longitude: this.data.longitude
        } ];
        that.setData({
            latitude: this.data.latitude,
            longitude: this.data.longitude,
            markers: t
        }), qqmapsdk.reverseGeocoder({
            location: {
                latitude: that.data.latitude,
                longitude: that.data.longitude
            },
            success: function(t) {}
        });
    },
    setMap: function(t) {
        var a = t.detail.latitude, t = t.detail.longitude;
        that.newAddress(a, t);
    },
    newAddress: function(t, a) {
        var e = [ {
            latitude: t,
            longitude: a
        } ];
        console.log(e), that.setData({
            latitude: t,
            longitude: a,
            markers: e
        }), qqmapsdk.reverseGeocoder({
            location: {
                latitude: t,
                longitude: a
            },
            success: function(t) {
                console.log(t), that.setData({
                    address: t.result.address_component.district + "•" + t.result.address_component.street_number,
                    address_msg: !1
                });
            }
        });
    },
    select: function() {
        wx.showActionSheet({
            itemList: that.data.auth_industry,
            success: function(t) {
                that.setData({
                    category: that.data.auth_industry[t.tapIndex]
                }), that.setData({
                    category_msg: !1
                }), console.log(that.data.auth_industry[t.tapIndex]);
            },
            fail: function(t) {
                console.log(t.errMsg);
            }
        });
    },
    nextstep: function() {
        var a = {}, t = !1;
        this.data.name ? a.name = this.data.name : (t = !0, this.setData({
            name_msg: !0
        })), this.data.category ? a.industry = this.data.category : (t = !0, this.setData({
            category_msg: !0
        })), this.data.introduction ? a.introduction = this.data.introduction : (t = !0, 
        wx.showToast({
            icon: "none",
            title: "请填写商家简介"
        })), this.data.shop_head ? a.shop_head = this.data.shop_head : (t = !0, wx.showToast({
            icon: "none",
            title: "请上传商家头像"
        })), this.data.address || (t = !0, this.setData({
            address_msg: !0
        })), a.address = this.data.address, a.longitude = this.data.longitude, a.latitude = this.data.latitude, 
        t || that.editorCtx.getContents({
            success: function(t) {
                a.brand = t.html, "<p><br></p>" != a.brand && a.brand ? (console.log(a), wx.setStorageSync("auth_data", a), 
                wx.navigateTo({
                    url: "/bh_vote/pages/attestation/start2/start2"
                })) : wx.showToast({
                    icon: "none",
                    title: "请填写商家介绍"
                });
            }
        });
    },
    addImg: function() {
        wx.chooseImage({
            count: 1,
            success: function(t) {
                _tools2.default.upload(t.tempFiles[0].path, function(t) {
                    that.setData({
                        shop_head_url: t.info.url,
                        shop_head: t.info.path
                    });
                });
            }
        });
    },
    delImg: function(t) {
        that.setData({
            shop_head_url: "",
            shop_head: ""
        });
    },
    onShareAppMessage: function() {
        return {
            title: this.data.share.text,
            imageUrl: this.data.share.images,
            path: "bh_vote/pages/index/index?parent_id=" + this.data.share.member_id
        };
    },
    getEditorValue: function(t) {
        this.setData(_defineProperty({}, "formData.content", t.detail.html));
    },
    onEditorReady: function() {
        wx.createSelectorQuery().select("#editor").context(function(t) {
            that.editorCtx = t.context;
        }).exec();
    },
    insertDivider: function() {
        this.editorCtx.insertDivider({
            success: function() {
                console.log("insert divider success");
            }
        });
    },
    format: function(t) {
        var a = t.target.dataset, t = a.name, a = a.value;
        t && this.editorCtx.format(t, a);
    },
    insertImage: function() {
        var a = this;
        wx.chooseImage({
            count: 1,
            success: function(t) {
                _tools2.default.upload(t.tempFiles[0].path, function(t) {
                    console.log(t), a.editorCtx.insertImage({
                        src: t.info.url,
                        data: {
                            id: "abcd",
                            role: "god"
                        },
                        success: function() {
                            console.log("insert image success");
                        }
                    });
                });
            }
        });
    }
});