var _Page, that, _tools = require("../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools), _weCropperMin = require("../../../utils/dist/we-cropper.min.js"), _weCropperMin2 = _interopRequireDefault(_weCropperMin);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

function _defineProperty(t, e, a) {
    return e in t ? Object.defineProperty(t, e, {
        value: a,
        enumerable: !0,
        configurable: !0,
        writable: !0
    }) : t[e] = a, t;
}

var device = wx.getSystemInfoSync(), app = getApp();

Page((_defineProperty(_Page = {
    data: {
        crop: !1,
        hours: [ "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23" ],
        minutes: [ "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", "55", "56", "57", "58", "59" ],
        lottery: [ !1, !0, !0, !0 ],
        titleIndex: 0,
        lotteryTitle: [ "到达设定时间自动开奖", "到达设定人数自动开奖", "发起人手动开奖", "用户参与即可看到抽奖结果" ],
        showTime: !1,
        senior_number: 0,
        price: 0,
        is_senior: 1,
        senior_source: 2,
        luck_mode: 1,
        luck_pwd: "",
        Textmsg: "任意提示文字",
        showState: !1,
        loading: !1,
        prize: [],
        image_text: [],
        lottery_explain: "",
        time: 1,
        lottery_time_show: "",
        yd_s: [ 1, 2, 3, 4, 5, 6, 7 ],
        d_key: 1,
        lottery_type: 1,
        lottery_value: 0,
        lottery_max_number: 1024,
        team_number_index: 0,
        prize_index: 0,
        open_senior: 1,
        is_share: 1,
        sponsor_name: "",
        sponsor_id: 0,
        height: device.windowHeight,
        appoint_group: 1,
        is_ad: 1,
        all_red: 0,
        cropperOpt: {
            id: "cropper",
            width: device.windowWidth,
            height: device.windowWidth / 630 * 320,
            scale: 2.5,
            zoom: 8
        },
        is_fans: 1,
        keyword: "",
        third_party_id: 0,
        third_party_name: ""
    },
    onLoad: function(t) {
        that = this;
        var e = {
            action: "init",
            contr: "luck",
            token: wx.getStorageSync("token")
        };
        _tools2.default.request(e, function(t) {
            that.setData(t.info), that.setData({
                yd_s: t.info.lottery_time.yd_s
            }), 2 == t.info.open_senior && that.setData({
                is_senior: 2
            });
        }), t.lottery_type && that.changetype(t.lottery_type);
        t = this.data.cropperOpt;
        new _weCropperMin2.default(t).on("ready", function(t) {
            console.log("wecropper is ready for work!");
        }).on("beforeImageLoad", function(t) {
            console.log("before picture loaded, i can do something"), console.log("current canvas context:", t), 
            wx.showToast({
                title: "加载中...",
                icon: "loading",
                duration: 2e4
            });
        }).on("imageLoad", function(t) {
            console.log("picture loaded"), console.log("current canvas context:", t), wx.hideToast();
        });
    },
    onReady: function() {
        wx.setNavigationBarColor({
            frontColor: "#000000"
        });
    },
    onShow: function() {
        var t = wx.getStorageSync("lottery_explain" + that.data.time);
        t && this.setData({
            lottery_explain: t
        });
        t = wx.getStorageSync("fictitiousindex");
        0 <= t && ((e = wx.getStorageSync("fictitious" + that.data.time + t)) && (this.data.prize[t].fictitious = e, 
        this.data.prize[t].fictitious_notice = !1, this.data.prize[t].fictitious_value = "已添加" + e.length + "个", 
        this.setData({
            prize: this.data.prize
        })));
        t = wx.getStorageSync("image_text" + that.data.time);
        t && that.setData({
            image_text: t
        });
        var e = wx.getStorageSync("sponsor" + that.data.time);
        e && that.setData({
            sponsor_name: e.sponsor_name,
            sponsor_id: e.id
        });
        t = wx.getStorageSync("authorization" + that.data.time);
        t && this.setData({
            third_party_id: t.id,
            third_party_name: t.name
        });
        e = wx.getStorageSync("goods_index_1" + +that.data.time), t = wx.getStorageSync("goods_" + this.data.time);
        e && (wx.removeStorageSync("goods_index_1" + +that.data.time), wx.removeStorageSync("goods_" + this.data.time), 
        t = {
            id: t.id,
            price: t.price,
            type: 1,
            name: t.name,
            url: t.url,
            number: 1
        }, 1 != this.data.senior_source ? that.setData({
            prize: [ t ],
            is_senior: 2,
            senior_source: 1
        }) : (this.data.prize[e] = t, this.setData({
            prize: this.data.prize
        })), this.calculation());
    },
    calculation: function() {
        if (1 == this.data.senior_source) {
            var t, e = 0;
            for (t in this.data.prize) e += parseInt(this.data.prize[t].number) * parseFloat(this.data.prize[t].price);
            this.setData({
                price: e
            });
        }
    },
    red_calculation: function() {
        if (2 == this.data.senior_source) {
            var t, e = 0;
            for (t in this.data.prize) 3 == this.data.prize[t].type && null != this.data.prize[t].red_money && null != this.data.prize[t].number && (e += 1 == this.data.prize[t].red_type ? this.data.prize[t].red_money : this.data.prize[t].red_money * parseInt(this.data.prize[t].number));
            this.setData({
                all_red: Math.ceil(100 * e) / 100
            });
        }
    },
    onHide: function(t) {},
    onUnload: function() {},
    onPullDownRefresh: function() {},
    onReachBottom: function() {},
    addprize: function() {
        var t;
        1 == this.data.senior_source ? (t = this.data.prize.length, wx.navigateTo({
            url: "/bh_vote/pages/shop/shop?type=1&time=" + that.data.time + "&index=" + t
        })) : (t = {
            type: 1,
            url: this.data.prize_default_picture.url,
            path: this.data.prize_default_picture.path
        }, this.data.prize.push(t), this.setData({
            prize: this.data.prize
        }));
    },
    delPrize: function(t) {
        t = t.currentTarget.dataset.index;
        1 < this.data.prize.length ? this.data.prize.splice(t, 1) : (t = {
            type: 1,
            url: this.data.prize_default_picture.url,
            path: this.data.prize_default_picture.path
        }, this.data.prize[0] = t, 1 == this.data.senior_source && 2 == this.data.is_senior && this.setData({
            senior_source: 2,
            is_senior: 1
        })), this.setData({
            prize: this.data.prize
        });
    },
    typeSwitch: function(t) {
        var e = t.target.dataset.index, t = t.target.dataset.t;
        this.data.prize[e].type = t, console.log(this.data.prize[e].red_type), 3 == t && null == this.data.prize[e].red_type && (this.data.prize[e].red_type = 1), 
        this.setData({
            prize: this.data.prize
        }), this.red_calculation();
    },
    setRedType: function(t) {
        t = t.target.dataset.index;
        console.log(this.data.prize[t].red_type), this.data.prize[t].red_type = 1 == this.data.prize[t].red_type ? 2 : 1, 
        this.setData({
            prize: this.data.prize
        }), this.red_calculation();
    },
    onShareAppMessage: function() {
        return {
            title: that.data.share.text,
            imageUrl: that.data.share.images,
            path: "bh_vote/pages/index/index?parent_id=" + that.data.member_id
        };
    },
    change: function() {
        wx.showActionSheet({
            itemList: [ "按时间自动开奖", "按人数自动开奖", "发起人手动开奖", "即抽即中" ],
            success: function(t) {
                that.changetype(t.tapIndex);
            },
            fail: function(t) {
                console.log(t.errMsg);
            }
        });
    },
    changetype: function(t) {
        that.setData({
            lottery_type: t + 1
        }), that.data.lottery = [ !0, !0, !0, !0 ], that.data.lottery[t] = !1, that.data.titleIndex = t, 
        that.setData({
            lottery: that.data.lottery,
            titleIndex: that.data.titleIndex
        });
    },
    showSelectTime: function() {
        this.set_lottery_time_show(), that.data.lottery[0] && that.data.lottery[3] ? console.log(2) : that.setData({
            showTime: !that.data.showTime
        });
    },
    touchStart: function(t) {
        this.wecropper.touchStart(t);
    },
    touchMove: function(t) {
        this.wecropper.touchMove(t);
    },
    touchEnd: function(t) {
        this.wecropper.touchEnd(t);
    },
    addImg: function(t) {
        t = t.currentTarget.dataset.index;
        that.data.prize_index = t, wx.chooseImage({
            count: 1,
            success: function(t) {
                t = t.tempFilePaths;
                that.setData({
                    crop: !0
                }), that.wecropper.pushOrign(t[0]);
            }
        });
    },
    cropimg: function(t) {
        var e = this;
        this.wecropper.getCropperImage(function(t) {
            t ? _tools2.default.upload(t, function(t) {
                e.data.prize[e.data.prize_index].url = t.info.url, e.data.prize[e.data.prize_index].image = t.info.path, 
                e.setData({
                    prize: e.data.prize,
                    crop: !1
                });
            }) : console.log("获取图片地址失败，请稍后重试");
        });
    },
    inputKeyword: function(t) {
        this.setData({
            keyword: t.detail.value
        });
    },
    inputPwd: function(t) {
        this.setData({
            luck_pwd: t.detail.value
        });
    },
    bindNameInput: function(t) {
        var e = t.currentTarget.dataset.index;
        that.data.prize[e].name = t.detail.value, that.data.prize[e].name_notice = !1, that.setData({
            prize: that.data.prize
        });
    },
    bindNumberInput: function(t) {
        var e = t.currentTarget.dataset.index;
        t.detail.value > this.data.max_number ? (that.data.prize[e].number_notice = !0, 
        that.data.prize[e].number_notice_value = "份数不能超过" + this.data.max_number) : (that.data.prize[e].number_notice = !1, 
        that.data.prize[e].number = t.detail.value), this.calculation(), 3 == that.data.prize[e].type && that.red_calculation(), 
        that.setData({
            prize: that.data.prize
        });
    },
    bindProbabilityInput: function(t) {
        var e = t.currentTarget.dataset.index;
        that.data.prize[e].probability_notice = !1, that.data.prize[e].probability = t.detail.value, 
        that.setData({
            prize: that.data.prize
        });
    },
    bindRedMoney: function(t) {
        var e = t.currentTarget.dataset.index, t = t.detail.value;
        0 < t && (that.data.prize[e].red_notice = !1, t = parseFloat(t)), that.data.prize[e].red_money = t, 
        that.setData({
            prize: that.data.prize
        }), that.red_calculation();
    },
    gotoExplain: function(t) {
        wx.navigateTo({
            url: "/bh_vote/pages/lotteryIntro/lotteryIntro?time=" + that.data.time + "&lottery_explain=" + that.data.lottery_explain
        });
    },
    addImageText: function(t) {
        wx.navigateTo({
            url: "/bh_vote/pages/editor/editor?time=" + that.data.time + "&audit_model=" + that.data.audit_model
        });
    },
    gotoAuthorization: function(t) {
        wx.navigateTo({
            url: "/bh_vote/pages/authorization/authorization?time=" + that.data.time
        });
    }
}, "addImageText", function(t) {
    wx.navigateTo({
        url: "/bh_vote/pages/editor/editor?time=" + that.data.time + "&audit_model=" + that.data.audit_model
    });
}), _defineProperty(_Page, "goToOfflineLotteryIntro", function() {
    wx.switchTab({
        url: "/bh_vote/pages/my/my"
    });
}), _defineProperty(_Page, "clearImageText", function() {
    wx.showModal({
        title: "提示",
        content: "确定清空",
        success: function(t) {
            t.confirm ? (that.setData({
                image_text: []
            }), wx.removeStorageSync("image_text" + that.data.time)) : t.cancel && console.log("用户点击取消");
        }
    });
}), _defineProperty(_Page, "addRedeem", function(t) {
    t = t.currentTarget.dataset.index;
    wx.navigateTo({
        url: "/bh_vote/pages/redeemCode/redeemCode?time=" + that.data.time + "&index=" + t
    });
}), _defineProperty(_Page, "goShop", function(t) {
    t = t.currentTarget.dataset.index;
    wx.navigateTo({
        url: "/bh_vote/pages/shop/shop?type=1&time=" + that.data.time + "&index=" + t
    });
}), _defineProperty(_Page, "gotoAddition", function() {
    wx.navigateTo({
        url: "/bh_vote/pages/luckSponsor/luckSponsor?time=" + that.data.time
    });
}), _defineProperty(_Page, "onDatetimeChange", function(t) {
    var e = t.detail.value;
    console.log(t), console.log(e), e[0] = e[0] < 0 ? 0 : e[0], e[1] = e[1] < 0 ? 0 : e[1], 
    e[2] = e[2] < 0 ? 0 : e[2], this.setData({
        d_key: e[0]
    });
    var a = this.data.yd_s[e[0]], i = this.data.hours[e[1]], t = this.data.minutes[e[2]], e = this.data.lottery_time;
    e.d = a, e.h = i, e.i = t, console.log(e), that.setData({
        lottery_time: e
    }), this.set_lottery_time_show();
}), _defineProperty(_Page, "set_lottery_time_show", function() {
    var t = this.data.lottery_time, e = t.yd[t.d].t + " " + t.h + ":" + t.i + " " + t.yd[t.d].i, a = parseInt(this.data.lottery_time.h), t = parseInt(this.data.lottery_time.i);
    console.log(this.data.lottery_time.d), this.setData({
        lottery_value: parseInt(this.data.lottery_time.d) + 3600 * a + 60 * t
    }), this.data.time >= this.data.lottery_value ? this.setData({
        lottery_value_notice: !0,
        lottery_value_notice_value: "日期不能早于当前"
    }) : this.setData({
        lottery_value_notice: !1
    }), this.setData({
        lottery_time_show: e
    });
}), _defineProperty(_Page, "bindNumInput", function(t) {
    this.setData({
        lottery_value: parseInt(t.detail.value)
    }), this.data.lottery_value > this.data.lottery_max_number ? this.setData({
        lottery_max_notice: !0
    }) : this.setData({
        lottery_max_notice: !1
    });
}), _defineProperty(_Page, "selTeamNumber", function(t) {
    t = t.currentTarget.dataset.index;
    this.setData({
        team_number_index: t
    });
}), _defineProperty(_Page, "newreceive", function(t) {
    that.data.dy_send_message_kj_id ? wx.requestSubscribeMessage({
        tmplIds: that.data.dy,
        success: function(t) {
            console.log(t);
        },
        fail: function(t) {
            console.log(t);
        },
        complete: function(t) {
            that.receive();
        }
    }) : that.receive();
}), _defineProperty(_Page, "receive", function() {
    var t = {
        token: wx.getStorageSync("token"),
        is_senior: this.data.is_senior,
        lottery_type: this.data.lottery_type,
        lottery_explain: this.data.lottery_explain,
        luck_mode: this.data.luck_mode,
        image_text: this.data.image_text,
        sponsor_id: this.data.sponsor_id,
        appoint_group: this.data.appoint_group,
        is_ad: this.data.is_ad,
        is_share: that.data.is_share
    }, e = !1;
    2 == t.is_senior && (t.senior_source = this.data.senior_source), t.lottery_type < 3 && (t.lottery_value = this.data.lottery_value, 
    2 == t.lottery_type && 1 == t.is_senior && (t.lottery_value > this.data.lottery_max_number || !t.lottery_value) ? (that.setData({
        lottery_max_notice: !0
    }), e = !0) : 1 == t.lottery_type && t.lottery_value <= this.data.time && (this.setData({
        lottery_value_notice: !0,
        lottery_value_notice_value: "日期不能早于当前"
    }), e = !0)), console.log(t.lottery_type), console.log(t.lottery_value), 4 == t.lottery_type && (t.lottery_value = this.data.lottery_value, 
    t.lottery_value <= this.data.time && (this.setData({
        lottery_value_notice: !0,
        lottery_value_notice_value: "日期不能早于当前"
    }), e = !0)), 4 == t.luck_mode && (t.luck_pwd = this.data.luck_pwd), 2 == t.luck_mode && (t.team_number = this.data.team_numbers[this.data.team_number_index]);
    this.data.prize;
    if (2 == t.is_senior && 1 == t.senior_source) {
        for (var a in this.data.prize) this.data.prize[a].name || (e = this.data.prize[a].name_notice = !0), 
        this.data.prize[a].number || (this.data.prize[a].number_notice = !0, this.data.prize[a].number_notice_value = "请输入奖品份数", 
        e = !0), 3 == this.data.titleIndex && (null == this.data.prize[a].probability || this.data.prize[a].probability <= 0) && (e = this.data.prize[a].probability_notice = !0);
        that.setData({
            prize: this.data.prize
        });
    } else {
        for (var a in this.data.prize) this.data.prize[a].name || (e = this.data.prize[a].name_notice = !0), 
        2 != this.data.prize[a].type ? (this.data.prize[a].number ? this.data.prize[a].number > this.data.max_number && (this.data.prize[a].number_notice = !0, 
        this.data.prize[a].number_notice_value = "份数不能超过" + this.data.max_number, e = !0) : (this.data.prize[a].number_notice = !0, 
        this.data.prize[a].number_notice_value = 3 == this.data.prize[a].type ? "请输入红包份数" : "请输入奖品份数", 
        e = !0), 3 != this.data.prize[a].type || null != this.data.prize[a].red_money && this.data.prize[a].red_money || (e = this.data.prize[a].red_notice = !0)) : (!this.data.prize[a].fictitious || this.data.prize[a].fictitious.length < 1) && (e = this.data.prize[a].fictitious_notice = !0), 
        3 == this.data.titleIndex && (null == this.data.prize[a].probability || this.data.prize[a].probability <= 0) && (e = this.data.prize[a].probability_notice = !0);
        that.setData({
            prize: this.data.prize
        });
    }
    if (t.prize = this.data.prize, 0 < t.image_text.length) for (var i in t.image_text) if (3 == t.image_text[i].type) {
        if (!t.image_text[i].text) return void wx.showToast({
            icon: "none",
            title: "请输入引导文案"
        });
        if (!t.image_text[i].copy) return void wx.showToast({
            icon: "none",
            title: "请输入复制内容"
        });
    }
    if (t.is_fans = this.data.is_fans, 2 == this.data.is_fans) {
        if (this.data.third_party_id < 1) return void wx.showToast({
            icon: "none",
            title: "请授权公众号"
        });
        if (t.third_party_id = this.data.third_party_id, !this.data.keyword) return void wx.showToast({
            icon: "none",
            title: "请设置回复关键字"
        });
        t.keyword = this.data.keyword;
    }
    e || _tools2.default.request(t, function(e) {
        3 == e.status ? wx.requestPayment({
            timeStamp: e.info.paydata.timeStamp,
            nonceStr: e.info.paydata.nonceStr,
            package: e.info.paydata.package,
            signType: e.info.paydata.signType,
            paySign: e.info.paydata.paySign,
            success: function(t) {
                that.luckSsuccess(e.info.luck_id);
            },
            fail: function(t) {
                console.log(t);
            }
        }) : that.luckSsuccess(e.info.luck_id);
    }, function() {}, function() {}, "", !0, "entry/wxapp/create");
}), _defineProperty(_Page, "luckSsuccess", function(t) {
    2 == this.data.luck_examine ? (wx.showToast({
        title: "发起成功"
    }), setTimeout(function() {
        wx.reLaunch({
            url: "/bh_vote/pages/userGame/userGame?id=" + t
        });
    }, 1200)) : wx.showModal({
        title: "提示",
        mask: !0,
        content: "发起成功,等待管理员审核",
        showCancel: !1,
        success: function(t) {
            t.confirm ? wx.reLaunch({
                url: "/bh_vote/pages/index/index"
            }) : t.cancel;
        }
    });
}), _defineProperty(_Page, "changeToProView", function() {
    0 < this.data.senior_number || 2 == this.data.open_senior ? that.setData({
        is_senior: 2,
        senior_source: 2
    }) : wx.navigateTo({
        url: "/bh_vote/pages/highLevelText/highLevelText"
    });
}), _defineProperty(_Page, "goToSelfSubmit", function() {
    wx.navigateTo({
        url: "/bh_vote/pages/goIndexIntro/goIndexIntro"
    });
}), _defineProperty(_Page, "ordinary", function() {
    var t = [ {
        url: this.data.prize_default_picture.url,
        image: "",
        type: 1,
        name: "",
        number: ""
    } ];
    that.setData({
        is_senior: 1,
        senior_source: 2,
        prize: t
    });
}), _defineProperty(_Page, "switch2Change", function(t) {
    that.setData({
        luck_mode: t.detail.value ? 4 : 1
    });
}), _defineProperty(_Page, "switchFans", function(t) {
    t = t.detail.value ? 2 : 1;
    that.setData({
        is_fans: t
    }), 2 == t && that.setData({
        appoint_group: 1
    });
}), _defineProperty(_Page, "switch3Change", function(t) {
    t = t.detail.value ? 2 : 1;
    that.setData({
        luck_mode: t
    }), 2 == t && that.setData({
        appoint_group: 1,
        is_share: 1
    });
}), _defineProperty(_Page, "switch4Change", function(t) {
    console.log(this.data.appoint_group);
    t = t.detail.value ? 2 : 1;
    that.setData({
        appoint_group: t
    }), 2 != that.data.luck_mode && 3 != that.data.luck_mode || (console.log(222), that.setData({
        luck_mode: 1
    })), 2 == t && that.setData({
        is_fans: 1
    });
}), _defineProperty(_Page, "switchCode", function(t) {
    t = t.detail.value ? 3 : 1;
    that.setData({
        luck_mode: t
    }), 3 == t && that.setData({
        appoint_group: 1,
        is_share: 1
    });
}), _defineProperty(_Page, "switchShare", function(t) {
    console.log(t.detail.value);
    t = t.detail.value ? 1 : 2;
    that.setData({
        is_share: t
    }), 2 == t && that.setData({
        luck_mode: 1
    });
}), _defineProperty(_Page, "switchTips4", function(t) {}), _defineProperty(_Page, "switch5Change", function(t) {
    that.setData({
        is_ad: t.detail.value ? 2 : 1
    });
}), _defineProperty(_Page, "switchTips", function(t) {
    1 != that.data.luck_mode && (t = t.target.dataset.mode, that.data.luck_mode != t && wx.showToast({
        icon: "none",
        title: "组队,口令,好友助力三选一"
    }));
}), _defineProperty(_Page, "pwdTipsIcon", function() {
    that.setData({
        showState: !0,
        Textmsg: this.data.tips.pwd
    });
}), _defineProperty(_Page, "groupTipsIcon", function() {
    that.setData({
        showState: !0,
        Textmsg: this.data.tips.group
    });
}), _defineProperty(_Page, "additionTipsIcon", function() {
    that.setData({
        showState: !0,
        Textmsg: this.data.tips.addition
    });
}), _defineProperty(_Page, "appointGroupTipsIcon", function() {
    that.setData({
        showState: !0,
        Textmsg: this.data.tips.appoint_group
    });
}), _defineProperty(_Page, "codeTipsIcon", function() {
    that.setData({
        showState: !0,
        Textmsg: this.data.tips.code_tips
    });
}), _defineProperty(_Page, "shareTipsIcon", function() {
    that.setData({
        showState: !0,
        Textmsg: this.data.tips.share_tips
    });
}), _defineProperty(_Page, "officialAccountMsg", function() {
    that.setData({
        showState: !0,
        Textmsg: this.data.tips.official_account_tips
    });
}), _defineProperty(_Page, "closeBox", function() {
    that.setData({
        showState: !1
    });
}), _defineProperty(_Page, "goVote", function() {
    wx.navigateTo({
        url: "/bh_vote/pages/vote/voteList/voteList"
    });
}), _defineProperty(_Page, "goIndex", function() {
    wx.reLaunch({
        url: "/bh_vote/pages/index/index"
    });
}), _Page));