var _tools = require("../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var that, app = getApp();

function e(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var i = e(require("./modules/base-canvas-palette.js")), n = e(require("../../../utils/wx-promisify/wx-promisify.js")), d = e(require("./modules/handle-create-img.js")), h = ((0, 
n.default)(wx.getSetting), 0), p = 0;

Page({
    data: {
        motto: "Hello World",
        userInfo: {},
        showState: !0,
        id: 0,
        w: 370,
        creat_img: !0
    },
    onReady: function() {
        wx.setNavigationBarColor({
            frontColor: "#000000"
        });
        var t = {
            action: "embed",
            contr: "luck",
            id: this.data.id,
            token: wx.getStorageSync("token")
        };
        _tools2.default.request(t, function(t) {
            that.setData(t.info), that.generatePoster();
        });
    },
    generatePoster: function() {
        this.data.poster = {
            z_h: 300,
            content: [ {
                type: "image",
                url: this.data.image,
                css: {
                    top: "0rpx",
                    left: "0rpx",
                    width: that.data.w + "rpx",
                    height: "220rpx",
                    mode: "scaleToFill"
                }
            }, {
                type: "text",
                text: this.data.font,
                css: Object.assign({
                    top: "230rpx",
                    left: "10rpx",
                    maxLines: 1,
                    width: that.data.w + "rpx",
                    color: "#000000",
                    fontSize: "23rpx"
                })
            }, {
                type: "text",
                text: this.data.font_text,
                css: Object.assign({
                    top: "265rpx",
                    left: "10rpx",
                    maxLines: 3,
                    width: that.data.w + "rpx",
                    color: "#ADADAD",
                    fontSize: "20rpx"
                })
            } ]
        }, wx.showLoading({
            title: "正在生成图片",
            mask: !0
        }), d.default.doCreateImg(this);
        try {
            getApp().sensors.track("XMClick", {
                ck_module: "保存图片",
                page: "投票海报"
            });
        } catch (t) {}
    },
    imgErr: function(t) {
        console.log(22222), d.default.createImgFail(t);
    },
    onImgOK: function(t) {
        wx.hideLoading(), console.log(t.detail.path), that.setData({
            newurl: t.detail.path,
            creat_img: !1
        });
    },
    onLoad: function(t) {
        (that = this).setData({
            id: t.id
        });
    },
    onShareAppMessage: function() {
        return {
            title: this.data.share.text,
            imageUrl: this.data.share.images,
            path: "bh_vote/pages/index/index?parent_id=" + this.data.share.member_id
        };
    },
    copyText: function(t) {
        t = t.currentTarget.dataset.value;
        wx.setClipboardData({
            data: t,
            success: function(t) {
                wx.showToast({
                    title: "复制成功"
                }), that.closecopy();
            }
        });
    },
    downImage: function() {
        wx.saveImageToPhotosAlbum({
            filePath: this.data.newurl,
            success: function(t) {
                wx.showToast({
                    title: "保存成功"
                });
            }
        });
    }
});