var _tools = require("../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var that, WxParse = require("../../wxParse/wxParse.js"), app = getApp();

Page({
    data: {
        share_text: "",
        share_image: "",
        member_id: 0,
        isIphoneX: !1,
        show: !1,
        s_index: 0,
        number: 1,
        source: 1,
        index: 0
    },
    onLoad: function(t) {
        that = this, t.id && (this.data.id = t.id), t.type && that.setData({
            type: t.type
        }), t.time && that.setData({
            time: t.time
        }), t.index && that.setData({
            index: t.index
        });
    },
    onReady: function() {
        wx.setNavigationBarColor({
            frontColor: "#000000"
        }), wx.getSystemInfo({
            success: function(t) {
                "ios" == t.platform && (that.setData({
                    isIphone: !0
                }), -1 < t.model.indexOf("iPhone X") && that.setData({
                    isIphoneX: !0
                }));
            }
        });
    },
    onShow: function() {
        var t = {
            action: "details",
            contr: "goods",
            token: wx.getStorageSync("token"),
            id: this.data.id
        };
        _tools2.default.request(t, function(t) {
            that.setData(t.info);
            t = t.info.goods.details;
            console.log(t), WxParse.wxParse("article", "html", t, that, 5);
        });
        var e = wx.getUpdateManager();
        e.onCheckForUpdate(function(t) {
            console.log(t.hasUpdate);
        }), e.onUpdateReady(function() {
            wx.showModal({
                title: "更新提示",
                content: "新版本已经准备好，是否重启应用？",
                success: function(t) {
                    t.confirm && e.applyUpdate();
                }
            });
        }), e.onUpdateFailed(function() {
            wx.showModal({
                title: "更新提示",
                content: "新版本下载失败",
                showCancel: !1
            });
        });
    },
    onHide: function() {},
    onInput: function(t) {
        this.setData({
            number: t.detail.value
        });
    },
    onMinus: function() {
        1 < this.data.number && this.setData({
            number: --this.data.number
        });
    },
    onPlus: function() {
        this.setData({
            number: ++this.data.number
        });
    },
    switchModel: function(t) {
        this.setData({
            s_index: t.currentTarget.dataset.index
        });
    },
    closeSelectPanel: function() {
        this.setData({
            show: !1
        });
    },
    handleTap: function() {
        var t = {
            id: this.data.goods.id,
            name: this.data.goods.name,
            price: this.data.goods.price,
            url: this.data.goods.cover_image
        };
        wx.setStorageSync("goods_index_" + this.data.type + this.data.time, this.data.index), 
        wx.setStorageSync("goods_" + this.data.time, t), wx.navigateBack({
            delta: 2
        });
    },
    onUnload: function() {},
    onPullDownRefresh: function() {},
    onReachBottom: function() {},
    onShareAppMessage: function() {
        return {
            title: this.data.share.text,
            imageUrl: this.data.share.images,
            path: "bh_vote/pages/index/index?parent_id=" + this.data.share.member_id
        };
    }
});