var _tools = require("../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var that, app = getApp();

Page({
    data: {
        nav: {
            title: "创建加粉",
            showHome: !0,
            isHomePage: !1
        },
        sel_index: 0,
        followData: [ {
            startname: "小程序",
            stype: 2,
            name: "小程序名称"
        }, {
            startname: "公众号",
            stype: 3,
            name: "公众号名称",
            is_image: 1
        }, {
            startname: "微信号",
            stype: 4,
            name: "微信昵称",
            is_image: 1
        }, {
            startname: "微信群",
            stype: 5,
            name: "群昵称",
            is_image: 1
        } ],
        codeImg: "../../images/icon_add.png",
        repeat: 1,
        name: "",
        account: "",
        codeUrl: "",
        code: "",
        path: ""
    },
    onReady: function() {
        wx.setNavigationBarColor({
            frontColor: "#000000"
        });
    },
    onLoad: function(t) {
        that = this;
    },
    onShow: function() {},
    toFollow: function(t) {
        t = t.currentTarget.dataset.index;
        this.setData({
            sel_index: t
        });
    },
    bindName: function(t) {
        this.setData({
            name: t.detail.value
        });
    },
    bindAccount: function(t) {
        this.setData({
            account: t.detail.value
        });
    },
    bindPath: function(t) {
        this.setData({
            path: t.detail.value
        });
    },
    addImage: function() {
        wx.chooseImage({
            count: 1,
            success: function(t) {
                _tools2.default.upload(t.tempFiles[0].path, function(t) {
                    that.setData({
                        codeUrl: t.info.url,
                        code: t.info.path
                    });
                });
            }
        });
    },
    codeImgClose: function() {
        that.setData({
            codeUrl: "",
            code: ""
        });
    },
    saveInfo: function() {
        var t = {
            action: "addSponsor",
            contr: "luck",
            token: wx.getStorageSync("token"),
            name: this.data.name
        }, e = this.data.followData[this.data.sel_index];
        if (t.name) {
            if (1 == e.is_image) {
                if (t.code = this.data.code, !t.code) return void wx.showToast({
                    icon: "none",
                    title: "请上传" + e.startname + "二维码"
                });
            } else if (1 != this.data.sel_index && (t.account = this.data.account, !t.account)) return void wx.showToast({
                icon: "none",
                title: "请填写" + e.startname + (0 == this.data.sel_index ? "APPID" : "账号")
            });
            t.type = e.stype, 0 == this.data.sel_index && (t.path = this.data.path), _tools2.default.request(t, function(t) {
                wx.showToast({
                    title: "添加成功"
                }), setTimeout(function() {
                    wx.navigateBack();
                }, 1e3);
            });
        } else wx.showToast({
            icon: "none",
            title: "请填写" + e.name
        });
    }
});