var _tools = require("../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(e) {
    return e && e.__esModule ? e : {
        default: e
    };
}

var that, app = getApp();

Page({
    data: {
        motto: "Hello World",
        userInfo: {},
        showState: !0,
        canIUseGetUserProfile: !1,
        nav: {
            title: "我的",
            showHome: !1,
            isHomePage: !0
        },
        loading: !1,
        auth_status_msg: [ "认证审核中", "已认证", "发起认证" ],
        settle_msgs: [ "商家认证", "入驻审核中", "商家主页", "重新审核" ]
    },
    onReady: function() {
        wx.setNavigationBarColor({
            frontColor: "#000000"
        });
    },
    onLoad: function(e) {
        that = this, e.scene && (e = decodeURIComponent(e.scene), this.write_off(e)), wx.getUserProfile && this.setData({
            canIUseGetUserProfile: !0
        });
    },
    gotoRelease: function() {
        wx.navigateTo({
            url: "/interaction/pages/my/my"
        });
    },
    getUserProfile: function(e) {
        this.data.canIUseGetUserProfile && wx.getUserProfile({
            desc: "用于完善会员资料",
            success: function(e) {
                console.log(e.userInfo);
                e = {
                    action: "authorization",
                    contr: "index",
                    token: wx.getStorageSync("token"),
                    avatarUrl: e.userInfo.avatarUrl,
                    nickName: e.userInfo.nickName,
                    city: e.userInfo.city,
                    province: e.userInfo.province,
                    country: e.userInfo.country,
                    gender: e.userInfo.gender
                };
                _tools2.default.request(e, function(e) {
                    wx.showToast({
                        icon: "none",
                        title: "同步成功"
                    }), that.onShow();
                });
            }
        });
    },
    subscription: function() {
        console.log(that.data.dy), wx.requestSubscribeMessage({
            tmplIds: that.data.dy,
            success: function(e) {
                console.log(e), that.add_num();
            },
            fail: function(e) {
                console.log(e);
            },
            complete: function(e) {
                console.log(e);
            }
        });
    },
    add_num: function() {
        var e = {
            action: "subscribe",
            contr: "user",
            token: wx.getStorageSync("token")
        };
        _tools2.default.request(e, function(e) {});
    },
    gotoSgin: function() {
        wx.navigateTo({
            url: "/packageA/pages/signin/signin"
        });
    },
    gotoJiziLog: function() {
        wx.navigateTo({
            url: "/packageA/pages/myjizi/myjizi"
        });
    },
    onShow: function() {
        var e = {
            action: "index",
            contr: "user",
            token: wx.getStorageSync("token")
        };
        _tools2.default.request(e, function(e) {
            that.setData(e.info);
        });
    },
    gotodrawLottery: function(e) {
        wx.navigateTo({
            url: "/bh_vote/pages/entrance/entrance"
        });
    },
    gotoCash: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/cash/cash"
        });
    },
    gotoVoucher: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/voucher/voucher"
        });
    },
    gotoHome: function(e) {
        wx.reLaunch({
            url: "/bh_vote/pages/index/index"
        });
    },
    getUserInfo: function(e) {
        "getUserInfo:ok" == e.detail.errMsg && (e = {
            action: "register",
            contr: "index",
            token: wx.getStorageSync("token"),
            encryptedData: e.detail.encryptedData,
            iv: e.detail.iv
        }, _tools2.default.request(e, function(e) {
            wx.showToast({
                icon: "none",
                title: "同步成功"
            }), that.onShow();
        }));
    },
    gotoattestation: function(e) {
        1 != this.data.settle ? 2 != this.data.settle ? wx.navigateTo({
            url: "/bh_vote/pages/attestation/start/start"
        }) : wx.navigateTo({
            url: "/bh_vote/pages/shopDetail/shopDetail"
        }) : wx.showToast({
            icon: "none",
            title: "请稍等,正在加紧审核中.."
        });
    },
    gotoAddress: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/address/address"
        });
    },
    gotoShop: function() {
        wx.navigateTo({
            url: "/packageA/pages/index/index"
        });
    },
    gotoOrder: function() {
        wx.navigateTo({
            url: "/packageA/pages/order/order"
        });
    },
    gotoHeigLevel: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/highLevel/highLevel"
        });
    },
    gotoQuestion: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/question/question"
        });
    },
    gotoIndexIntro: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/goIndexIntro/goIndexIntro"
        });
    },
    onShareAppMessage: function() {
        return {
            title: this.data.share.text,
            imageUrl: this.data.share.images,
            path: "bh_vote/pages/index/index?parent_id=" + this.data.share.member_id
        };
    },
    goParticipate: function(e) {
        wx.navigateTo({
            url: "/bh_vote/pages/participate/participate"
        });
    },
    goInPrize: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/inPrize/inPrize"
        });
    },
    goLaunch: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/launch/launch"
        });
    },
    onGenQrc: function() {
        var o = this;
        wx.scanCode({
            success: function(e) {
                var t;
                console.log(e), t = "WX_CODE" == e.scanType ? e.path.split("scene=")[1] : e.result, 
                console.log(e), console.log(t), o.write_off(t);
            }
        });
    },
    write_off: function(t) {
        var e = {
            action: "writeoff",
            contr: "voucher",
            token: wx.getStorageSync("token"),
            voucher: t
        };
        _tools2.default.request(e, function(e) {
            wx.navigateTo({
                url: "/bh_vote/pages/heXiao/heXiao?fictitious=" + t + "&type=1"
            });
        });
    }
});