var _tools = require("../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var methods = require("../../toolkit/toolkit.js"), app = getApp();

Page({
    data: {
        capsuleHeight: "",
        capsuleTop: "",
        headHei: "",
        id: "",
        config: "",
        title: "",
        content: "",
        cover_image: "",
        base_map: "",
        code: "",
        headimgurl: "",
        ImgWidth: "",
        Imgheight: "",
        aspectRatio: "",
        code_up: "",
        cover_image_up: "",
        base_map_up: "",
        headimgurl_up: ""
    },
    onLoad: function(t) {
        var e = this, i = wx.getMenuButtonBoundingClientRect(), a = Number(i.height) + Number(i.top);
        e.setData({
            capsuleHeight: i.height,
            capsuleTop: i.top,
            headHei: a
        }), wx.getSystemInfo({
            success: function(t) {
                e.setData({
                    windowWidth: t.windowWidth,
                    windowHeight: t.windowHeight,
                    nowHeight: t.windowHeight - 145 - a + 20
                });
            }
        }), e.setData({
            id: t.id
        }), e.poster(t.id);
    },
    poster: function(t) {
        var o = this, t = {
            action: "poster",
            contr: "interaction",
            token: wx.getStorageSync("token"),
            id: t
        };
        _tools2.default.request(t, function(t) {
            console.log(t);
            var e, i = "";
            console.log(t.info.participate.cover_image), wx.getImageInfo({
                src: t.info.participate.cover_image,
                success: function(t) {
                    console.log(t.width), console.log(t.height), i = t.width / t.height, o.setData({
                        ImgWidth: t.width,
                        Imgheight: t.height,
                        aspectRatio: i.toFixed(2)
                    });
                }
            }), e = 10 < t.info.participate.title.length ? t.info.participate.title.slice(0, 10) + "..." : t.info.participate.title, 
            o.setData({
                code: t.info.code,
                title: t.info.initiator.nickname,
                content: e,
                cover_image: t.info.participate.cover_image,
                base_map: t.info.activity.base_map,
                config: t.info.config
            }), wx.downloadFile({
                url: t.info.code,
                success: function(t) {
                    console.log(t), o.setData({
                        code_up: t.tempFilePath
                    });
                }
            }), wx.downloadFile({
                url: t.info.participate.cover_image,
                success: function(t) {
                    console.log(t), o.setData({
                        cover_image_up: t.tempFilePath
                    });
                }
            }), wx.downloadFile({
                url: t.info.activity.base_map,
                success: function(t) {
                    console.log(t), o.setData({
                        base_map_up: t.tempFilePath
                    });
                }
            }), wx.downloadFile({
                url: t.info.initiator.headimgurl,
                success: function(t) {
                    console.log(t), o.setData({
                        headimgurl_up: t.tempFilePath
                    });
                }
            });
            var a = setInterval(function() {
                "" != o.data.code_up && "" != o.data.cover_image_up && "" != o.data.base_map_up && "" != o.data.headimgurl_up && "" != o.data.ImgWidth && "" != o.data.Imgheight && (clearInterval(a), 
                o.canvasImg());
            }, 500);
        });
    },
    goback: function() {
        wx.navigateBack({
            delta: 1
        });
    },
    onShow: function() {},
    onShareAppMessage: function() {
        return {
            title: this.data.content,
            imageUrl: this.data.cover_image,
            path: "interaction/pages/detail/detail?id=" + this.data.id
        };
    },
    forward: function() {
        var e = this, t = {
            action: "forward",
            contr: "interaction",
            token: wx.getStorageSync("token"),
            id: e.data.id
        };
        _tools2.default.request(t, function(t) {
            e.setData(t.info);
        });
    },
    saveImg: function() {
        var e = this;
        wx.canvasToTempFilePath({
            x: 0,
            y: 0,
            width: this.data.windowWidth,
            height: this.data.nowHeight,
            destWidth: this.data.windowWidth * this.data.pixelRatio,
            destHeight: this.data.nowHeight * this.data.pixelRatio,
            fileType: "png",
            canvasId: "myCanvas",
            success: function(t) {
                console.log(t.tempFilePath), wx.saveImageToPhotosAlbum({
                    filePath: t.tempFilePath,
                    success: function(t) {
                        console.log("123-=-=-=-=-=-="), console.log(t), wx.showToast({
                            title: "保存成功"
                        }), e.forward(), e.goback();
                    }
                });
            }
        });
    },
    canvasImg: function() {
        console.log("xxxx");
        var t = wx.createCanvasContext("myCanvas"), e = t.createLinearGradient(0, 0, this.data.windowWidth, 0);
        e.addColorStop(0, "#000"), e.addColorStop(1, "#fff"), t.setFillStyle(e), t.fillRect(0, 0, this.data.windowWidth, this.data.nowHeight), 
        console.log(this.data.base_map_up), t.drawImage(this.data.base_map_up, 0, 0, this.data.windowWidth, this.data.nowHeight), 
        console.log(this.data.ImgWidth), console.log(this.data.Imgheight);
        var i = this.data.windowWidth - 50;
        a = !(1 < this.data.aspectRatio && this.data.aspectRatio < 4) && this.data.Imgheight > this.data.nowHeight - 200 ? i / this.data.ImgWidth * (this.data.nowHeight - 200) : i / this.data.ImgWidth * this.data.Imgheight;
        var a = i * this.data.Imgheight / this.data.ImgWidth;
        a = (s = this.data.nowHeight < 550 ? 260 : 320) < a ? s : a;
        var o = Math.round(a), e = (this.data.nowHeight - o - 80 - 30) / 2, s = Math.round(e);
        console.log(i + "-" + o + "-" + s), this.bjfillet(t, 25, s, i, o, 16);
        var n = s + 5, a = i - 10, l = o - 50, e = a / this.data.ImgWidth, i = (this.data.Imgheight, 
        Math.round((this.data.Imgheight - l / e) / 2)), e = Math.round(l / e);
        t.drawImage(this.data.cover_image_up, 0, i, this.data.ImgWidth, e, 30, n, a, l);
        a = n + l - 20;
        this.imgfillet(t, this.data.headimgurl_up, 30, a, 40, 40, 20);
        a = (this.data.windowWidth - 80) / 2, o = s + 30 + o;
        console.log(this.data.code_up), this.imgfillet(t, this.data.code_up, a, o, 80, 80, 12);
        a = t.measureText("长按扫码为 TA 点赞");
        console.log(a.width), t.setFontSize(12), t.setFillStyle("#fff"), t.fillText("长按扫码为 TA 点赞", (this.data.windowWidth - a.width) / 2 - 10, o + 100), 
        t.setFontSize(12), t.setFillStyle("#000"), t.fillText(this.data.title, 85, n + l + 20, 170);
        var h = this.data.content.split(""), d = "", c = [];
        t.setFontSize(10), t.setFillStyle("#000");
        for (var g = 0; g < h.length; g++) t.measureText(d).width < 150 ? d += h[g] : (g--, 
        c.push(d), d = "");
        if (c.push(d), 2 < c.length) {
            for (var a = c.slice(0, 2), r = a[1], u = "", o = [], g = 0; g < r.length && t.measureText(u).width < 140; g++) u += r[g];
            o.push(u);
            o = o[0] + "...";
            a.splice(1, 1, o), c = a;
        }
        for (var f = 0; f < c.length; f++) c.length, t.fillText(c[f], 85, n + l + 40, 170);
        t.restore(), t.draw();
    },
    bjfillet: function(t, e, i, a, o, s) {
        t.rect(e, i, a, o), t.setFillStyle("#fff"), t.fill(), t.save(), t.fillStyle = "#fff", 
        t.strokeStyle = "#fff", t.lineJoin = "round", t.lineWidth = s, t.strokeRect(e + s / 2, i + s / 2, a - s, o - s), 
        t.fillRect(e + s, i + s, a - 2 * s, o - 2 * s), t.stroke(), t.closePath();
    },
    imgfillet: function(t, e, i, a, o, s, n) {
        t.beginPath(), t.save(), t.setLineWidth(1), t.setStrokeStyle("#ffffff"), t.moveTo(i + n, a), 
        t.lineTo(i + o - n, a), t.arcTo(i + o, a, i + o, a + n, n), t.lineTo(i + o, a + s - n), 
        t.arcTo(i + o, a + s, i + o - n, a + s, n), t.lineTo(i + n, a + s), t.arcTo(i, a + s, i, a + s - n, n), 
        t.lineTo(i, a + n), t.arcTo(i, a, i + n, a, n), t.stroke(), t.clip(), console.log(11111, e, i, a, o, s), 
        t.drawImage(e, i, a, o, s), t.restore(), t.closePath();
    }
});