var _tools = require("../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var that, WxParse = require("../../wxParse/wxParse.js"), app = getApp();

function exchangeGoods(t) {
    t = {
        token: wx.getStorageSync("token"),
        id: t.data.id
    };
    _tools2.default.request(t, function(t) {
        2 == t.status ? wx.requestPayment({
            timeStamp: t.info.paydata.timeStamp,
            nonceStr: t.info.paydata.nonceStr,
            package: t.info.paydata.package,
            signType: t.info.paydata.signType,
            paySign: t.info.paydata.paySign,
            success: function(t) {
                wx.showToast({
                    title: "兑换成功"
                }), setTimeout(function() {
                    wx.navigateTo({
                        url: "/packageA/pages/order/order"
                    });
                }, 1500);
            },
            fail: function(t) {
                console.log(t);
            }
        }) : 3 == t.status ? wx.showModal({
            title: "提示",
            mask: !0,
            content: t.info,
            showCancel: !1
        }) : (wx.showToast({
            title: "兑换成功"
        }), setTimeout(function() {
            wx.navigateTo({
                url: "/packageA/pages/order/order"
            });
        }, 800));
    }, function() {}, function() {}, "", !0, "entry/wxapp/ExchangeGoods");
}

Page({
    data: {
        id: 0,
        indicatorDots: !1,
        vertical: !1,
        autoplay: !0,
        interval: 5e3,
        duration: 1e3,
        isScrollY: !0,
        current: 0,
        isIphoneX: !1,
        isIphone: !1,
        extra_info_tab: 1
    },
    onLoad: function(t) {
        (that = this).data.id = t.id;
    },
    onReady: function() {
        wx.getSystemInfo({
            success: function(t) {
                "ios" == t.platform && (that.setData({
                    isIphone: !0
                }), -1 < t.model.indexOf("iPhone X") && that.setData({
                    isIphoneX: !0
                }));
            }
        }), wx.createSelectorQuery().select("#global-nav").boundingClientRect(function(t) {
            console.log(t.height), that.setData({
                m_height: t.height
            });
        }).exec();
    },
    setAddress: function(t) {
        wx.navigateTo({
            url: "/bh_vote/pages/address/address"
        });
    },
    onUnload: function() {},
    onHide: function() {},
    swiperchange: function(t) {
        this.setData({
            current: t.detail.current
        });
    },
    switchTab: function(t) {
        this.setData({
            extra_info_tab: t.target.dataset.extra
        });
    },
    onShow: function() {
        var t = {
            action: "details",
            contr: "sign",
            token: wx.getStorageSync("token"),
            id: that.data.id
        };
        _tools2.default.request(t, function(t) {
            that.setData(t.info);
            t = t.info.goods.introduce;
            WxParse.wxParse("article", "html", t, that, 5);
        });
    },
    exchange: function() {
        wx.navigateTo({
            url: "/packageA/pages/buy/buy?id=" + this.data.id
        });
    },
    onShareAppMessage: function() {
        return {
            title: this.data.goods.share_title,
            imageUrl: this.data.goods.cover_image,
            path: "bh_vote/pages/index/index?parent_id=" + this.data.share.member_id
        };
    }
});