<?php

class merchant extends bhCommon {


    public function index()
    {
        $id = intval($this->get('id'));
        if ($id < 1) {
            $id = $this->member['shop_id'];
        }
        if ($id < 1) {
            $this->json('商家不存在', 0);
        }

        $merchant = p_get('merchant', array('id' => $id));
        if (empty($merchant) || $merchant['status'] != 2) {
            $this->json('商家不存在或者还未通过审核', 0);
        }

        $launch = p_getcolumn('luck', array('shop_id' => $id, 'is_delete' => 1), 'count(*)') ? : 0;

        $participants = p_getcolumn('luck_participate', array('shop_id' => $id), 'count(*)') ? : 0;

        $merchant['shop_head'] = getImage($merchant['shop_head']);

        $config = array(
            'qq_map_key' => getConfig('qq_map_key')
        );

        if ($luck = p_getall('luck', array('shop_id' => $id, 'is_delete' => 1, 'status' => 1, 'complete' => 2))) {
            foreach ($luck as & $value) {
                if ($value['lottery_type'] == 1) {
                    $value['lottery'] = date('m月d日 H:i', $value['lottery_value']);
                } elseif ($value['lottery_type'] == 2) {
                    $value['lottery'] = '满' . $value['lottery_value'] . '人';
                } else if ($value['lottery_type'] == 3){
                    $value['lottery'] = '发起者手动开奖';
                } else {
                    $value['lottery'] = '组队满' . $value['team_number'] . '人';
                }

                $goods = p_get('luck_goods', array('luck_id' => $value['id']));
                $goods['image'] = getImage($goods['image'] ? $goods['image'] : getConfig('prize_default_picture'));
                $value['goods'] = $goods;
            }
        }
        $merchant['add_group_url'] && $merchant['add_group_url'] = urlencode($merchant['add_group_url']);

        $share = array(
            'member_id' => $this->member['id'],
            'text' => str_replace('{name}', $this->member['nickname'], getConfig('shop_share_text')),
            'images' => getImage(getConfig('shop_share_image'))
        );
        $xcx_path = 'bh_vote/pages/shopDetail/shopDetail';
        $code = $this->vote->createWxCode($this, $id, $xcx_path, 'shop' . $id . '.png');

        $images = array(
            'pyq' => $this->image_url . 'pyq.png',
            'wxi' => $this->image_url . 'wxi.png',
            'shop_bg' => $this->image_url . 'shop_bg.png',
        );



        $data = array(
            'merchant' => $merchant,
            'launch' => $launch,
            'config' => $config,
            'participants' => $participants + $merchant['participants'],
            'luck' => $luck,
            'share' => $share,
            'images' => $images,
            'code' => $code,
        );
        $this->json($data);
    }

}