<?php

class noLogin extends bhCommon {

    public function __construct()
    {
        parent::__construct();
    }


    /**
     *
     */
    public function login()
    {
        $code = $this->get('code');
        if (empty($code)) {
            $this->json('参数错误', 0);
        }

        $option = array(
            'appid' => $this->w['uniaccount']['key'],
            'secret' => $this->w['uniaccount']['secret'],
        );
        if (isQq()) {
            $wxObj = new Qqadoc($option);
        } else {
            $wxObj = new Wxadoc($option);
        }
        if (false === $res = $wxObj->jscode2session($code)) {

            $this->json($wxObj->getError(), 0);
        }
        $member = p_get('memberinfo', array('openid' => $res['openid']));

        if (empty($member)) {
            $data = array(
                'openid' => $res['openid'],
                'c_time' => time(),
                'u_time' => time(),
            );
            if (isset($res['unionId']) && $this->vote->isIntegralUser()) {
                $data['unionid'] = $res['unionId'];
            }
            if ($res['unionid'] && false) {
                $data['unionid'] = $res['unionid'];
                $member = p_get('memberinfo', array('unionid' => $res['unionid']));
                if ($member) {
                    p_update('memberinfo', array('openid' => $res['openid']), array('id' => $member['id']));
                }
            }
        } else if (isset($res['unionid']) && $this->vote->isIntegralUser() && !$member['unionid']) {
            p_update('memberinfo', array('unionid' => $res['unionid']), array('id' => $member['id']));
        }

        if (empty($member)) {
            if ($this->get('parent_id')) {
                $data['parent_id'] = $this->get('parent_id');
            }

            p_insert('memberinfo', $data);
            $member['id'] = pdo_insertid();
        }

        $token = md5($member['id'] . time() . PREFIX);

        $insert = array(
            'token' => $token,
            'session_key' => $res['session_key'],
            'member_id' => $member['id'],
            'created' => time()
        );

        p_insert('token', $insert);

        $this->json($token, 1, false);
    }


    /**
     *
     */
    public function upload()
    {
        if (!isset($_FILES['file'])) {
            json('请上传图片', 0);
        }
        load()->func('file');
        $reslut = file_upload($_FILES['file']);
        if (isset($reslut['errno'])) {
            json($reslut['message'], 0);
        }
        $pic = $reslut['path'];

        $option = array(
            'appid' => $this->w['uniaccount']['key'],
            'secret' => $this->w['uniaccount']['secret'],
        );

        if (isQq()) {
            $wxObj = new Qqadoc($option);
        } else {
            $wxObj = new Wxadoc($option);
        }

        if (getConfig('img_check') == 2 || $this->get('check') == 1) {
            if ($this->get('check') == 1) {
                var_dump(IA_ROOT . '/attachment/' . $pic);
            }

            $res = $wxObj->imgSecCheck(IA_ROOT . '/attachment/' . $pic);

            if ($this->get('check') == 1) {
                var_dump($res);
            }

            if (isset($res['errcode']) && $res['errcode'] == 87014) {
                $this->json('图片含有违法违规内容,请重新上传', 0);
            }
            //file_put_contents(IA_ROOT . '/attachment/vote_image.txt', "\r\n图片:" . tomedia($pic)  . var_export($res, true), FILE_APPEND);
        }


        if (is_oss()) {
            $remotestatus = file_remote_upload($reslut['path']);
            if (is_error($remotestatus)) {
                json('远程附件上传失败', 0);
            }
        }

        json(array('url' => tomedia($pic), 'path' => $pic));
    }

    /**
     *
     */
    public function captcha()
    {
        defined('IN_IA') or exit('Access Denied');
        error_reporting(0);
        load()->classs('captcha');
        session_start();

        $captcha = new Captcha();
        $captcha->build(145, 40);
        $hash = md5(strtolower($captcha->phrase) . $this->w['config']['setting']['authkey']);
        isetcookie('__code', $hash);
        $_SESSION['__code'] = $hash;

        $captcha->output();
    }


    public function loading()
    {
        $full_screen_ad = getConfig('full_screen_ad');
        $ad_time = getConfig('ad_time', 0);

        $data = array(
            'full_screen_ad' => $full_screen_ad,
            'ad_time' => $ad_time,
        );
        $this->json($data);
    }


    public function home()
    {
        $daily = $this->vote->getRecommend(1, 6, 0);
        $self = $this->vote->getRecommend(2, 10, 0);

        $config = array(
            'home_public_number' => getConfig('home_public_number'),
            'is_front_page' => getConfig('is_front_page', 1),
            'integral_name' => getConfig('integral_name', '积分'),
            'home_title' => getConfig('home_title', '公共福利'),
            'daily_benefits' => getConfig('daily_benefits', '每日福利'),
            'self_service' => getConfig('self_service', '自助福利'),
            'home_public_number_url' => getConfig('home_public_number_url'),
            'is_new_home' => getConfig('is_new_home', 2),
            'open_withdrawal' => getConfig('open_withdrawal', 1),
            'screen_second' => intval(getConfig('screen_second', 0)) * 1000,
        );
        $config['home_public_number_url'] && $config['home_public_number_url'] = urlencode($config['home_public_number_url']);
        $images = array(
            'xin' => $this->images('integral_img', 'pop_gold.png')
        );
        $is_integral_plugin = $this->vote->is_show_integral();

        $sgin = array();
        if ($is_integral_plugin) {
            $sgin['is_sign'] = 0;
        }

        $data = array(
            'config' => $config,
            'daily' => $daily,
            'self' => $self,
            'ad' => $this->vote->getAdvertisement(1),
            'member' => $this->member,
            'is_integral_plugin' => $is_integral_plugin,
            'images' => $images,
            'sgin' => $sgin,
            'home_top_ad' => $this->vote->getAdvertisement(6, 4),
            'isIntegralUser' => $this->vote->isIntegralUser(),
            'home_screen' => getConfig('home_screen', 1),
            'screen_ad' => getConfig('screen_ad')
        );
        $data['yy'] = yanyi();
        if ($data['yy']) {
            $data['images_bg'] = $this->image_url . '20190701102654167.png';
            $data['currency_name'] = getConfig('currency_name', '燃力币');
            $data['yy_ad'] = $this->vote->getAdvertisement(8, 4);
        }

        $this->json($data);
    }

}