<?php
include_once IA_ROOT . '/addons/bh_vote/lib/ThirdParty.php';

class open extends bhCommon {

    public $thirdParty;

    public function __construct()
    {
        parent::__construct();
        $this->thirdParty = new ThirdParty($this);
    }


    public function bindcomponent()
    {
        $parent_id = $this->get('parent_id', 0);
        $url = $this->thirdParty->bindcomponent($parent_id);

        $parent = array();
        if ($parent_id > 0) {
            $parent = p_get('memberinfo', array('id' => $parent_id));
        }


        $data = array(
            'url' => $url,
            'parent' => $parent,
            'user' => $this->member
        );
        $this->json($data);
    }


    /**
     *
     */
    public function apiAuth($p_id)
    {
        $auth_code = $this->get('auth_code');
        return $this->thirdParty->api_query_auth($auth_code, false, $p_id);
    }



    public function event($dta)
    {

    }
}