<?php

class user extends bhCommon {

    public function __construct()
    {
        parent::__construct();
    }



    /**
     *
     */
    public function index()
    {
        //$luck_participate = p_getcolumn('luck_participate', array('member_id' => $this->member['id']), 'COUNT(*)') ? : 0;
        $sql = "SELECT count(*) FROM " . prefix('luck_participate') . " A INNER JOIN " . prefix('luck') . " B ON A.luck_id=B.id WHERE A.member_id={$this->member['id']} AND B.is_delete=1";

        $luck_participate = p_fetchcolumn($sql) ? : 0;
        $luck_launch = p_getcolumn('luck', array('member_id' => $this->member['id'], 'complete' => 2, 'is_delete' => 1), 'COUNT(*)') ? : 0;
        //$luck_prize = p_getcolumn('luck_goods_info', array('in_member_id' => $this->member['id']), 'COUNT(*)') ? : 0;
        $sql = "SELECT count(*) FROM " . prefix('luck_goods_info') . " A INNER JOIN "  . prefix('luck') . " B ON A.luck_id=B.id WHERE in_member_id={$this->member['id']} AND B.is_delete=1";
        $luck_prize = p_fetchcolumn($sql) ? : 0;
        $auth_status = $this->member['auth'];

        $vote_launch = p_getcolumn('vote_activity', array('member_id' => $this->member['id'], 'complete' => 2, 'is_delete' => 1), 'COUNT(*)') ? : 0;
        $vote_participate = p_getcolumn('vote_join', array('uid' => $this->member['id']), 'COUNT(*)') ? : 0;

        $vote_prize = p_getcolumn('vote_goods_info', array('in_member_id' => $this->member['id']), 'COUNT(*)') ? : 0;

        if ($auth_status == 1) {
            $auth_status = p_get('authentication', array('member_id' => $this->member['id'], 'status' => 1)) ? 1 : 3;
        }

        $images = array(
            'add3x' => $this->image_url . 'add3x.png',
            'profile3x' => $this->image_url . 'profile3x.png',
            'vip3x' => $this->image_url . 'vip3x.png',
            'question3x' => $this->image_url . 'question3x.png',
            'my_icon' => $this->image_url . 'my_icon.png'
        );
        $dy = array();
        $dy_send_message_kj_id = getConfig('dy_send_message_kj_id');
        $dy_send_message_tp_id = getConfig('dy_send_message_tp_id');
        $new_activities = getConfig('new_activities');

        if ($dy_send_message_kj_id) {
            $dy[] = $dy_send_message_kj_id;
        }
        if ($dy_send_message_tp_id) {
            $dy[] = $dy_send_message_tp_id;
        }
        if ($new_activities) {
            $dy[] = $new_activities;
        }
        $is_integral_plugin = $this->vote->is_show_integral();
        $config = array(
            'integral_name' => getConfig('integral_name', '积分'),
            'is_front_page' => getConfig('is_front_page', 1),
            'my_title_bg_color' => getConfig('my_title_bg_color', '#FFFFFF'),
            'my_title_color' => getConfig('my_title_color', '#000000'),
            'initiate_authentication' => getConfig('initiate_authentication', '1'),
            'open_withdrawal' => getConfig('open_withdrawal', 2),
            'open_write' => getConfig('open_write', 1),
            'xcx_title' => getConfig('xcx_title'),
            'is_personal' => getConfig('is_personal', 1),
            'open_hd' => getConfig('open_hd', 1),
            'is_calligraphy' => $this->vote->is_calligraphy(),
            'xcx_describe' => getConfig('xcx_describe', '一款上千万人使用的小程序'),
        );

        $settle = 0;
        if ($this->member['shop_id'] > 0) {
            $merchant = p_get('merchant', array('id' => $this->member['shop_id']));
            $settle = $merchant['status'];
        }

        $participate = 0;
        $launch = 0;
        $prize_num = 0;
        $use_substance = getConfig('use_substance', 1);

        if ($use_substance != 2) {
            $participate += $luck_participate;
            $launch += $luck_launch;
            $prize_num += $luck_prize;
        }
        if ($use_substance != 3) {
            $participate += $vote_participate;
            $launch += $vote_launch;
            $prize_num += $vote_prize;
        }

        $data = array(
            'is_auth' => $this->is_auth,
            'member' => $this->member,
            'participate' => $participate,
            'launch' => $launch,
            'prize_num' => $prize_num,
            'auth_status' => $auth_status,
            'images' => $images,
            'is_integral_plugin' => $is_integral_plugin,
            'dy' => $dy,
            'config' => $config,
            'settle' => $settle,
            'open_senior' => getConfig('open_senior', 1),
            'yy' => yanyi(),
            'is_union' => $this->vote->is_union(),
            'isIntegralUser' => $this->vote->isIntegralUser(),
            'ad' => $this->vote->getAdvertisement(9)
        );

        $this->json($data);
    }


    /**
     *
     */
    public function setAddress()
    {
        $data = array(
            'name' =>  $this->get('name'),
            'phone' =>  $this->get('phone'),
            'address' =>  $this->get('address'),
        );

        if ($address = p_get('address', array('member_id' => $this->member['id']))) {
            p_update('address', $data, array('id' => $address['id']));
        } else {
            $data['member_id'] = $this->member['id'];
            $data['created'] = time();
            p_insert('address', $data);
        }
        $this->json('设置成功');
    }


    /**
     *
     */
    public function getAddress()
    {
        $address = p_get('address', array('member_id' => $this->member['id']));
        $this->json(array('address' => $address));
    }


    /**
     *
     */
    public function getPartner()
    {
        $address = p_get('partner', array('member_id' => $this->member['id']));
        $address['region'] = json_decode($address['address']);
        $this->json(array('partner' => $address));
    }


    /**
     *
     */
    public function setPartner()
    {
        $region = $this->get('region');
        $region = json_decode(html_entity_decode($region), true);
        if (count($region) < 3) {
            $this->json('请选择省市区', 0);
        }

        $data = array(
            'name' =>  $this->get('name'),
            'phone' =>  $this->get('phone'),
            'address' =>  json_encode($region),
            'updated' => time()
        );

        if ($partner = p_get('partner', array('member_id' => $this->member['id']))) {
            p_update('partner', $data, array('id' => $partner['id']));
        } else {
            $data['member_id'] = $this->member['id'];
            $data['created'] = time();
            p_insert('partner', $data);
        }
        $this->json('设置成功');
    }


    /**
     *
     */
    public function authStart()
    {
        if ($auth_start = getConfig('auth_start')) {
            $auth_start = json_decode($auth_start, true);
        } else {
            $auth_start = array(
                '认证作用：抽奖发起人显示为认证品牌名，携带加V标识。如投放自助福利，认证用户将有更高几率被置顶展示,获得更多曝光转化',
                '认证过程：1、提供经营信息或凭证，2、提交审核判定'
            );
        }

        $data = array(
            'auth_start' => $auth_start,
            'images' => array(
                'auth' => $this->image_url . 'icon-auth.png'
            )
        );

        $this->json($data);
    }


    /**
     *
     */
    public function authStart2()
    {
        $auth_industry = getConfig('auth_industry');
        $auth_industry = $auth_industry ? json_decode($auth_industry, true) : array('小程序', '视频');
        $data = array(
            'auth_industry' => $auth_industry,
            'qq_map_key' => getConfig('qq_map_key')
        );

        $this->json($data);
    }


    /**
     *
     */
    public function authStart3()
    {
        $name = $this->get('name');
        $category = $this->get('category');
        $introduce = $this->get('introduce');
        $image = html_entity_decode($this->get('image'));
        $full_name = $this->get('full_name');
        $wx = $this->get('wx');
        $phone = $this->get('phone');
        if (!isMobile($phone)) {
            $this->json('手机号码格式错误', 0);
        }
        if (!isWx($wx)) {
            $this->json('微信号格式错误', 0);
        }

        $data = array(
            'member_id' => $this->member['id'],
            'name' => $name,
            'image' => $image,
            'category' => $category,
            'introduce' => $introduce,
            'full_name' => $full_name,
            'phone' => $phone,
            'wx' => $wx,
            'created' => time()
        );

        p_insert('authentication', $data);
        $this->json();
    }


    /**
     *
     */
    public function settle()
    {
        if ($this->member['shop_id'] > 0) {
            $this->json('您已绑定了商家', 0);
        }

        $shop_name = $this->get('name');
        $industry = $this->get('industry');
        $introduction = $this->get('introduction');
        $address = $this->get('address');
        $longitude = $this->get('longitude');
        $latitude = $this->get('latitude');
        $brand = $this->get('brand');
        $name = $this->get('full_name');
        $we_chat = $this->get('wx');
        $phone = $this->get('phone');
        $business_imgs = $this->get('business_imgs');
        $shop_head = $this->get('shop_head');


        if (empty($shop_name)) {
            $this->json('请填写商家名称', 0);
        }

        if (empty($shop_head)) {
            $this->json('请上传商家头像', 0);
        }

        if (empty($industry)) {
            $this->json('请选择所属行业', 0);
        }

        if (empty($introduction)) {
            $this->json('请填写商家简介', 0);
        }

        if (empty($address)) {
            $this->json('请填写商家地址', 0);
        }

        if (empty($brand)) {
            $this->json('请填写商家介绍', 0);
        }

        if (empty($name)) {
            $this->json('请填写联系人姓名', 0);
        }

        if (!isWx($we_chat)) {
            $this->json('微信号格式错误', 0);
        }

        if (!isMobile($phone)) {
            $this->json('手机号码格式错误', 0);
        }

        if (empty($business_imgs)) {
            $this->json('请上传凭证', 0);
        }
        $business_imgs = json_decode(html_entity_decode($business_imgs), true);
        $imgs = [];
        foreach ($business_imgs as $value) {
            $imgs[] = $value['path'];
        }

        $business_imgs = json_encode($imgs);

        $data = array(
            'member_id' => $this->member['id'],
            'shop_name' => $shop_name,
            'longitude' => $longitude,
            'latitude' => $latitude,
            'address' => $address,
            'phone' => $phone,
            'name' => $name,
            'we_chat' => $we_chat,
            'shop_head' => $shop_head,
            'status' => 1,
            'introduction' => $introduction,
            'brand' => $brand,
            'industry' => $industry,
            'business_imgs' => $business_imgs,
            'created' => time()
        );
        if (p_insert('merchant', $data)) {
            p_update('memberinfo', array('shop_id' => p_insert_id()), array('id' => $this->member['id']));
        }

        $this->json();
    }


    /**
     *
     */
    public function upHome()
    {
        $up_home_mrfl_text = getConfig('up_home_mrfl_text', '针对企业合作伙伴开放,进行品牌宣传与产品推荐,按天展示在首页[每日福利]模块. 如有意向,请点击下方联系我们');

        $up_home_mrfl_details = getConfig('up_home_mrfl_details');
        $up_home_mrfl_details = $up_home_mrfl_details ? json_decode($up_home_mrfl_details, true) : array();


        $up_home_zzfl_text = getConfig('up_home_zzfl_text', '个人和企业均可投放.完成流程后提交,可推广抽奖展示[自助福利]模块,获得曝光和关注,以固定展示天数开奖');

        $up_home_zzfl_details = getConfig('up_home_zzfl_details');
        $up_home_zzfl_details = $up_home_zzfl_details ? json_decode($up_home_zzfl_details, true) : array();

        $data = array(
            'up_home_mrfl_text' => $up_home_mrfl_text,
            'up_home_mrfl_details' => $up_home_mrfl_details,
            'up_home_zzfl_text' => $up_home_zzfl_text,
            'up_home_zzfl_details' => $up_home_zzfl_details,
        );

        $this->json($data);
    }


    public function fromId()
    {
        exit;
    }


    /**
     *
     */
    public function captcha()
    {
        defined('IN_IA') or exit('Access Denied');
        error_reporting(0);
        load()->classs('captcha');


        $captcha = new Captcha();
        $captcha->build(145, 40);
        $hash = md5(strtolower($captcha->phrase) . $this->w['config']['setting']['authkey']);

        p_delete('code', array('member_id' => $this->member['id']));
        $insert = array(
            'code' => $hash,
            'member_id' => $this->member['id'],
            'created' => time()
        );
        p_insert('code', $insert);

        $captcha->output();
    }


    /**
     * 订阅消息
     */
    public function subscribe()
    {
        $new_activities = getConfig('new_activities');
        if (!empty($new_activities)) {
            $subscribe = p_get('subscribe', array('member_id' => $this->member['id']));
            if (empty($subscribe)) {
                $i = array(
                    'member_id' => $this->member['id'],
                    'new_activities' => 1,
                    'created' => time()
                );
                p_insert('subscribe', $i);
            } else {
                p_update('subscribe', array('new_activities' => $subscribe['new_activities'] + 1), array('id' => $subscribe['id']));
            }
        }
    }


    /**
     * 绑定手机号
     */
    public function bindPhone()
    {
        $iv = $this->get('iv');
        $encryptedData = $this->get('encryptedData');

        if ($this->member['phone']) {
            //json('ok');
        }

        $wxbd = new WXBizDataCrypt($this->w['uniaccount']['key'], $this->session_key);

        $res = $wxbd->decryptData($encryptedData, $iv, $data);
        if ($res != ErrorCode::$OK) {
            p_delete('token', array('member_id' => $this->member['id']));
            $this->json('unlogin', -1);
        }

        $data = json_decode($data, true);
        p_update('memberinfo', array('phone' => $data['purePhoneNumber']), array('id' => $this->member['id']));
        $this->json();
    }


    /**
     * 提现
     */
    public function cash()
    {
        $cash_explain = getConfig('cash_explain');
        $cash_explain = $cash_explain ? json_decode($cash_explain, true) : '';

        $this->member['payment_code_url'] = getImage($this->member['payment_code']);

        $audit_model = getConfig('open_withdrawal', 2) == 2;
        if ($audit_model) {
            $share_text = '真有趣';
        } else {
            $share_text = '邀请好友，一起领红包';
        }
        $pwd_guide_url = getConfig('pwd_guide_url');
        $pwd_guide_url = $pwd_guide_url ? urlencode($pwd_guide_url) : '';

        $data = array(
            'member' => $this->member,
            'cash_explain' => $cash_explain,
            'images' => array(
                'bg' => $this->images('cash_bg', '20190701102654167.png')
            ),
            'cash_type' => getConfig('cash_type', 2),
            'share_text' => $share_text,
            'tx' => '提现',
            'audit_model' => $audit_model,
            'pwd_guide_url' => $pwd_guide_url,
            'open_cash_password' => getConfig('open_cash_password', 1)
        );

        $this->json($data);
    }


    /**
     * 提现
     */
    public function withdrawals()
    {
        $money = $this->get('money', 0);

        if ($money <= 0) {
            $this->json('提现金额需要大于0元', 2);
        }
        if (getConfig('open_cash_password') == 2 && $this->get('pwd') != getConfig('cash_password')) {
            $this->json('提现口令错误', 2);
        }

        $bag_daily_upper = getConfig('bag_daily_upper', 100);

        $time = strtotime(date('Y-m-d', time()));
        $sql = "SELECT SUM(money) FROM " . prefix('withdrawals') . " WHERE member_id={$this->member['id']} AND created>={$time}";
        if (pdo_fetchcolumn($sql) + $money > $bag_daily_upper) {
            $this->json('每天提现金额上限为' . $bag_daily_upper . '元', 2);
        }


        $withdrawals_day_number = getConfig('withdrawals_day_number', 2);
        $sql = "SELECT COUNT(*) FROM " . prefix('withdrawals') . " WHERE member_id={$this->member['id']} AND created>={$time}";
        if (pdo_fetchcolumn($sql) >= $withdrawals_day_number) {
            $this->json('每天提现次数为' . $withdrawals_day_number . '次，请明天再来', 2);
        }

        $cash_type = getConfig('cash_type', 2);
        if (isQq() && $cash_type == 1) {
            $qq = $this->get('qq');
            if (empty($qq)) {
                json('请填写当前qq号', 2);
            }
            p_update('member', array('qq' => $qq), array('id' => $this->member['id']));
        }

        $cash_reviewed = getConfig('cash_reviewed');

        $insert = array(
            'member_id' => $this->member['id'],
            'money' => $money,
            'success_time' => time(),
            'type' => $cash_type,
            'status' => 1,
            'created' => time()
        );

        if ($cash_type == 1 && $money < $cash_reviewed) {
            $insert['status'] = 2;
        }

        if ($this->member['cash']) {
            $follow_up_presentation = getConfig('follow_up_presentation', 10);
            if ($money < $follow_up_presentation) {
                json('非首笔提现金额需满' . $follow_up_presentation, 2);
            }
        } else {
            $first_presentation = getConfig('first_presentation', 30);
            if ($money != $first_presentation) {
                json('首次提现金额为' . $first_presentation . '元', 2);
            }
        }

        $m_update = array(
            'cash' => $this->member['cash'] + 1
        );
        if ($cash_type == 2) {
            $insert['payment_code'] = $this->get('payment_code');
            if (empty($insert['payment_code'])) {
                $this->json('请上传收款码', 2);
            }
            $m_update['payment_code'] = $insert['payment_code'];
        }

        pdo_begin();
        try{
            if (!$this->vote->change_money($this->member['id'], $money, 2)) {
                throw new Exception($this->vote->error);
            }
            if (!p_insert('withdrawals', $insert)) {
                throw new Exception('提现失败');
            }
            $pid = pdo_insertid();
            if ($insert['status'] == 2) {

                $this->setPayment();
                if (isQq()) {
                    if (!$this->vote->qqCash($this->member['id'], $money, '', $pid)) {
                        throw new Exception($this->vote->error);
                    }
                } else {
                    if (!$this->vote->cash($money, $this->member['id'])) {
                        throw new Exception($this->vote->error);
                    }
                }

            }
            p_update('memberinfo', $m_update, array('id' => $this->member['id']));
            pdo_commit();
            $this->json('');
        } catch (Exception $e) {
            pdo_rollback();
            $this->json($e->getMessage(), 0);
        }
    }


    public function moneyLog()
    {
        $log = p_getall('money_log', array('member_id' => $this->member['id']), array(), '', 'id desc');

        $types = array(
            '1' => '抽奖中奖',
            '2' => '提现',
            '3' => '兑换红包',
            '4' => '等级分红',
        );

        if ($log) {
            foreach ($log as & $value) {
                $value['type_msg'] = $types[$value['type']];
                $value['created'] = date('Y-m-d H:i:s', $value['created']);
            }
        }

        $data = array(
            'log' => $log,
            'food_name' => getConfig('food_name')
        );
        $this->json($data);
    }
}