<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>

<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge, chrome=1">
    <meta name="viewport"
        content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0,user-scalable=no">
    <meta name="format-detection" content="telephone=no">
    <title>授权成功</title>
    <style>
        @media all {
            html {
                font-size: 16px;
            }
        }

        @media all and (min-width:140px) and (min-height:220px) {
            html {
                font-size: 9px;
            }

            .ui-block-auto {
                width: 50%
            }
        }

        @media all and (min-width: 220px) and (min-height: 140px) {
            html {
                font-size: 9px;
            }

            .ui-block-auto {
                width: 50%
            }
        }

        @media all and (min-width:210px) and (min-height:280px),
        (min-width:280px) and (min-height:210px),
        (min-width:280px) and (min-height:280px) {
            html {
                font-size: 14px;
            }

            .ui-block-auto {
                width: 50%
            }
        }

        @media all and (min-width:300px) and (min-height:460px),
        (min-width:460px) and (min-height:300px) {
            html {
                font-size: 16px;
            }

            .ui-block-auto {
                width: 33.333%
            }
        }

        @media all and (min-width:340px) and (min-height:620px),
        (min-width:620px) and (min-height:340px) {
            html {
                font-size: 20px;
            }

            .ui-block-auto {
                width: 33.333%
            }
        }

        @media all and (min-width:420px) and (min-height:760px) and (max-height:900px),
        (min-width:760px) and (max-width:900px) and (min-height:420px) {
            html {
                font-size: 24px;
            }

            .ui-block-auto {
                width: 33.333%
            }
        }


        @media all and (min-width:1000px) and (min-height:740px),
        (min-width:740px) and (min-height:1000px) {
            html {
                font-size: 20px;
            }

            .ui-block-auto {
                width: 20%
            }
        }

        @media all and (min-width:1200px) and (min-height:600px),
        (min-width:600px) and (min-height:1200px) {
            html {
                font-size: 16px;
            }

            .ui-block-auto {
                width: 10%
            }
        }

        @media all and (device-width:1024px),
        (device-width:768px) {
            html {
                font-size: 20px;
            }

            .ui-block-auto {
                width: 20%
            }
        }

        @media all and (device-width:960px) and (device-height:640px),
        (device-width:640px) and (device-height:960px) {
            html {
                font-size: 32px;
            }

            .ui-block-auto {
                width: 25%
            }
        }

        @media all and (device-width:480px) and (min-device-height:800px) and (max-device-height:900px),
        (min-device-width:800px) and (max-device-width:900px) and (device-height:480px) {
            html {
                font-size: 24px;
            }

            .ui-block-auto {
                width: 33.333%
            }
        }

        @media all and (device-width:360px) and (device-height:640px),
        (device-width:640px) and (device-height:360px) {
            html {
                font-size: 20px;
            }

            .ui-block-auto {
                width: 33.333%
            }
        }

        @media all and (device-width:320px) and (device-height:480px),
        (device-width:480px) and (device-height:320px) {
            html {
                font-size: 16px;
            }

            .ui-block-auto {
                width: 33.333%
            }
        }

        @media all and (device-width:240px) and (device-height:320px),
        (device-width:320px) and (device-height:240px),
        (device-width:320px) and (device-height:320px) {
            html {
                font-size: 14px;
            }

            .ui-block-auto {
                width: 50%
            }
        }
    </style>
    <style>
        *{
            margin:0;
            padding: 0;
        }
        html{
            overflow-x: hidden;
        }
        body{
            background: #fff;
        }
        body,a,span,p,h1,h2,h3,h4,h5,h6{
            font-size: 1rem;
            color: #333;
        }
        img{
            border: 0;
        }
        .success{
            display: -webkit-box;
            display: -ms-flexbox;
            display: -webkit-flex;
            display: flex;
            width: 100vw;
            height: 100vh;
            -webkit-box-pack: start;
            justify-content: flex-start;
            -webkit-box-align: center;
            -ms-flex-align: center;
            align-items: center;
            -webkit-box-flex: 1;
            -ms-flex: 1;
            flex: 1;
            flex-direction: column;
        }
        .success .icon{
            width: 5rem;
            margin-top:3rem;
        }
        .success .text{
            display: -webkit-box;
            display: -ms-flexbox;
            display: -webkit-flex;
            display: flex;
            color: #000;
            font-weight: bold;
            font-size: 0.9rem;
            margin: 1rem 0;
        }
        .success .tips{
            display: -webkit-box;
            display: -ms-flexbox;
            display: -webkit-flex;
            display: flex;
            color: #666;
            font-size: 0.8rem;
            margin-bottom: 1rem;
        }
        .success .pic{
            width: 50%;
        }
    </style>
</head>

<body>
    <div class="success">
        <img src="https://www.easyicon.net/api/resizeApi.php?id=1201384&size=128" class="icon"/>
        <div class="text">授权已成功</div>
        <?php if ($p_id < 1){?>
        <div class="tips">还差最后一步<br>一直点击右上角的返回键,<br>直到返回授权页面</div>
        <?php }; ?>
        <!--<img src="https://s3.ax1x.com/2020/12/17/rG8CF0.png" class="pic"/>-->

    </div>
</body>

</html>