var _tools = require("../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var that, app = getApp();

Page({
    data: {
        motto: "Hello World",
        userInfo: {},
        showState: !1,
        giving_show: !1,
        giving_number: 1,
        loading: !1,
        giving_id: 0,
        platform: 1
    },
    givingShow: function() {
        this.setData({
            giving_show: !0
        });
    },
    givingClose: function() {
        this.setData({
            giving_show: !1
        });
    },
    confirmGiving: function() {
        var t = {
            action: "giving",
            contr: "senior",
            number: that.data.giving_number,
            token: wx.getStorageSync("token")
        };
        _tools2.default.request(t, function(t) {
            that.setData(t.info), that.setData({
                showState: !0
            });
        }, function() {}, function() {}, "", !0);
    },
    confirmGivingHide: function() {
        this.setData({
            showState: !1
        });
    },
    onReady: function() {
        that.setData({
            loading: !0
        }), wx.setNavigationBarColor({
            frontColor: "#000000"
        });
    },
    onLoad: function() {
        that = this, wx.getSystemInfo({
            success: function(t) {
                "devtools" == t.platform || ("ios" == t.platform ? that.setData({
                    platform: 2
                }) : t.platform);
            }
        });
    },
    onShow: function() {
        var t = {
            action: "index",
            contr: "senior",
            token: wx.getStorageSync("token")
        };
        _tools2.default.request(t, function(t) {
            that.setData(t.info);
        });
    },
    onShareAppMessage: function(t) {
        if (null == t.target || "giving" != t.target.dataset.type) return {
            title: this.data.share.text,
            imageUrl: this.data.share.images,
            path: "bh_vote/pages/index/index?parent_id=" + this.data.share.member_id
        };
        t = {
            action: "givingConfirm",
            contr: "senior",
            id: that.data.giving_id,
            token: wx.getStorageSync("token")
        };
        return _tools2.default.request(t, function(t) {
            that.onShow();
        }), console.log("bh_vote/pages/highLevelGet/highLevelGet?id=" + that.data.giving_id), 
        {
            title: "转赠 高级功能X" + that.data.giving_number + ",免费领取",
            path: "bh_vote/pages/highLevelGet/highLevelGet?id=" + that.data.giving_id,
            imageUrl: that.data.images.senior
        };
    },
    reduce: function() {
        this.data.giving_number < 2 || this.setData({
            giving_number: --this.data.giving_number
        });
    },
    plus: function() {
        this.data.giving_number >= this.data.senior.number || this.setData({
            giving_number: ++this.data.giving_number
        });
    },
    gotodrawLottery: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/drawLottery/drawLottery"
        });
    },
    gotoPurchase: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/highLevelText/highLevelText"
        });
    }
});