var _tools = require("../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var that, app = getApp();

Page({
    data: {
        showState: !0,
        sindex: 0,
        platform: 1
    },
    onReady: function() {
        wx.setNavigationBarColor({
            frontColor: "#000000"
        });
        var t = {
            action: "init",
            contr: "senior",
            token: wx.getStorageSync("token")
        };
        _tools2.default.request(t, function(t) {
            that.setData(t.info);
        });
    },
    onLoad: function() {
        that = this, wx.getSystemInfo({
            success: function(t) {
                "devtools" == t.platform || ("ios" == t.platform ? that.setData({
                    platform: 2
                }) : t.platform);
            }
        });
    },
    gotodrawLottery: function() {
        wx.navigateTo({
            url: "/pages/drawLottery/drawLottery"
        });
    },
    spurchase: function(t) {
        this.setData({
            sindex: t.currentTarget.dataset.index
        });
    },
    purchase: function() {
        var t = {
            token: wx.getStorageSync("token"),
            id: this.data.senior[this.data.sindex].id
        };
        _tools2.default.request(t, function(t) {
            wx.requestPayment({
                timeStamp: t.info.paydata.timeStamp,
                nonceStr: t.info.paydata.nonceStr,
                package: t.info.paydata.package,
                signType: t.info.paydata.signType,
                paySign: t.info.paydata.paySign,
                success: function(t) {
                    wx.showToast({
                        title: "购买成功"
                    }), setTimeout(function() {
                        wx.reLaunch({
                            url: "/bh_vote/pages/drawLottery/drawLottery"
                        });
                    }, 1500);
                },
                fail: function(t) {
                    console.log(t);
                }
            });
        }, function() {}, function() {}, "", !0, "entry/wxapp/purchase");
    },
    onShareAppMessage: function() {
        return {
            title: this.data.share.text,
            imageUrl: this.data.share.images,
            path: "bh_vote/pages/index/index?parent_id=" + this.data.share.member_id
        };
    }
});