var _tools = require("../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var that, WxParse = require("../../wxParse/wxParse.js"), app = getApp();

function e(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var i = e(require("./modules/base-canvas-palette.js")), n = e(require("../../../utils/wx-promisify/wx-promisify.js")), d = e(require("./modules/handle-create-img.js")), h = ((0, 
n.default)(wx.getSetting), 0), p = 0;

Page({
    data: {
        motto: "Hello World",
        userInfo: {},
        showState: !0,
        statusBarHeight: 0,
        navBarHeight: 0,
        loading: !1,
        luck_modes: [ "普通", "组队", "助力", "口令" ],
        sel_index: 1,
        creat_img: !0,
        statusPoster: !1
    },
    setPoster: function() {
        that.setData({
            statusPoster: !this.data.statusPoster
        });
    },
    gotoShopAddress: function() {
        requirePlugin("routePlan");
        var t = this.data.config.qq_map_key, e = this.data.xcx_name, a = JSON.stringify({
            name: this.data.merchant.shop_name,
            latitude: this.data.merchant.latitude,
            longitude: this.data.merchant.longitude
        });
        wx.navigateTo({
            url: "plugin://routePlan/index?navigation=1&key=" + t + "&referer=" + e + "&endPoint=" + a
        });
    },
    switch: function(t) {
        t = t.currentTarget.dataset.index;
        that.setData({
            sel_index: t
        });
    },
    gotoLuck: function(t) {
        t = t.currentTarget.dataset.id;
        wx.navigateTo({
            url: "/bh_vote/pages/userGame/userGame?id=" + t
        });
    },
    gotoAddGroup: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/webView/webView?url=" + this.data.merchant.add_group_url
        });
    },
    generatePoster: function() {
        this.data.poster = {
            z_h: 300,
            content: [ {
                type: "image",
                url: this.data.images.shop_bg,
                css: {
                    top: "0rpx",
                    left: "0rpx",
                    width: "330px",
                    height: "348px",
                    mode: "scaleToFill"
                }
            }, {
                type: "image",
                url: this.data.merchant.shop_head,
                css: {
                    top: "30rpx",
                    left: "30rpx",
                    width: "70rpx",
                    height: "70rpx",
                    mode: "scaleToFill"
                }
            }, {
                type: "text",
                text: this.data.merchant.shop_name,
                css: Object.assign({
                    top: "50rpx",
                    left: "120rpx",
                    maxLines: 1,
                    color: "#000000",
                    fontSize: "26rpx"
                })
            }, {
                type: "image",
                url: this.data.code,
                css: {
                    top: "250rpx",
                    left: "76px",
                    width: "178px",
                    height: "178px",
                    mode: "scaleToFill"
                }
            } ]
        }, console.log(this.data.poster), d.default.doCreateImg(this);
        try {
            getApp().sensors.track("XMClick", {
                ck_module: "保存图片",
                page: "投票海报"
            });
        } catch (t) {}
    },
    imgErr: function(t) {
        console.log(22222), d.default.createImgFail(t);
    },
    onImgOK: function(t) {
        console.log(t.detail.path), that.setData({
            creat_img: !1,
            posterImg: t.detail.path
        });
    },
    downImg: function() {
        wx.saveImageToPhotosAlbum({
            filePath: this.data.posterImg,
            success: function(t) {
                wx.showToast({
                    title: "保存成功"
                });
            }
        });
    },
    onReady: function() {
        wx.getSystemInfo({
            success: function(t) {
                console.log(wx.getMenuButtonBoundingClientRect().top), that.setData({
                    statusBarHeight: t.statusBarHeight,
                    navBarHeight: wx.getMenuButtonBoundingClientRect().top
                });
            }
        });
        var t = {
            action: "index",
            contr: "merchant",
            token: wx.getStorageSync("token"),
            id: this.data.id
        };
        _tools2.default.request(t, function(t) {
            that.setData(t.info);
            t = t.info.merchant.brand;
            console.log(t), WxParse.wxParse("article", "html", t, that, 5), that.generatePoster();
        });
    },
    onLoad: function(t) {
        t.id && (this.data.id = t.id), t.scene && (this.data.id = decodeURIComponent(t.scene)), 
        that = this;
    },
    onShareAppMessage: function() {
        return {
            title: this.data.share.text,
            imageUrl: this.data.share.images,
            path: "bh_vote/pages/shopDetail/shopDetail?parent_id=" + this.data.share.member_id + "&id=" + this.data.merchant.id
        };
    }
});