var _tools = require("../../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var that, app = getApp();

Page({
    data: {
        isHidePlaceholder: !1,
        btnHeight: 0,
        id: 0,
        vote: [],
        delShow: !1,
        shareShow: !1
    },
    hideShare: function() {
        this.setData({
            shareShow: !1
        });
    },
    showS: function() {
        this.setData({
            shareShow: !0
        });
    },
    onReady: function() {
        wx.setNavigationBarColor({
            frontColor: "#000000"
        });
    },
    onShow: function() {
        var t = {
            action: "administration",
            contr: "cvote",
            token: wx.getStorageSync("token"),
            id: this.data.id
        };
        _tools2.default.request(t, function(t) {
            that.setData(t.info);
        });
    },
    onLoad: function(t) {
        (that = this).data.id = t.id, wx.createSelectorQuery().select(".NavBtn2").boundingClientRect(function(t) {
            that.setData({
                btnHeight: t.width
            });
        }).exec();
    },
    select: function() {
        var e = this;
        wx.showActionSheet({
            itemList: e.data.selectArr,
            success: function(t) {
                e.setData({
                    selectText: e.data.selectArr[t.tapIndex]
                }), console.log(t);
            },
            fail: function(t) {
                console.log(t.errMsg);
            }
        });
    },
    addImg: function() {
        wx.chooseImage({
            count: 1,
            success: function(t) {
                _tools2.default.upload(t.tempFiles[0].path, function(t) {
                    that.data.vote.cover_image = t.info.url, that.setData({
                        vote: that.data.vote
                    });
                    t = {
                        action: "update",
                        contr: "cvote",
                        token: wx.getStorageSync("token"),
                        id: that.data.id,
                        cover_image: t.info.path
                    };
                    _tools2.default.request(t, function(t) {});
                });
            }
        });
    },
    suspend: function(t) {
        var e = t.currentTarget.dataset.suspend, t = {
            action: "update",
            contr: "cvote",
            token: wx.getStorageSync("token"),
            id: that.data.id,
            suspend: e
        };
        _tools2.default.request(t, function(t) {
            that.data.vote.is_suspend = e, that.setData({
                vote: that.data.vote
            }), wx.showToast({
                icon: "none",
                title: 1 == e ? "开启成功!" : "暂停成功!"
            });
        });
    },
    deleteShow: function() {
        this.setData({
            delShow: !0
        });
    },
    hideDel: function() {
        this.setData({
            delShow: !1
        });
    },
    sureDelete: function() {
        var t = {
            action: "update",
            contr: "cvote",
            token: wx.getStorageSync("token"),
            id: that.data.id,
            is_delete: 2
        };
        _tools2.default.request(t, function(t) {
            wx.showToast({
                title: "删除成功!"
            }), setTimeout(function() {
                wx.reLaunch({
                    url: "/bh_vote/pages/my/my"
                });
            }, 1200);
        });
    },
    onShareAppMessage: function() {
        return wx.showShareMenu({
            withShareTicket: !0
        }), {
            title: this.data.vote.title,
            imageUrl: this.data.vote.cover_image,
            path: "bh_vote/pages/vote/webView/webView?id=" + this.data.id + "&parent_id=" + this.data.vote.member_id
        };
    },
    gotoIndex: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/vote/webView/webView?id=" + this.data.id
        });
    },
    toLuRu: function(t) {
        t = t.currentTarget.dataset.type;
        wx.navigateTo({
            url: "/bh_vote/pages/vote/voteCheckList/voteCheckList?id=" + this.data.id + "&type=" + t
        });
    },
    toWeCode: function(t) {
        wx.navigateTo({
            url: "/bh_vote/pages/vote/poster/poster?id=" + this.data.id
        });
    },
    toAddress: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/vote/addressList/addressList?id=" + this.data.id
        });
    },
    goEdit: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/vote/voteEdit/voteEdit?id=" + this.data.id
        });
    }
});