function t(t) {
    if (Array.isArray(t)) {
        for (var s = 0, e = Array(t.length); s < t.length; s++) e[s] = t[s];
        return e;
    }
    return Array.from(t);
}

function s(t, s) {
    if (!(t instanceof s)) throw new TypeError("Cannot call a class as a function");
}

Object.defineProperty(exports, "__esModule", {
    value: !0
});

var e = function() {
    function i(t, s) {
        for (var e = 0; e < s.length; e++) {
            var i = s[e];
            i.enumerable = i.enumerable || !1, i.configurable = !0, "value" in i && (i.writable = !0), 
            Object.defineProperty(t, i.key, i);
        }
    }
    return function(t, s, e) {
        return s && i(t.prototype, s), e && i(t, e), t;
    };
}(), i = require("./qrcode.js"), r = function() {
    function r(t, e) {
        s(this, r), this.ctx = t, this.data = e;
    }
    return e(r, [ {
        key: "paint",
        value: function(t) {
            this.style = {
                width: this.data.width.toPx(),
                height: this.data.height.toPx()
            }, this._background();
            var s = !0, e = !1, i = void 0;
            try {
                for (var r = this.data.views[Symbol.iterator](); !(s = (h = r.next()).done); s = !0) {
                    var h = h.value;
                    this._drawAbsolute(h);
                }
            } catch (t) {
                e = !0, i = t;
            } finally {
                try {
                    !s && r.return && r.return();
                } finally {
                    if (e) throw i;
                }
            }
            this.ctx.draw(!1, function() {
                t();
            });
        }
    }, {
        key: "_background",
        value: function() {
            this.ctx.save();
            var t = this.style, s = t.width, e = t.height, t = this.data.background;
            this.ctx.translate(s / 2, e / 2), this._doClip(this.data.borderRadius, s, e), t ? t.startsWith("#") || t.startsWith("rgba") || "transparent" === t.toLowerCase() ? (this.ctx.setFillStyle(t), 
            this.ctx.fillRect(-s / 2, -e / 2, s, e)) : this.ctx.drawImage(t, -s / 2, -e / 2, s, e) : (this.ctx.setFillStyle("#fff"), 
            this.ctx.fillRect(-s / 2, -e / 2, s, e)), this.ctx.restore();
        }
    }, {
        key: "_drawAbsolute",
        value: function(s) {
            switch (s.css && s.css.length && (s.css = Object.assign.apply(Object, t(s.css))), 
            s.type) {
              case "image":
                this._drawAbsImage(s);
                break;

              case "text":
                this._fillAbsText(s);
                break;

              case "rect":
                this._drawAbsRect(s);
                break;

              case "qrcode":
                this._drawQRCode(s);
            }
        }
    }, {
        key: "_doClip",
        value: function(t, s, e) {
            t && s && e && (t = Math.min(t.toPx(), s / 2, e / 2), this.ctx.setGlobalAlpha(0), 
            this.ctx.setFillStyle("white"), this.ctx.beginPath(), this.ctx.arc(-s / 2 + t, -e / 2 + t, t, +Math.PI, 1.5 * Math.PI), 
            this.ctx.lineTo(s / 2 - t, -e / 2), this.ctx.arc(s / 2 - t, -e / 2 + t, t, 1.5 * Math.PI, 2 * Math.PI), 
            this.ctx.lineTo(s / 2, e / 2 - t), this.ctx.arc(s / 2 - t, e / 2 - t, t, 0, .5 * Math.PI), 
            this.ctx.lineTo(-s / 2 + t, e / 2), this.ctx.arc(-s / 2 + t, e / 2 - t, t, .5 * Math.PI, +Math.PI), 
            this.ctx.closePath(), this.ctx.fill(), getApp().systemInfo && getApp().systemInfo.version <= "6.6.6" && "ios" === getApp().systemInfo.platform || this.ctx.clip(), 
            this.ctx.setGlobalAlpha(1));
        }
    }, {
        key: "_doBorder",
        value: function(t, s, e) {
            var i, r, h;
            t.css && (i = (r = t.css).borderRadius, h = r.borderWidth, r = r.borderColor, h && (this.ctx.save(), 
            this._preProcess(t, !0), t = void 0, t = i ? Math.min(i.toPx(), s / 2, e / 2) : 0, 
            h = h.toPx(), this.ctx.setLineWidth(h), this.ctx.setStrokeStyle(r || "black"), this.ctx.beginPath(), 
            this.ctx.arc(-s / 2 + t, -e / 2 + t, t + h / 2, +Math.PI, 1.5 * Math.PI), this.ctx.lineTo(s / 2 - t, -e / 2 - h / 2), 
            this.ctx.arc(s / 2 - t, -e / 2 + t, t + h / 2, 1.5 * Math.PI, 2 * Math.PI), this.ctx.lineTo(s / 2 + h / 2, e / 2 - t), 
            this.ctx.arc(s / 2 - t, e / 2 - t, t + h / 2, 0, .5 * Math.PI), this.ctx.lineTo(-s / 2 + t, e / 2 + h / 2), 
            this.ctx.arc(-s / 2 + t, e / 2 - t, t + h / 2, .5 * Math.PI, +Math.PI), this.ctx.closePath(), 
            this.ctx.stroke(), this.ctx.restore()));
        }
    }, {
        key: "_preProcess",
        value: function(t, s) {
            var e = void 0, i = void 0, r = void 0;
            switch (t.type) {
              case "text":
                var h = "bold" === t.css.fontWeight ? "bold" : "normal";
                t.css.fontSize = t.css.fontSize || "20rpx", this.ctx.font = "normal " + h + " " + t.css.fontSize.toPx() + "px sans-serif";
                var c = this.ctx.measureText(t.text).width, e = t.css.width ? t.css.width.toPx() : c, h = Math.ceil(c / e), c = t.css.maxLines < h ? t.css.maxLines : h, h = (t.css.lineHeight || t.css.fontSize).toPx(), i = h * c, r = {
                    lines: c,
                    lineHeight: h
                };
                break;

              case "image":
                h = getApp().systemInfo.pixelRatio ? getApp().systemInfo.pixelRatio : 2;
                e = t.css && t.css.width ? t.css.width.toPx() : Math.round(t.sWidth / h), i = t.css && t.css.height ? t.css.height.toPx() : Math.round(t.sHeight / h);
                break;

              default:
                if (!t.css.width || !t.css.height) return void console.error("You should set width and height");
                e = t.css.width.toPx(), i = t.css.height.toPx();
            }
            var a = t.css && t.css.right ? this.style.width - t.css.right.toPx(!0) : t.css && t.css.left ? t.css.left.toPx(!0) : 0, o = t.css && t.css.bottom ? this.style.height - i - t.css.bottom.toPx(!0) : t.css && t.css.top ? t.css.top.toPx(!0) : 0, n = t.css && t.css.rotate ? this._getAngle(t.css.rotate) : 0;
            switch (t.css && t.css.align ? t.css.align : t.css && t.css.right ? "right" : "left") {
              case "center":
                this.ctx.translate(a, o + i / 2);
                break;

              case "right":
                this.ctx.translate(a - e / 2, o + i / 2);
                break;

              default:
                this.ctx.translate(a + e / 2, o + i / 2);
            }
            return this.ctx.rotate(n), !s && t.css && t.css.borderRadius && this._doClip(t.css.borderRadius, e, i), 
            {
                width: e,
                height: i,
                x: a,
                y: o,
                extra: r
            };
        }
    }, {
        key: "_drawQRCode",
        value: function(t) {
            this.ctx.save();
            var s = this._preProcess(t), e = s.width, s = s.height;
            i.api.draw(t.content, this.ctx, -e / 2, -s / 2, e, s, t.css.background, t.css.color), 
            this.ctx.restore(), this._doBorder(t, e, s);
        }
    }, {
        key: "_drawAbsImage",
        value: function(t) {
            var s, e, i, r, h, c;
            t.url && (this.ctx.save(), s = (c = this._preProcess(t)).width, e = c.height, r = i = void 0, 
            c = h = 0, t.sHeight > t.sWidth ? (r = Math.round(t.sWidth / s * e), i = t.sWidth) : (i = Math.round(t.sHeight / e * s), 
            r = t.sHeight), t.sWidth > i && (h = Math.round((t.sWidth - i) / 2)), t.sHeight > r && (c = Math.round((t.sHeight - r) / 2)), 
            t.css && "scaleToFill" === t.css.mode ? this.ctx.drawImage(t.url, -s / 2, -e / 2, s, e) : this.ctx.drawImage(t.url, h, c, i, r, -s / 2, -e / 2, s, e), 
            this.ctx.restore(), this._doBorder(t, s, e));
        }
    }, {
        key: "_fillAbsText",
        value: function(t) {
            if (t.text) {
                this.ctx.save();
                var s = this._preProcess(t), e = s.width, i = s.height, s = s.extra;
                this.ctx.setFillStyle(t.css.color || "black");
                for (var r = s.lines, h = s.lineHeight, c = Math.round(t.text.length / r), a = 0, o = 0, n = 0; n < r; ++n) {
                    o = c;
                    for (var l = t.text.substr(a, o), x = this.ctx.measureText(l).width; a + o <= t.text.length && (e - x > t.css.fontSize.toPx() || e < x); ) {
                        if (x < e) l = t.text.substr(a, ++o); else {
                            if (l.length <= 1) break;
                            l = t.text.substr(a, --o);
                        }
                        x = this.ctx.measureText(l).width;
                    }
                    if (a += l.length, n === r - 1 && a < t.text.length) {
                        for (;this.ctx.measureText(l + "...").width > e && !(l.length <= 1); ) l = l.substring(0, l.length - 1);
                        l += "...", x = this.ctx.measureText(l).width;
                    }
                    this.ctx.setTextAlign(t.css.align || "left");
                    var d = void 0;
                    switch (t.css.align) {
                      case "center":
                        d = 0;
                        break;

                      case "right":
                        d = e / 2;
                        break;

                      default:
                        d = -e / 2;
                    }
                    var u = -i / 2 + (0 === n ? t.css.fontSize.toPx() : t.css.fontSize.toPx() + n * h);
                    "stroke" === t.css.textStyle ? this.ctx.strokeText(l, d, u, x) : this.ctx.fillText(l, d, u, x);
                    var f = t.css.fontSize.toPx();
                    t.css.textDecoration && (this.ctx.beginPath(), /\bunderline\b/.test(t.css.textDecoration) && (this.ctx.moveTo(d, u), 
                    this.ctx.lineTo(d + x, u)), /\boverline\b/.test(t.css.textDecoration) && (this.ctx.moveTo(d, u - f), 
                    this.ctx.lineTo(d + x, u - f)), /\bline-through\b/.test(t.css.textDecoration) && (this.ctx.moveTo(d, u - f / 3), 
                    this.ctx.lineTo(d + x, u - f / 3)), this.ctx.closePath(), this.ctx.setStrokeStyle(t.css.color), 
                    this.ctx.stroke());
                }
                this.ctx.restore(), this._doBorder(t, e, i);
            }
        }
    }, {
        key: "_drawAbsRect",
        value: function(t) {
            this.ctx.save();
            var s = this._preProcess(t), e = s.width, s = s.height;
            this.ctx.setFillStyle(t.css.color), this.ctx.fillRect(-e / 2, -s / 2, e, s), this.ctx.restore(), 
            this._doBorder(t, e, s);
        }
    }, {
        key: "_getAngle",
        value: function(t) {
            return Number(t) * Math.PI / 180;
        }
    } ]), r;
}();

exports.default = r;