function t(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

function e() {
    String.prototype.toPx = function(t) {
        var e = (t ? /^-?[0-9]+([.]{1}[0-9]+){0,1}(rpx|px)$/g : /^[0-9]+([.]{1}[0-9]+){0,1}(rpx|px)$/g).exec(this);
        if (!this || !e) return console.error("The size: " + this + " is illegal"), 0;
        var n = e[2], t = parseFloat(this), e = 0;
        return "rpx" === n ? e = Math.round(t * o) : "px" === n && (e = t), e;
    };
}

var r = t(require("./lib/pen")), n = t(require("./lib/downloader")), i = require("./lib/util"), a = new n.default();

Component({
    canvasWidthInPx: 0,
    canvasHeightInPx: 0,
    paintCount: 0,
    properties: {
        customStyle: {
            type: String
        },
        palette: {
            type: Object,
            observer: function(t, e) {
                this.isNeedRefresh(t, e) && (this.paintCount = 0, this.startPaint());
            }
        },
        dirty: {
            type: Boolean,
            value: !1
        }
    },
    data: {
        picURL: "",
        showCanvas: !0,
        painterStyle: ""
    },
    attached: function() {
        e();
    },
    methods: {
        isEmpty: function(t) {
            for (var e in t) return !1;
            return !0;
        },
        isNeedRefresh: function(t, e) {
            return !(!t || this.isEmpty(t) || this.data.dirty && i.equal(t, e));
        },
        startPaint: function() {
            var a = this;
            if (!this.isEmpty(this.properties.palette)) {
                var e = this;
                if (!getApp().systemInfo || !getApp().systemInfo.screenWidth) try {
                    getApp().systemInfo = wx.getSystemInfoSync();
                } catch (a) {
                    var t = "Painter get system info failed, " + JSON.stringify(a);
                    return e.triggerEvent("imgErr", {
                        error: t
                    }), void console.error(t);
                }
                o = getApp().systemInfo.screenWidth / 750, this.downloadImages().then(function(t) {
                    var e, n = t.width, i = t.height;
                    a.canvasWidthInPx = n.toPx(), a.canvasHeightInPx = i.toPx(), n && i ? (a.setData({
                        painterStyle: "width:" + n + ";height:" + i + ";"
                    }), e = wx.createCanvasContext("k-canvas", a), new r.default(e, t).paint(function() {
                        a.saveImgToLocal();
                    })) : console.error("You should set width and height correctly for painter, width: " + n + ", height: " + i);
                }).catch(function(t) {
                    e.triggerEvent("imgErr", {
                        error: t
                    });
                });
            }
        },
        downloadImages: function() {
            var f = this;
            return new Promise(function(n, r) {
                var i = 0, o = 0, s = JSON.parse(JSON.stringify(f.properties.palette));
                if (s.background && (i++, a.download(s.background).then(function(t) {
                    s.background = t, i === ++o && n(s);
                }, function() {
                    i === ++o && n(s);
                })), s.views) {
                    var t = !0, e = !1, c = void 0;
                    try {
                        for (var u, h = s.views[Symbol.iterator](); !(t = (u = h.next()).done); t = !0) !function() {
                            var e = u.value;
                            e && "image" === e.type && e.url && (i++, a.download(e.url).then(function(t) {
                                e.url = t, wx.getImageInfo({
                                    src: e.url,
                                    success: function(t) {
                                        e.sWidth = t.width, e.sHeight = t.height;
                                    },
                                    fail: function(t) {
                                        t = "getImageInfo failed, " + JSON.stringify(t || {}) + "; imageUrl:" + e.url;
                                        console.error(t), r(t);
                                    },
                                    complete: function() {
                                        i === ++o && n(s);
                                    }
                                });
                            }, function() {
                                i === ++o && n(s);
                            }));
                        }();
                    } catch (t) {
                        e = !0, c = t;
                    } finally {
                        try {
                            !t && h.return && h.return();
                        } finally {
                            if (e) throw c;
                        }
                    }
                }
                0 === i && n(s);
            });
        },
        saveImgToLocal: function() {
            var t = this, e = this;
            setTimeout(function() {
                wx.canvasToTempFilePath({
                    canvasId: "k-canvas",
                    success: function(t) {
                        e.getImageInfo(t.tempFilePath);
                    },
                    fail: function(t) {
                        console.error("canvasToTempFilePath failed, " + JSON.stringify(t)), e.triggerEvent("imgErr", {
                            error: t
                        });
                    }
                }, t);
            }, 300);
        },
        getImageInfo: function(n) {
            var r = this;
            wx.getImageInfo({
                src: n,
                success: function(t) {
                    if (5 < r.paintCount) {
                        var e = "The result is always fault, even we tried 5 times";
                        return console.error(e), void r.triggerEvent("imgErr", {
                            error: e
                        });
                    }
                    Math.abs((t.width * r.canvasHeightInPx - r.canvasWidthInPx * t.height) / (t.height * r.canvasHeightInPx)) < .01 ? r.triggerEvent("imgOK", {
                        path: n
                    }) : r.startPaint(), r.paintCount++;
                },
                fail: function(t) {
                    console.error("getImageInfo failed, " + JSON.stringify(t)), r.triggerEvent("imgErr", {
                        error: t
                    });
                }
            });
        }
    }
});

var o = .5;