var _tools = require("../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var methods = require("../../toolkit/toolkit.js"), app = getApp();

Page({
    data: {
        capsuleHeight: "",
        capsuleTop: "",
        headHei: "",
        ring_Load: !1,
        id: "",
        participateInfo: "",
        memberInfo: "",
        is_fabulous: !1,
        time: "",
        fabulousList: [],
        activity_banner: [],
        activity_Current: 0,
        config: "",
        Finished: !1,
        NoMore: "2",
        p: 1,
        DialogLogin: !1,
        DialogLoginAsyn: !1,
        is_auth: "",
        canIUseGetUserProfile: !1
    },
    onLoad: function(t) {
        var e = this;
        t.scene && (t.id = decodeURIComponent(t.scene)), wx.hideShareMenu({
            menus: [ "shareAppMessage", "shareTimeline" ]
        }), wx.getUserProfile && this.setData({
            canIUseGetUserProfile: !0
        });
        var i = wx.getMenuButtonBoundingClientRect();
        e.setData({
            capsuleHeight: i.height,
            capsuleTop: i.top,
            headHei: Number(i.height) + Number(i.top)
        }), this.setData({
            id: t.id
        }), e.details(t.id);
        e.fabulousList(t.id, 1);
    },
    details: function(t) {
        var i = this, t = {
            action: "details",
            contr: "interaction",
            token: wx.getStorageSync("token"),
            id: t
        };
        _tools2.default.request(t, function(t) {
            console.log(t);
            var e = methods.timeToDate(t.info.participate.updated);
            i.setData({
                participateInfo: t.info.participate,
                time: e,
                activity_banner: t.info.participate.images,
                memberInfo: t.info.member,
                is_fabulous: t.info.is_fabulous,
                config: t.info.config,
                is_auth: t.info.is_auth,
                my: t.info.my
            });
        });
    },
    fabulousList: function(t, e) {
        var i = this;
        i.data.Finished || (e = {
            action: "fabulousList",
            contr: "interaction",
            token: wx.getStorageSync("token"),
            id: t,
            p: e
        }, _tools2.default.request(e, function(t) {
            console.log(t), t.info.list.length < 42 && i.setData({
                Finished: !0,
                NoMore: "0"
            }), t = 41 < i.data.fabulousList.length ? i.data.list.concat(t.info.list) : t.info.list, 
            i.setData({
                fabulousList: t
            });
        }));
    },
    fabulous: function() {
        var t, e = this;
        this.data.is_auth ? (t = {
            action: "fabulous",
            contr: "interaction",
            token: wx.getStorageSync("token"),
            id: e.data.id
        }, _tools2.default.request(t, function(t) {
            methods.tipsBox("已点赞");
            e.fabulousList(e.data.id, 1), e.details(e.data.id);
        })) : this.go_login();
    },
    cancel: function() {
        var t, e = this;
        this.data.is_auth ? (t = {
            action: "cancel",
            contr: "interaction",
            token: wx.getStorageSync("token"),
            id: e.data.id
        }, _tools2.default.request(t, function(t) {
            methods.tipsBox("已取消");
            e.fabulousList(e.data.id, 1), e.details(e.data.id);
        })) : this.go_login();
    },
    more_fabulousList: function() {
        var t, e = this;
        e.data.Finished || (t = e.data.p + 1, e.setData({
            p: t,
            NoMore: "1"
        }), e.fabulousList(e.data.id, t));
    },
    go_like: function() {
        var t = this;
        t.data.is_fabulous ? t.cancel() : t.fabulous();
    },
    goback: function() {
        1 < getCurrentPages().length ? wx.navigateBack({
            delta: 1
        }) : wx.reLaunch({
            url: "/interaction/pages/index/index"
        });
    },
    activity_swiperChange: function(t) {
        this.setData({
            activity_Current: t.detail.current
        });
    },
    go_share: function() {
        this.data.is_auth ? wx.navigateTo({
            url: "../share/share?id=" + this.data.id
        }) : this.go_login();
    },
    onShow: function() {},
    getUserInfo: function(e) {
        var i = this;
        console.log(e), wx.login({
            success: function(t) {
                t.code && (t.code, e.detail.userInfo ? wx.getUserInfo({
                    success: function(t) {
                        i.setData({
                            DialogLoginAsyn: !0,
                            DialogLogin: !1
                        });
                        var e = t.encryptedData, t = t.iv, e = {
                            action: "register",
                            contr: "index",
                            token: wx.getStorageSync("token"),
                            iv: t,
                            encryptedData: e
                        };
                        _tools2.default.request(e, function(t) {
                            i.setData({
                                DialogLoginAsyn: !1,
                                DialogLogin: !1,
                                is_auth: !0
                            }), i.details(i.data.id);
                        });
                    }
                }) : methods.promptBox("授权失败", "none"));
            }
        });
    },
    getUserProfile: function(t) {
        var e = this;
        this.data.canIUseGetUserProfile && wx.getUserProfile({
            desc: "用于完善会员资料",
            success: function(t) {
                console.log(t.userInfo);
                t = {
                    action: "authorization",
                    contr: "index",
                    token: wx.getStorageSync("token"),
                    avatarUrl: t.userInfo.avatarUrl,
                    nickName: t.userInfo.nickName,
                    city: t.userInfo.city,
                    province: t.userInfo.province,
                    country: t.userInfo.country,
                    gender: t.userInfo.gender
                };
                _tools2.default.request(t, function(t) {
                    e.setData({
                        DialogLoginAsyn: !1,
                        DialogLogin: !1,
                        is_auth: !0
                    }), e.details(e.data.id);
                });
            }
        });
    },
    go_login: function() {
        this.setData({
            DialogLogin: !0
        });
    },
    hd_login: function() {
        this.setData({
            DialogLogin: !1
        });
    }
});