var _tools = require("../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var _urls = require("../../toolkit/url/urls.js"), methods = require("../../toolkit/toolkit.js"), _server = require("../../toolkit/url/server.js"), _urls2 = methods.interopRequireDefault(_urls), _server2 = methods.interopRequireDefault(_server), app = getApp(), themes = {
    smallBar: "smallBar"
};

Page({
    data: {
        capsuleHeight: "",
        capsuleTop: "",
        headHei: "",
        isScroll: !0,
        left: "0",
        right: "750",
        bottom: "0",
        mSelected: "0",
        lastIndex: 0,
        transition: "left 0.5s, right 0.2s",
        windowWidth: 375,
        domData: [],
        textDomData: [],
        items: [],
        newType_items: [],
        theme: "smallBar",
        is_Click: !1,
        TabCur: 0,
        ring_Load: !1,
        activity_id: "",
        activity_banner: [],
        activity_Current: 0,
        Finished: !1,
        NoMore: "2",
        p: 1,
        list: [],
        lftList: [],
        ritList: [],
        rank: [],
        is_auth: "",
        DialogLogin: !1,
        DialogLoginAsyn: !1,
        config: "",
        canIUseGetUserProfile: !1,
        TabbarId: "",
        TabbarIndex: 0,
        idClass: "idClassA",
        idView: ""
    },
    onLoad: function(t) {
        var a = this;
        wx.getUserProfile && this.setData({
            canIUseGetUserProfile: !0
        });
        var i = wx.getMenuButtonBoundingClientRect();
        a.setData({
            capsuleHeight: i.height,
            capsuleTop: i.top,
            headHei: Number(i.height) + Number(i.top)
        }), t.id ? (a.setData({
            activity_id: t.id
        }), a.is_activity(t.id)) : (a.setData({
            ring_Load: !0
        }), a.activity());
    },
    activity: function() {
        var e = this, t = {
            action: "activity",
            contr: "interaction",
            token: wx.getStorageSync("token")
        };
        _tools2.default.request(t, function(t) {
            console.log(t), e.setData({
                ring_Load: !1,
                items: t.info.list,
                is_auth: t.info.is_auth,
                config: t.info.config
            }), t.info.navigation_list && e.setData({
                navigation_list: t.info.navigation_list
            }), "" == e.data.activity_id && e.setData({
                activity_id: t.info.list[0].id,
                TabbarId: t.info.list[0].id,
                TabbarIndex: 0
            });
            var a = t.info.list;
            if ("" != e.data.activity_id) for (var i = 0; i < a.length; i++) (t = a[i]).id == e.data.activity_id && e.setData({
                idView: "id" + i,
                TabbarIndex: i
            });
            e.setData({
                activity_banner: a[e.data.TabbarIndex].head_picture
            });
            e.content(1), e.rank();
        });
    },
    content: function(t) {
        var s = this;
        s.data.Finished || (t = {
            action: "content",
            contr: "interaction",
            token: wx.getStorageSync("token"),
            id: s.data.activity_id,
            p: t
        }, _tools2.default.request(t, function(t) {
            if (console.log(t), t.info.content.length < 10 && s.setData({
                Finished: !0,
                NoMore: "0"
            }), 9 < s.data.list.length) {
                for (var a = s.data.list.concat(t.info.content), i = [], e = [], n = 0; n < a.length; n++) {
                    t = a[n];
                    ((n + 1) % 2 == 0 ? e : i).push(t);
                }
                s.setData({
                    lftList: i,
                    ritList: e,
                    list: a
                });
            } else {
                for (var a = t.info.content, i = [], e = [], o = 0; o < a.length; o++) {
                    t = a[o];
                    ((o + 1) % 2 == 0 ? e : i).push(t);
                }
                s.setData({
                    lftList: i,
                    ritList: e,
                    list: a
                });
            }
        }));
    },
    activity_swiperChange: function(t) {
        this.setData({
            activity_Current: t.detail.current
        });
    },
    rank: function(t) {
        var a = this, i = {
            action: "rank",
            contr: "interaction",
            token: wx.getStorageSync("token"),
            id: a.data.activity_id,
            p: 1
        };
        _tools2.default.request(i, function(t) {
            console.log(t), a.setData({
                rank: t.info.content
            });
        });
    },
    is_activity: function(a) {
        var i = this, t = {
            action: "is_activity",
            contr: "interaction",
            token: wx.getStorageSync("token"),
            id: a
        };
        _tools2.default.request(t, function(t) {
            console.log(t), 1 == t.info.is_activity ? i.setData({
                TabbarId: a,
                TabbarIndex: "x"
            }) : i.setData({
                activity_id: "",
                TabbarId: ""
            }), i.activity();
        });
    },
    getUserInfo: function(a) {
        var i = this;
        console.log(a), wx.login({
            success: function(t) {
                t.code && (t.code, a.detail.userInfo ? wx.getUserInfo({
                    success: function(t) {
                        i.setData({
                            DialogLoginAsyn: !0,
                            DialogLogin: !1
                        });
                        var a = t.encryptedData, t = t.iv, a = {
                            action: "register",
                            contr: "index",
                            token: wx.getStorageSync("token"),
                            iv: t,
                            encryptedData: a
                        };
                        _tools2.default.request(a, function(t) {
                            i.setData({
                                DialogLoginAsyn: !1,
                                is_auth: !0,
                                DialogLogin: !1
                            });
                        });
                    }
                }) : methods.promptBox("授权失败", "none"));
            }
        });
    },
    getUserProfile: function(t) {
        var a = this;
        this.data.canIUseGetUserProfile && wx.getUserProfile({
            desc: "用于完善会员资料",
            success: function(t) {
                console.log(t.userInfo);
                t = {
                    action: "authorization",
                    contr: "index",
                    token: wx.getStorageSync("token"),
                    avatarUrl: t.userInfo.avatarUrl,
                    nickName: t.userInfo.nickName,
                    city: t.userInfo.city,
                    province: t.userInfo.province,
                    country: t.userInfo.country,
                    gender: t.userInfo.gender
                };
                _tools2.default.request(t, function(t) {
                    a.setData({
                        DialogLoginAsyn: !1,
                        DialogLogin: !1,
                        is_auth: !0
                    });
                });
            }
        });
    },
    go_login: function() {
        this.setData({
            DialogLogin: !0
        });
    },
    hd_login: function() {
        this.setData({
            DialogLogin: !1
        });
    },
    ck_chooseBar: function(t) {
        console.log(t);
        var a = t.currentTarget.dataset.info, t = t.currentTarget.dataset.index;
        console.log(2222, t), this.setData({
            TabbarId: a.id,
            TabbarIndex: t,
            activity_id: a.id,
            activity_banner: this.data.items[t].head_picture
        });
        this.setData({
            Finished: !1,
            list: [],
            p: 1,
            NoMore: "2"
        }), this.content(1), this.rank();
    },
    onReady: function() {},
    onShow: function() {
        this.newType_activity();
    },
    newType_activity: function() {
        var a = this, t = {
            action: "activity",
            contr: "interaction",
            token: wx.getStorageSync("token")
        };
        _tools2.default.request(t, function(t) {
            console.log(t), a.setData({
                newType_items: t.info.list
            });
        });
    },
    onHide: function() {},
    onUnload: function() {},
    onPullDownRefresh: function() {
        this.setData({
            Finished: !1,
            list: [],
            p: 1,
            NoMore: "2"
        }), this.content(1);
    },
    onReachBottom: function() {
        var t;
        this.data.Finished || (t = this.data.p + 1, this.setData({
            p: t,
            NoMore: "1"
        }), this.content(t));
    },
    onShareAppMessage: function() {
        var t = this;
        return console.log("interaction/pages/index/index?id=" + t.data.items[t.data.TabbarIndex].id), 
        {
            title: t.data.items[t.data.TabbarIndex].name + "-" + t.data.config.interaction_title,
            imageUrl: t.data.items[t.data.TabbarIndex].share_img,
            path: "interaction/pages/index/index?id=" + t.data.items[t.data.TabbarIndex].id
        };
    },
    go_Detail: function(t) {
        t = t.currentTarget.dataset.id;
        wx.navigateTo({
            url: "../detail/detail?id=" + t
        });
    },
    go_rink: function() {
        0 < this.data.rank.length ? wx.navigateTo({
            url: "../rink/rink?id=" + this.data.activity_id + "&config=" + JSON.stringify(this.data.config)
        }) : methods.tipsBox("该活动没有人点赞哟！");
    },
    go_up: function() {
        this.data.is_auth ? wx.navigateTo({
            url: "../join/join?id=" + this.data.activity_id
        }) : this.go_login();
    },
    co_domData: function() {
        var a = this, t = wx.getSystemInfoSync();
        this.setData({
            windowWidth: t.screenWidth
        });
        t = this.createSelectorQuery();
        console.log(t), t.in(this).selectAll(".li-nav-item").fields({
            dataset: !0,
            rect: !0,
            size: !0
        }, function(t) {
            a.setData({
                domData: t
            }), a.data.theme != themes.smallBar && (a.barLeft(a.data.mSelected, a.data.domData), 
            a.barRight(a.data.mSelected, a.data.domData));
        }).exec(), t.in(this).selectAll(".li-nav-text").fields({
            dataset: !0,
            rect: !0,
            size: !0
        }, function(t) {
            a.setData({
                textDomData: t
            }), a.data.theme == themes.smallBar && (a.barLeft(a.data.mSelected, a.data.textDomData), 
            a.barRight(a.data.mSelected, a.data.textDomData));
        }).exec();
    },
    barLeft: function(t, a) {
        this.setData({
            left: a[t].left
        });
    },
    barRight: function(t, a) {
        this.setData({
            right: this.data.windowWidth - a[t].right
        });
    },
    tabSelect: function(t) {
        this.setData({
            is_Click: !0
        }), console.log(t);
        var a = t.currentTarget.dataset.index, i = t.currentTarget.dataset.id, e = this.data.lastIndex < a ? "left 0.5s, right 0.2s" : "left 0.2s, right 0.5s";
        this.setData({
            transition: e,
            lastIndex: a,
            mSelected: a,
            TabCur: t.currentTarget.dataset.index,
            activity_id: i,
            activity_banner: this.data.items[a].head_picture
        });
        this.setData({
            Finished: !1,
            list: [],
            p: 1,
            NoMore: "2"
        }), this.content(1), this.rank(), this.data.theme == themes.smallBar ? (this.barLeft(a, this.data.textDomData), 
        this.barRight(a, this.data.textDomData)) : (this.barLeft(a, this.data.domData), 
        this.barRight(a, this.data.domData));
    },
    loadImage: function(t) {
        console.log(1121), console.log(t);
        var a = t.detail.width, i = t.detail.height;
        1.19 <= parseFloat(i / a) && (a = parseInt(t.currentTarget.dataset.type), t = t.currentTarget.dataset.index, 
        1 == a ? (this.data.lftList[t].img_type = !0, this.setData({
            lftList: this.data.lftList
        })) : (this.data.ritList[t].img_type = !0, this.setData({
            ritList: this.data.ritList
        })));
    }
});