var _tools = require("../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var that, app = getApp();

function exchangeGoods(t) {
    t = {
        token: wx.getStorageSync("token"),
        id: t.data.id,
        message: t.data.message,
        shop_id: t.data.shop_id
    };
    _tools2.default.request(t, function(t) {
        2 == t.status ? wx.requestPayment({
            timeStamp: t.info.paydata.timeStamp,
            nonceStr: t.info.paydata.nonceStr,
            package: t.info.paydata.package,
            signType: t.info.paydata.signType,
            paySign: t.info.paydata.paySign,
            success: function(t) {
                wx.showToast({
                    title: "兑换成功"
                }), setTimeout(function() {
                    wx.reLaunch({
                        url: "/packageA/pages/order/order"
                    });
                }, 1500);
            },
            fail: function(t) {
                console.log(t);
            }
        }) : 3 == t.status ? wx.showModal({
            title: "提示",
            mask: !0,
            content: t.info,
            showCancel: !1
        }) : (wx.showToast({
            title: "兑换成功"
        }), setTimeout(function() {
            wx.reLaunch({
                url: "/packageA/pages/order/order"
            });
        }, 800));
    }, function() {}, function() {}, "", !0, "entry/wxapp/ExchangeGoods");
}

Page({
    data: {
        id: 0,
        request: 1,
        message: "",
        index: 0,
        shop_id: 0
    },
    onLoad: function(t) {
        this.data.id = t.id, that = this;
    },
    onShow: function() {
        var t = {
            action: "details",
            contr: "sign",
            token: wx.getStorageSync("token"),
            id: that.data.id
        };
        _tools2.default.request(t, function(t) {
            that.setData(t.info);
        });
    },
    gotoAddress: function() {
        wx.navigateTo({
            url: "/bh_vote/pages/address/address"
        });
    },
    bindPickerChange: function(t) {
        console.log(t), this.setData({
            index: t.detail.value
        }), that.data.shop_id = this.data.merchant[t.detail.value].id;
    },
    buy: function() {
        this.data.address || 1 != that.data.goods.type ? 3 == this.data.goods.type && this.data.shop_id < 1 ? wx.showToast({
            title: "请先选择提货站点",
            icon: "none"
        }) : wx.showModal({
            title: "提示",
            content: "确定要兑换该商品",
            success: function(t) {
                t.confirm ? exchangeGoods(that) : t.cancel && console.log("用户点击取消");
            }
        }) : this.gotoAddress();
    },
    buySsuccess: function() {
        wx.showToast({
            title: "兑换成功"
        }), setTimeout(function() {
            wx.reLaunch({
                url: "/bh_bargain/pages/order/order"
            });
        }, 1500);
    },
    gotobargain: function() {
        wx.navigateBack();
    },
    bindMessage: function(t) {
        this.data.message = t.detail.value;
    }
});