var _tools = require("../../../utils/tools.js"), _tools2 = _interopRequireDefault(_tools);

function _interopRequireDefault(t) {
    return t && t.__esModule ? t : {
        default: t
    };
}

var that, app = getApp();

Page({
    data: {
        setTimeself: "",
        time: 0
    },
    onLoad: function() {
        that = this;
    },
    onReady: function() {
        var t = {
            action: "participate",
            contr: "jizi",
            token: wx.getStorageSync("token")
        };
        _tools2.default.request(t, function(t) {
            that.setData(t.info), that.clearTime(), that.countdown();
        }), wx.setNavigationBarColor({
            frontColor: "#000000",
            backgroundColor: "#000000"
        });
    },
    gotoBargain: function(t) {
        t = t.currentTarget.dataset.id;
        wx.navigateTo({
            url: "/packageA/pages/jizi/jizi?id=" + t
        });
    },
    delOrder: function(t) {
        var e = t.currentTarget.dataset.id;
        wx.showModal({
            title: "提示",
            content: "确定要删除该砍价订单",
            cancelText: "再想想",
            success: function(t) {
                var a;
                t.confirm ? (a = {
                    action: "delOrder",
                    contr: "my",
                    token: wx.getStorageSync("token"),
                    id: e
                }, _tools2.default.request(a, function(t) {
                    wx.showToast({
                        title: "删除成功"
                    }), that.onReady();
                })) : t.cancel;
            }
        });
    },
    clearTime: function() {
        clearTimeout(that.data.setTimeself);
    },
    countdown: function() {
        if (null != this.data.participate && this.data.participate) {
            for (var t in this.data.time++, this.data.participate) {
                var a, e, i, o = parseInt(that.data.participate[t].surplus_time) - this.data.time;
                that.data.participate[t].d = "00", that.data.participate[t].h = "00", that.data.participate[t].m = "00", 
                that.data.participate[t].s = "00", 0 < o && that.data.participate[t].is_end && (a = parseInt(o / 60 / 60 / 24, 10), 
                (e = Math.floor(o / 60 / 60 % 24)) < 10 && (e = "0" + e), a < 10 && (a = "0" + a), 
                (i = Math.floor(o / 60 % 60)) < 10 && (i = "0" + i), (o = Math.floor(o % 60)) < 10 && (o = "0" + o), 
                that.data.participate[t].d = a, that.data.participate[t].h = e, that.data.participate[t].m = i, 
                that.data.participate[t].s = o);
            }
            that.data.setTimeself = setTimeout(function() {
                that.setData({
                    participate: that.data.participate
                }), that.countdown();
            }, 1e3);
        } else clearTimeout(that.data.setTimeself);
    },
    onUnload: function() {
        this.clearTime();
    }
});