var _showdown = require("./showdown.js"), _showdown2 = _interopRequireDefault(_showdown), _html2json = require("./html2json.js"), _html2json2 = _interopRequireDefault(_html2json);

function _interopRequireDefault(e) {
    return e && e.__esModule ? e : {
        default: e
    };
}

function _defineProperty(e, t, a) {
    return t in e ? Object.defineProperty(e, t, {
        value: a,
        enumerable: !0,
        configurable: !0,
        writable: !0
    }) : e[t] = a, e;
}

var realWindowWidth = 0, realWindowHeight = 0;

function wxParse() {
    var e = 0 < arguments.length && void 0 !== arguments[0] ? arguments[0] : "wxParseData", t = 1 < arguments.length && void 0 !== arguments[1] ? arguments[1] : "html", a = 2 < arguments.length && void 0 !== arguments[2] ? arguments[2] : '<div class="color:red;">数据不能为空</div>', i = arguments[3], r = arguments[4], o = i, i = {};
    "html" == t ? (i = _html2json2.default.html2json(a, e), console.log(JSON.stringify(i, " ", " "))) : "md" != t && "markdown" != t || (a = new _showdown2.default.Converter().makeHtml(a), 
    i = _html2json2.default.html2json(a, e), console.log(JSON.stringify(i, " ", " "))), 
    i.view = {}, void (i.view.imagePadding = 0) !== r && (i.view.imagePadding = r);
    r = {};
    r[e] = i, o.setData(r), o.wxParseImgLoad = wxParseImgLoad, o.wxParseImgTap = wxParseImgTap;
}

function wxParseImgTap(e) {
    var t = e.target.dataset.src, e = e.target.dataset.from;
    void 0 !== e && 0 < e.length && wx.previewImage({
        current: t,
        urls: this.data[e].imageUrls
    });
}

function wxParseImgLoad(e) {
    var t = e.target.dataset.from, a = e.target.dataset.idx;
    void 0 !== t && 0 < t.length && calMoreImageInfo(e, a, this, t);
}

function calMoreImageInfo(e, t, a, i) {
    var r = a.data[i];
    if (r && 0 != r.images.length) {
        var r = r.images, e = wxAutoImageCal(e.detail.width, e.detail.height, a, i), o = r[t].index, n = "" + i, d = !0, s = !1, l = void 0;
        try {
            for (var m, g = o.split(".")[Symbol.iterator](); !(d = (m = g.next()).done); d = !0) n += ".nodes[" + m.value + "]";
        } catch (e) {
            s = !0, l = e;
        } finally {
            try {
                !d && g.return && g.return();
            } finally {
                if (s) throw l;
            }
        }
        t = n + ".width", i = n + ".height";
        a.setData((_defineProperty(a = {}, t, e.imageWidth), _defineProperty(a, i, e.imageheight), 
        a));
    }
}

function wxAutoImageCal(e, t, a, i) {
    var r, o = 0, n = {}, i = a.data[i].view.imagePadding;
    return (o = realWindowWidth - 2 * i) < e ? (r = o * t / e, n.imageWidth = o, n.imageheight = r) : (n.imageWidth = e, 
    n.imageheight = t), n;
}

function wxParseTemArray(e, t, a, i) {
    for (var r = [], o = i.data, n = null, d = 0; d < a; d++) {
        var s = o[t + d].nodes;
        r.push(s);
    }
    e = e || "wxParseTemArray", (n = JSON.parse('{"' + e + '":""}'))[e] = r, i.setData(n);
}

function emojisInit() {
    var e = 0 < arguments.length && void 0 !== arguments[0] ? arguments[0] : "", t = 1 < arguments.length && void 0 !== arguments[1] ? arguments[1] : "/wxParse/emojis/", a = arguments[2];
    _html2json2.default.emojisInit(e, t, a);
}

wx.getSystemInfo({
    success: function(e) {
        realWindowWidth = e.windowWidth, realWindowHeight = e.windowHeight;
    }
}), module.exports = {
    wxParse: wxParse,
    wxParseTemArray: wxParseTemArray,
    emojisInit: emojisInit
};